  '**************************************************************************
  '** Program Name: RJCDDupL - CD-ROM Dupe Kill Listing Program            **
  '**       Author: R.J. (Bob) Ross                                        **
  '** Date Started: October 28th, 1994                                     **
  '**      Version: .01 Beta - completed November 15th,1994                **
  '**               1.00 - completed April 14th, 1995                      **
  '**               Last compiled - April 15th, 1995                       **
  '**                                                                      **
  '**      Purpose: To scan a CD-ROM and Hard drive disk(s) for files.bbs  **
  '**               files and compile a listing of files that are          **
  '**               duplicated on the Hard drive(s) suitable to be used    **
  '**               with program RJKILL.                                   **
  '**                                                                      **
  '**     Language: Microsoft QuickBASIC 4.5                               **
  '**    Libraries: Crescent Software Inc - QuickPak Professional          **
  '**************************************************************************
  '
    DEFINT A-Z
    DECLARE SUB CleanUp ()
    DECLARE FUNCTION CurrentDate$ ()
    DECLARE FUNCTION DCount (DSpec$)
    DECLARE FUNCTION DiskRoom& (Drive$)
    DECLARE SUB Display ()
    DECLARE FUNCTION ErrorMsg$ (Num%)
    DECLARE FUNCTION Exist% (FileN$)
    DECLARE FUNCTION FCount (FSpec$)
    DECLARE FUNCTION FindLast% (BYVAL Address, Size)
    DECLARE SUB FileInfo (FSpec$, SEG ArrayEl)
    DECLARE SUB Help ()
    DECLARE FUNCTION GetDir$ (Drive$)
    DECLARE FUNCTION GetDrive% ()
    DECLARE SUB DiskInfo (Drive$, BPS, SC, AC, TC)
    DECLARE FUNCTION Pad$ (X)
    DECLARE SUB ParseCmdLine (Switch$, Work$, ReturnCode%)
    DECLARE FUNCTION QInstrB% (StartPos%, Source$, Search$)
    DECLARE SUB ReadDirT (Spec$, BYVAL Segment, BYVAL Address)
    DECLARE SUB ReadFileT (Spec$, BYVAL Segment, BYVAL Address)
    DECLARE SUB SetDrive (Drive$)
    DECLARE FUNCTION QPTrim$ (Var$)

    CONST Version = "RJCDDupL - V1.00"
    CONST False = 0
    CONST True = NOT False
    ConfigFile% = False
    OutPutFile% = False
    Dupes% = False
    DelTemp% = True
    Dt$ = CurrentDate$
    MasterLst$ = "$$Mast.lst"
    Count& = 0


  '  GOTO ProcMaster

    CmdLine$ = UCASE$(COMMAND$)

    IF CmdLine$ = "" THEN
        CALL Help
        END
    END IF

  'Error trap
   ON ERROR GOTO Bomb

    OrigDrive = GetDrive%
    OrigDir$ = GetDir$(Drive$)

    CLS
    PRINT Dt$; TIME$; " RJUT Begin "; Version

  'Look for a Config file
    CALL ParseCmdLine("-C", ConfigFile$, ConfigFile%)
    IF NOT ConfigFile% THEN
        PRINT Dt$; TIME$; " RJUT You need to use the -CDrive:\path\config.cfg switch!"
        PRINT Dt$; TIME$; " RJUT End "; Version
        END
    END IF
  'Output kill listing
    CALL ParseCmdLine("-O", OutPutFile$, OutPutFile%)
    IF NOT OutPutFile% THEN
        PRINT Dt$; TIME$; " RJUT You need to use the -ODrive:\path\killist.txt switch!"
        PRINT Dt$; TIME$; " RJUT End "; Version
        END
    END IF

    IF INSTR(CmdLine$, "-KTF") THEN
        DelTemp% = False
    END IF

   'File Handles
    CfgF% = 1
    Hd% = 2
    HDF% = 3
    CD% = 4
    FBBS% = 5

    IF Exist%(ConfigFile$) THEN
        OPEN MasterLst$ FOR OUTPUT AS #HDF%
        OPEN ConfigFile$ FOR INPUT AS #CfgF%
        PRINT Dt$; TIME$; " RJUT Opening "; ConfigFile$
        DO UNTIL EOF(CfgF%)
            DO UNTIL EOF(CfgF%)
                LINE INPUT #CfgF%, Record$
                Record$ = LTRIM$(Record$)
                IF LEFT$(Record$, 1) = ";" THEN
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 13)) = "CDDRIVELETTER" THEN
                    Drive$ = QPTrim$(MID$(Record$, 14))
                    Drive$ = LEFT$(Drive$, 1)
                    CDDrive$ = Drive$
                    EXIT DO
                END IF

                IF UCASE$(LEFT$(Record$, 12)) = "AREAFILESBBS" THEN
                    FilesBBS$ = QPTrim$(MID$(Record$, 13))
                    IF Exist%(FilesBBS$) THEN
                        OPEN FilesBBS$ FOR INPUT AS #Hd%
                        PRINT Dt$; TIME$; " RJUT Processing "; FilesBBS$
                        Posn% = QInstrB%(-1, FilesBBS$, "\")
                        Path$ = LEFT$(FilesBBS$, Posn%)
                        DO UNTIL EOF(Hd%)
                            LINE INPUT #Hd%, Record$
                            P% = INSTR(Record$, ".")
                            IF P% THEN
                                IF P% < 10 AND LEFT$(Record$, 1) <> " " THEN
                                    P% = INSTR(Record$, " ")
                                    IF P% THEN
                                        FileName$ = LEFT$(Record$, P% - 1)
                                        PRINT #HDF, FileName$; ","; Path$
                                        F% = LEN(FileName$)
                                        Pa% = LEN(Path$)
                                        LineLength% = F% + Pa%
                                        IF LineLength% >= LongestLine% THEN
                                            LongestLine% = LineLength%
                                            LineLength% = LongestLine%
                                        END IF
                                        Count& = Count& + 1
                                    END IF
                                END IF
                            END IF
                        LOOP
                        CLOSE Hd%
                    END IF
                END IF
            LOOP
        LOOP
    END IF
    CLOSE

    OPEN MasterLst$ FOR APPEND AS #CD%

  'Find all directory names
    Search$ = "*.*"

    SetDrive Drive$
    Spec$ = "Files.bbs"

    Original$ = GetDir$("")     'save current directory
    Drive = GetDrive%           'and the current drive
    IF LEN(Drive$) THEN
        SetDrive Drive$
    END IF

    CHDIR "\"   'start searching in the root
    TotalCount = 0              'total number of files found
    Display     'display all matching files
    CleanUp     'restore original path & drive
    CLOSE

ProcMaster:
    MasterLst$ = "$$mast.Lst"
    TempFile$ = "$$Temp."
    MergeFile$ = "$$Merg."

    PRINT Dt$; TIME$; " RJUT Number of Lines in "; MasterLst$; Count&

  'Find out how many temp files to make
    NumberOfPasses% = Count& \ 1000
    Remainder% = Count& MOD 1000
    IF Remainder% THEN
        NumberOfPasses% = NumberOfPasses% + 1
    END IF

  'Calculate the first merge
    NumberOfMerges% = NumberOfPasses% \ 2
    Odd% = NumberOfPasses% MOD 2

    CLOSE 1
    OPEN MasterLst$ FOR INPUT AS #1

    FileSize& = LOF(1)
    PRINT Dt$; TIME$; " RJUT Size of "; MasterLst$; " ="; FileSize&

  'Make sure there is enough disk space to work with
    Drive$ = ""
    IF (FileSize& * 2) + 2000 >= DiskRoom&(Drive$) THEN
        PRINT Dt$; TIME$; " RJUT Insufficient disk space to perform sort."
        PRINT Dt$; TIME$; " RJUT End "; Version
        CLOSE
        KILL MasterLst$
    END IF

    Last% = 1000
    REDIM FlName$(1 TO 1000)

    IF NumberOfPasses% = 1 THEN
        GOSUB FillFlName
        GOSUB LastFullArray
        GOSUB Sort
        CLOSE 1
        OPEN MasterLst$ FOR OUTPUT AS #1
        FOR X% = 1 TO Last%
            PRINT #1, FlName$(X%)
        NEXT
        CLOSE 1
        GOSUB EmptyIt
        PRINT Dt$; TIME$; " RJUT Finished Sort of "; MasterLst$; " String Memory ="; FRE("X")
        GOSUB MakeDupeList
        IF DelTemp% THEN
            KILL MasterLst$
            ELSE
            PRINT Dt$; TIME$; " RJUT File: "; MasterLst$; " kept on disk."
        END IF
        IF Dupes% THEN
            PRINT Dt$; TIME$; " RJUT Finished "; OutPutFile$
            PRINT Dt$; TIME$; " RJUT End "; Version
        ELSE
            PRINT Dt$; TIME$; " RJUT No Dupes Found!"
            PRINT Dt$; TIME$; " RJUT End "; Version
            KILL OutPutFile$
        END IF
        END
    END IF

    PRINT Dt$; TIME$; " RJUT Passes :"; NumberOfPasses%; "String Memory ="; FRE("X")
    FOR Temp% = 1 TO NumberOfPasses%
        OutFile$ = TempFile$ + LTRIM$(STR$(Temp%))
        GOSUB Initialize
        GOSUB FillFlName
        GOSUB LastFullArray
        GOSUB Sort
        OPEN OutFile$ FOR OUTPUT AS #2
        FOR X% = 1 TO Last%
            PRINT #2, FlName$(X%)
        NEXT
        CLOSE 2
    NEXT
    CLOSE 1
    GOSUB EmptyIt

    IF NumberOfPasses% = 2 THEN
        File1$ = TempFile$ + "1"
        File2$ = TempFile$ + "2"
        OutFile$ = MergeFile$ + "1"
        PRINT Dt$; TIME$; " RJUT Merging...."
        GOSUB MergeFiles
        KILL File1$: KILL File2$
        KILL MasterLst$
        NAME OutFile$ AS MasterLst$
        GOSUB EmptyIt
        PRINT Dt$; TIME$; " RJUT Finished Sort of "; MasterLst$; " String Memory ="; FRE("X")
        GOSUB MakeDupeList
        IF DelTemp% THEN
            KILL MasterLst$
            ELSE
            PRINT Dt$; TIME$; " RJUT File: "; MasterLst$; " kept on disk."
        END IF
        IF Dupes% THEN
            PRINT Dt$; TIME$; " RJUT Finished "; OutPutFile$
            PRINT Dt$; TIME$; " RJUT End "; Version
        ELSE
            PRINT Dt$; TIME$; " RJUT No Dupes Found!"
            PRINT Dt$; TIME$; " RJUT End "; Version
            KILL OutPutFile$
        END IF
        END
    END IF

Merge:
    PRINT Dt$; TIME$; " RJUT Merging:"; NumberOfMerges%
    a% = 1
    FOR X% = 1 TO NumberOfMerges%
        OutFile$ = MergeFile$ + LTRIM$(STR$(X%))
        File1$ = TempFile$ + LTRIM$(STR$(a%))
        File2$ = TempFile$ + LTRIM$(STR$(a% + 1))
        GOSUB MergeFiles
        KILL File1$
        KILL File2$
        a% = a% + 2
        NAME OutFile$ AS TempFile$ + LTRIM$(STR$(X%))
    NEXT

    IF Odd% THEN
        NAME TempFile$ + LTRIM$(STR$(NumberOfPasses%)) AS TempFile$ + LTRIM$(STR$(NumberOfMerges% + 1))
        PRINT Dt$; TIME$; " RJUT Merging:"; NumberOfMerges% + 1
    END IF

    NumberOfPasses% = NumberOfMerges% + Odd%
    Odd% = 0
    NumberOfMerges% = NumberOfPasses% \ 2
    Odd% = NumberOfPasses% MOD 2
    IF NumberOfMerges% THEN
        GOTO Merge
    END IF
    KILL MasterLst$
    NAME TempFile$ + "1" AS MasterLst$
    PRINT Dt$; TIME$; " RJUT Finished Sort of "; MasterLst$; " String Memory ="; FRE("X")
    GOSUB MakeDupeList
    IF DelTemp% THEN
        KILL MasterLst$
        ELSE
        PRINT Dt$; TIME$; " RJUT File: "; MasterLst$; " kept on disk."
    END IF
    IF Dupes% THEN
        PRINT Dt$; TIME$; " RJUT Finished "; OutPutFile$
        PRINT Dt$; TIME$; " RJUT End "; Version
        PRINT
    ELSE
        PRINT Dt$; TIME$; " RJUT No Dupes Found!"
        PRINT Dt$; TIME$; " RJUT End "; Version
        PRINT
        KILL OutPutFile$
    END IF
    END

GetFilenames:
    DO UNTIL EOF(BBS%)
        LINE INPUT #BBS%, Record$
        P% = INSTR(Record$, ".")
        IF P% THEN
            IF P% < 10 AND LEFT$(Record$, 1) <> " " THEN
                P% = INSTR(Record$, " ")
                IF P% THEN
                    Ctr% = Ctr% + 1
                    FileName$ = LEFT$(Record$, P% - 1)
                    PRINT #ML%, FileName$; ","; Path$
                    F% = LEN(FileName$)
                    Pa% = LEN(Path$)
                    LineLength% = F% + Pa%
                    IF LineLength% >= LongestLine% THEN
                        LongestLine% = LineLength%
                        LineLength% = LongestLine%
                    END IF
                    Count& = Count& + 1
                END IF
            END IF
        END IF
    LOOP
    CLOSE BBS%
    RETURN

EmptyIt:
    ERASE FlName$
    RETURN

Initialize:
    REDIM FlName$(1 TO 1000)
    RETURN

FillFlName:
    FOR X% = 1 TO Last%
        IF EOF(1) THEN EXIT FOR
        LINE INPUT #1, Record$
        FlName$(X%) = Record$
    NEXT
    RETURN

Sort:
    CALL SortStr(BYVAL VARPTR(FlName$(1)), Last%, 0)
    RETURN

LastFullArray:
    Last% = FindLast%(BYVAL VARPTR(FlName$(1000)), 1000)
    RETURN

MergeFiles:
  ' code by Matt Hart
    OPEN File1$ FOR INPUT AS 1
    OPEN File2$ FOR INPUT AS 2
    OPEN OutFile$ FOR OUTPUT AS 3
    DO
        IF LEN(S1$) = 0 AND NOT EOF(1) THEN LINE INPUT #1, S1$
        IF LEN(S2$) = 0 AND NOT EOF(2) THEN LINE INPUT #2, S2$
        IF LEN(S1$) > 0 AND LEN(S2$) > 0 THEN
            IF S1$ < S2$ THEN
                PRINT #3, S1$: S1$ = ""
            ELSE
                PRINT #3, S2$: S2$ = ""
            END IF
        ELSEIF LEN(S1$) THEN
            PRINT #3, S1$: S1$ = ""
        ELSEIF LEN(S2$) THEN
            PRINT #3, S2$: S2$ = ""
        ELSEIF EOF(1) AND EOF(2) THEN
            EXIT DO
        END IF
    LOOP
    CLOSE 1, 2, 3
    RETURN

MakeDupeList:
    OPEN MasterLst$ FOR INPUT AS #1

    OPEN OutPutFile$ FOR OUTPUT AS #2

    PRINT Dt$; TIME$; " RJUT Making: "; OutPutFile$
    DO UNTIL EOF(1)
        INPUT #1, Var2$, Seq2$
        P% = INSTR(Var2$, ".")
        IF LEFT$(Var2$, P%) = LEFT$(Var1$, P%) THEN
            IF LEN(Var1$) THEN
                Path$ = Seq1$
                FileName$ = Var1$
                IF LEFT$(Seq1$, 1) <> CDDrive$ THEN
                    GOSUB GetDescription
                    PRINT #2, RTRIM$(Seq1$); Var1$;
                    PRINT #2, TAB(LongestLine% + 1); LTRIM$(Description$)
                    PRINT Dt$; TIME$; " RJUT Dupe "; RTRIM$(Seq1$); Var1$
                    Dupes% = True
                END IF
            END IF
            IF LEN(Var2$) THEN
                Path$ = Seq2$
                FileName$ = Var2$
                IF LEFT$(Seq2$, 1) <> CDDrive$ THEN
                    GOSUB GetDescription
                    PRINT #2, RTRIM$(Seq2$); RTRIM$(Var2$);
                    PRINT #2, TAB(LongestLine% + 1); LTRIM$(Description$)
                    PRINT Dt$; TIME$; " RJUT Dupe "; RTRIM$(Seq2$); Var2$
                END IF
            END IF
            Var1$ = ""
            Seq1$ = ""
            Var3$ = Var2$
            Seq3$ = Seq2$
        ELSE
            Var1$ = Var2$
            Seq1$ = Seq2$
            IF LEFT$(Var1$, P%) = LEFT$(Var3$, P%) THEN
                Path$ = Seq1$
                FileName$ = Var1$
                IF LEFT$(Seq1$, 1) <> CDDrive$ THEN
                    GOSUB GetDescription
                    PRINT #2, RTRIM$(Seq1$); Var1$;
                    PRINT #2, TAB(LongestLine% + 1); LTRIM$(Description$)
                    PRINT Dt$; TIME$; " RJUT Dupe "; RTRIM$(Seq1$); Var1$
                    Dupes% = True
                    Var1$ = "": Seq1$ = ""
                END IF
            END IF
        END IF
    LOOP
    CLOSE
    RETURN

GetDescription:
    IF Exist%(Path$ + "Files.bbs") THEN
        OPEN Path$ + "Files.bbs" FOR INPUT AS #3
        DO UNTIL EOF(3)
            LINE INPUT #3, Record$
            IF LEFT$(Record$, LEN(FileName$)) = FileName$ THEN
                P% = INSTR(Record$, " ")
                IF P% THEN
                    Description$ = MID$(Record$, P%)
                    EXIT DO
                END IF
            END IF
        LOOP
        CLOSE 3
    ELSE
        Description$ = Path$ + "Files.bbs not found!"
    END IF
    RETURN

Bomb:
    BEEP
    PRINT ErrorMsg$(ERR)
    END

    SUB CleanUp STATIC
        SHARED OrigDir$, OrigDrive

        SetDrive CHR$(OrigDrive)
        CHDIR OrigDir$

    END SUB

    FUNCTION CurrentDate$ STATIC
        Dt$ = DATE$
        Mnth$ = LEFT$(Dt$, 2)
        SELECT CASE Mnth$
        CASE IS = "01"
            Month$ = "Jan"
        CASE IS = "02"
            Month$ = "Feb"
        CASE IS = "03"
            Month$ = "Mar"
        CASE IS = "04"
            Month$ = "Apr"
        CASE IS = "05"
            Month$ = "May"
        CASE IS = "06"
            Month$ = "Jun"
        CASE IS = "07"
            Month$ = "Jul"
        CASE IS = "08"
            Month$ = "Aug"
        CASE IS = "09"
            Month$ = "Sep"
        CASE IS = "10"
            Month$ = "Oct"
        CASE IS = "11"
            Month$ = "Nov"
        CASE IS = "12"
            Month$ = "Dec"
        END SELECT
        CurrentDate$ = " " + MID$(Dt$, 4, 2) + " " + Month$ + " "

    END FUNCTION

    SUB Display

        SHARED Drive, Drive$, FilesBBS$, Spec$, Search$, CD%, FBBS%, TotalCount, Count&, Dt$, LineLength%, LongestLine%
        DisplayFile% = 0

        IF T > 45 THEN          '9 levels is enough, agreed?
            PRINT "Too many levels"
            EXIT SUB
        END IF

        CurntDir$ = SPACE$(64)  'make room for directory name
        CurntDir$ = GetDir$("") 'get directory, current drive
        CurntDir$ = RTRIM$(CurntDir$)           'strip trailing blanks

        FCnt = FCount(Spec$)    'count matching files
      '  0 means count normal files
        TotalCount = TotalCount + FCnt          'add to the accumulator
        DIM FArray(FCnt)  AS STRING * 12        'dimension array accordingly
        ReadFileT Spec$, VARSEG(FArray$(0)), VARPTR(FArray$(0)) 'read the names
      '  0 means read normal files

        FOR X = 0 TO FCnt - 1   'for each file
            IF LEN(Drive$) THEN 'print the drive being used
              ' PRINT UCASE$(Drive$);           '  if appropriate
            ELSE                '  else print original drive
              ' PRINT CHR$(Drive);
            END IF
        '   PRINT ":"; CurntDir$; "\";          'print current directory
        '   PRINT RTRIM$(FArray$(X));
        '   PRINT
            OPEN CHR$(Drive) + ":" + CurntDir$ + "\" + RTRIM$(FArray$(X)) FOR INPUT AS #FBBS%
            PRINT Dt$; TIME$; " RJUT Processing "; CHR$(Drive); ":"; CurntDir$; "\"
            DO UNTIL EOF(FBBS%)
                LINE INPUT #FBBS%, Record$
                P% = INSTR(Record$, ".")
                IF P% THEN
                    IF P% < 10 AND LEFT$(Record$, 1) <> " " THEN
                        P% = INSTR(Record$, " ")
                        IF P% THEN
                            FileName$ = LEFT$(Record$, P% - 1)
                          ' PRINT FileName$
                          '  PRINT #CD%, FileName$
                             Path$ = CHR$(Drive) + ":" + CurntDir$ + "\"
                             PRINT #CD%, FileName$; ","; Path$
                           ' PRINT #CD%, FileName$; ","; CHR$(Drive) + ":" + CurntDir$ + "\"
                             F% = LEN(FileName$)
                             Pa% = LEN(Path$)
                             LineLength% = F% + Pa%
                             IF LineLength% >= LongestLine% THEN
                                 LongestLine% = LineLength%
                                 LineLength% = LongestLine%
                             END IF
                             Count& = Count& + 1
                        END IF
                    END IF
                END IF
            LOOP
            CLOSE FBBS%
          'See if a key was pressed
           X$ = INKEY$
          'Pause on any keypress or abort on Esc
            IF X$ <> "" THEN
                IF X$ = CHR$(27) THEN
                    CleanUp
                    CLOSE (1)
                    CLOSE (2)
                    END
                ELSE
                    WHILE INKEY$ = "": WEND
                    END IF
                END IF
            NEXT

          'Count dirs
            DCnt = DCount(Search$)

            IF DCnt THEN

                DIM DArray(DCnt) AS STRING * 12 'dimension array for dir names
                ReadDirT Search$, VARSEG(DArray$(0)), VARPTR(DArray$(0))

              'get all dirs under this one
                IF CurntDir$ = "\" THEN         'if we're in the root, use a
                    Prefix$ = ""                'blank, otherwise use the
                ELSE            'current directory
                    Prefix$ = CurntDir$
                END IF

                FOR X = 0 TO DCnt - 1           'for each directory,
                    CHDIR Prefix$ + "\" + DArray$(X)            '  change to it
                    Display
                NEXT

            END IF

        END SUB

        SUB Help
            CLS
            Title$ = "RJ's CD-ROM Dupe File Kill Listing Program - " + Version
            Title2$ = "by R.J. (Bob) Ross"
            Title3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
            PRINT TAB(40 - LEN(Title$) / 2); Title$
            PRINT TAB(40 - LEN(Title2$) / 2); Title2$
            PRINT TAB(40 - LEN(Title3$) / 2); Title3$
            PRINT STRING$(80, 196)
            PRINT "Purpose: To scan a CD-ROM disk for files.bbs files and those areas on a hard"
            PRINT "         drive described in the AreaFilesBBS area of a configuration file and"
            PRINT "         make a listing of duplicate files that reside on the hard drives(s)."
            PRINT "         Once edited, this file can then be used to delete dupe files from the"
            PRINT "         hard drive(s) and update files.bbs files using program RJKIL"
            PRINT STRING$(80, 196)
            PRINT "Switches:"
            PRINT
            PRINT "          -CDrive:\Path\CfgFile.Cfg"
            PRINT "          -ODrive:\Path\KilList.txt"
            PRINT "          -KTF [optional - will retain file $$Mast.Lst on disk.]"
            PRINT
            PRINT
        END SUB

        FUNCTION Pad$ (X) STATIC                'strip leading space, pad w/leading zero if needed

            IF LEN(STR$(X)) = 2 THEN
                Pad$ = "0" + RIGHT$(STR$(X), 1)
            ELSE
                Pad$ = RIGHT$(STR$(X), 2)
            END IF

        END FUNCTION

    SUB ParseCmdLine (Switch$, Work$, ReturnCode%)

        CmdLine$ = UCASE$(COMMAND$)
        ReturnCode% = False

        P% = INSTR(CmdLine$, Switch$)
        IF P% THEN
            Temp$ = MID$(CmdLine$, P% + 2)
            P% = INSTR(Temp$, " ")
            IF P% THEN
                Work$ = LEFT$(Temp$, P% - 1)
            ELSE
                Work$ = Temp$
            END IF
            ReturnCode% = True
        END IF

    END SUB

