  '**********************************************************************
  '**      Program:  RJCDFAL - CD-ROM Files Available Listing          **
  '**       Author:  R.J.(Bob) Ross                                    **
  '**                SysOp - RJ's Byteline BBS - FidoNet 1:134/75      **
  '** Date Started:  February 15th, 1995                               **
  '**                Version 1.00                                      **
  '**                Last compiled - March 9th, 1995                   **
  '**                                                                  **
  '**      Purpose:  To produce a Files Available Listing, listing     **
  '**                files available with descriptions from the        **
  '**                files.bbs files, that are available on a BBS      **
  '**                system on a CD-ROM drive.                         **
  '**                                                                  **
  '**                See Sample.Cfg for detals on the                  **
  '**                the key words to use with this program.           **
  '**                                                                  **
  '**     Language:  Microsoft QuickBASIC 4.5                          **
  '**      Library:  Crescent Software Inc - QuickPak Professional     **
  '**                Crescent Software Inc - P.D.Q                     **
  '**                                                                  **
  '**********************************************************************
  '
    DEFINT A-Z
    DECLARE SUB Help ()
    DECLARE FUNCTION Exist% (FileName$)
    DECLARE SUB Process (FilePath$, FilesBBS$, Count&, Bytes&)
    DECLARE FUNCTION QInstrB% (Start%, Source$, Search$)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION QPValI% (Num$)
    DECLARE FUNCTION QPValL& (Number$)
    DECLARE SUB WordWrap (X$, Wide, LeftMargin, OutFileHandel%)
    DECLARE FUNCTION Date2Day% (D$)
    DECLARE FUNCTION Date2Num% (Dat$)
    DECLARE FUNCTION FUsing$ (Num$, Image$)
    DECLARE FUNCTION Num2Day% (Days%)
    DECLARE FUNCTION Num2Date$ (Days%)
    DECLARE FUNCTION DayName$ (Day%)
    DECLARE FUNCTION MonthName$ (Month%)
    DECLARE FUNCTION Pad$ (X&, Places%)
    DECLARE SUB PrintRecord (FileHandel%, Rec$)
  
    CONST False = 0
    CONST True = NOT False
    CONST Version = "RJCDFAL V1.00"
    Quote$ = CHR$(34)
  
    CLS
    PRINT Version
    PRINT
  
    AreaDat% = False
    CDHeader% = False
    ShowPath% = False
    ShowAreaNum% = False
    ShowAreaTitle% = False
    Test% = False
    Ctr% = 0
  
    DIM Array$(0 TO 1)
    Array$(1) = SPACE$(37)
  
    BBSName$ = "You forgot to put your BBS Name in the Config File"
    SysOp$ = "SysOp Who!"
  
    OutputFile$ = "RJFAL.LST"
  
  'FileHandles
    CfgF% = 1
    OutP% = 2
    Handel% = 3
    HdrF% = 4
    TblF% = 5
    Adat% = 6
    AdatO% = 7
  
    ON ERROR GOTO Bomb
  
    CmdLine$ = UCASE$(COMMAND$)
  
  'No command line options given
    IF CmdLine$ = "" THEN
        CALL Help
        END
    END IF
  
  'Look for a Config file
    P% = INSTR(CmdLine$, "-C")
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            ConfigFile$ = LEFT$(Temp$, P% - 1)
        ELSE
            ConfigFile$ = Temp$
        END IF
    END IF
  
  'Test one file area only
    P% = INSTR(CmdLine$, "-T")
    IF P% THEN
        Test% = True
    END IF
  
  'Get Config file variables
    IF Exist%(ConfigFile$) THEN
        OPEN ConfigFile$ FOR INPUT AS #CfgF%
        PRINT "   Opening: "; ConfigFile$
        DO UNTIL EOF(CfgF%)
            DO UNTIL EOF(1)
                LINE INPUT #CfgF%, Record$
                Record$ = LTRIM$(Record$)
                IF LEFT$(Record$, 1) = ";" THEN
                    EXIT DO
                END IF
              
                IF UCASE$(LEFT$(Record$, 7)) = "BBSNAME" THEN
                    BBSName$ = QPTrim$(MID$(Record$, 8))
                    EXIT DO
                END IF
              
                IF UCASE$(LEFT$(Record$, 5)) = "SYSOP" THEN
                    SysOp$ = QPTrim$(MID$(Record$, 6))
                    EXIT DO
                END IF
              
                IF UCASE$(LEFT$(Record$, 10)) = "MAXAREADAT" THEN
                    AreaDatFile$ = QPTrim$(MID$(Record$, 11))
                    IF Exist%(AreaDatFile$) THEN
                        AreaDat% = True
                        EXIT DO
                    ELSE
                        BEEP
                        PRINT "Maximus Area Dat File "; AreaDatFile$; " not found!"
                        CLOSE
                        END
                    END IF
                END IF
                IF UCASE$(LEFT$(Record$, 13)) = "CD-HEADERFILE" THEN
                    CDHeaderFile$ = QPTrim$(MID$(Record$, 14))
                    CDHeader% = True
                    EXIT DO
                END IF
              
                IF UCASE$(LEFT$(Record$, 12)) = "CD-AVAILLIST" THEN
                    OutputFile$ = QPTrim$(MID$(Record$, 13))
                    OPEN OutputFile$ FOR OUTPUT AS #OutP%
                    PRINT "   Opening: "; OutputFile$
                    IF CDHeader% THEN
                        FileHandel% = OutP%
                        GOSUB HeaderFile
                    END IF
                    GOSUB BannerHeader
                    EXIT DO
                END IF
              
                IF UCASE$(LEFT$(Record$, 14)) = "SHOWCDAREAPATH" THEN
                    ShowPath% = True
                    EXIT DO
                END IF
              
                IF UCASE$(LEFT$(Record$, 14)) = "SHOWFILEAREANO" THEN
                    ShowAreaNum% = True
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 13)) = "SHOWAREATITLE" THEN
                    ShowAreaTitle% = True
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 13)) = "CD-LEFTMARGIN" THEN
                    LM$ = QPTrim$(MID$(Record$, 14))
                    LM% = QPValI%(LM$)
                    IF LM% = 0 THEN
                        BEEP
                        PRINT "Invalid or missing CD-LeftMargin in "; ConfigFile$
                    END IF
                END IF
                IF UCASE$(LEFT$(Record$, 14)) = "CD-DRIVELETTER" THEN
                    CDDrive$ = QPTrim$(UCASE$(MID$(Record$, 15)))
                    EXIT DO
                END IF
            LOOP
        LOOP
    ELSE
        CALL chime(4)
        PRINT "Configuration file "; ConfigFile$; " not found!"
        END
    END IF
    CLOSE CfgF%
  
  ' CLOSE : END
  'Skip over AreaDat for testing purposes
  '**************************************
  ' GOTO ReadAreaDat
  
  'Get Path, Files.bbs name and area description by reading
  'the Max Area.dat file and creating a temp file RJCDFAL.$$$
    IF AreaDat% THEN
        GOSUB GetAreaDatInfo
    ELSE
        BEEP
        PRINT "Maximus Area Dat File not described in "; ConfigFile$
        END
    END IF
  
ReadAreaDat:
  
  'Match the CD-Drive with the RJCDFAL.$$$ record and process
    OPEN "RJCDFAL.$$$" FOR INPUT AS TblF%
    DO UNTIL EOF(TblF%)
        DO UNTIL EOF(TblF%)
            INPUT #TblF%, AreaNumber$, FilePath$, FilesBBS$, AreaDescription$
            IF LEFT$(FilePath$, 1) = CDDrive$ THEN
                IF Test% THEN
                    Ctr% = Ctr% + 1
                    IF Ctr% >= 2 THEN
                        EXIT DO
                    END IF
                END IF
                IF Exist%(FilesBBS$) THEN
                    OPEN FilesBBS$ FOR INPUT AS #Handel%
                    Ln% = LEN(FilesBBS$)
                    Ln% = Ln% - 11
                    PRINT "Processing: "; FilesBBS$;
                    PRINT STRING$((45 - Ln%), ".");
                    Count& = 0
                    Bytes& = 0
                    CALL Process(FilePath$, FilesBBS$, Count&, Bytes&)
                    MegaBytes! = Bytes& / 1048576
                    Padded$ = Pad$(Bytes&, 10)
                    PRINT Padded$
                    TotalFiles& = TotalFiles& + Count&
                    TotalMBytes! = TotalMBytes! + MegaBytes!
                    IF ShowPath% THEN
                        PRINT #OutP%, TAB(38 - LEN(Path$) / 2); "("; FilePath$; ")"
                    END IF
                  'Files.bbs file total stats
                    PRINT #OutP%, STRING$(80, 196)
                    PRINT #OutP%, SPACE$(23); ""; STRING$(28, 196); ""
                    PRINT #OutP%, SPACE$(23); "  TOTAL FILES: ";
                    PRINT #OutP%, FUsing$(STR$(Count&), "#######,###");
                    PRINT #OutP%, "  "
                    PRINT #OutP%, SPACE$(23); "  TOTAL BYTES: ";
                    PRINT #OutP%, FUsing$(STR$(Bytes&), "#######,###");
                    PRINT #OutP%, "  "
                    PRINT #OutP%, SPACE$(23); ""; STRING$(28, 196); ""
                    PRINT #OutP%, STRING$(80, 196)
                    ELSE
                    BEEP
                    PRINT "*********** File: "; FilesBBS$; " not found!"
                END IF
            END IF
        LOOP
    LOOP
    CLOSE TblF%
  
  'Grand total stats
    PRINT #OutP%, STRING$(80, 196)
    PRINT #OutP%, SPACE$(18); ""; STRING$(37, 205); ""
    PRINT #OutP%, SPACE$(18); " GRAND TOTAL FILES    : ";
    PRINT #OutP%, FUsing$(STR$(TotalFiles&), "#######,###");
    PRINT #OutP%, "  "
    PRINT #OutP%, SPACE$(18); " GRAND TOTAL MEGABYTES: ";
    PRINT #OutP%, FUsing$(STR$(TotalMBytes!), "#######,###");
    PRINT #OutP%, "  "
    PRINT #OutP%, SPACE$(18); ""; STRING$(37, 205); ""
    PRINT #OutP%, STRING$(80, 196)
    GOSUB ProgramID
    CLOSE #OutP%
    CALL chime(10)
    PRINT
    PRINT
    PRINT Version
    PRINT "                            Started at:    "; Tm$
    PRINT "                           Finished at:    "; TIME$
    PRINT
    PRINT "                           Total Files: ";
    PRINT FUsing$(STR$(TotalFiles&), "#######,###")
    PRINT "                       Total MegaBytes: ";
    PRINT FUsing$(STR$(TotalMBytes!), "#######,###")
    PRINT
    PRINT
    PRINT "    Created Files Available Listing as: "; OutputFile$
    PRINT
    END
    PRINT
  
Bomb:
    PRINT "program bombed!", ERR
    END
  
HeaderFile:
    IF Exist%(CDHeaderFile$) THEN
        OPEN CDHeaderFile$ FOR INPUT AS #HdrF%
        PRINT "   Opening: "; CDHeaderFile$
        DO UNTIL EOF(HdrF%)
            LINE INPUT #HdrF%, Record$
            PRINT #FileHandel%, Record$
        LOOP
        CLOSE HdrF%
    END IF
    RETURN
  
BannerHeader:
  
    GOSUB BannerInfo
    GOSUB DaySuffix
    GOSUB AsOfLine
    PRINT #OutP%,
    PRINT #OutP%, ""; STRING$(78, 205); ""
    PRINT #OutP%, "";
    PRINT #OutP%, TAB(40 - LEN(BBSName$) / 2); BBSName$;
    PRINT #OutP%, TAB(80); ""
    PRINT #OutP%, "";
    PRINT #OutP%, TAB(40 - LEN(SysOp$) / 2); SysOp$;
    PRINT #OutP%, TAB(80); ""
    PRINT #OutP%, "";
    PRINT #OutP%, TAB(40 - LEN(Fal$) / 2); Fal$;
    PRINT #OutP%, TAB(80); ""
    PRINT #OutP%, "";
    PRINT #OutP%, TAB(40 - LEN(AsOf$) / 2); AsOf$;
    PRINT #OutP%, TAB(80); ""
    PRINT #OutP%, ""; STRING$(78, 205); ""
    RETURN
  
BannerInfo:
    SysOp$ = "SysOp: " + SysOp$
    Fal$ = "CD-ROM - Files Available Listing As Of"
    Day% = Date2Day%(DATE$)
    Dy% = QPValI%(MID$(DATE$, 4, 2))
    Dy$ = STR$(Dy%)
    Mo% = QPValI%(LEFT$(DATE$, 2))
    Yr$ = RIGHT$(DATE$, 4)
    Tm$ = TIME$
    RETURN
  
DaySuffix:
    SELECT CASE Dy%
    CASE 1, 21, 31
        Suffix$ = "st"
    CASE 2, 22
        Suffix$ = "nd"
    CASE 3, 23
        Suffix$ = "rd"
    CASE ELSE
        Suffix$ = "th"
    END SELECT
    RETURN
AsOfLine:
    AsOf$ = Tm$ + " Hrs -- " + DayName$(Day%) + "," + Dy$ + Suffix$ + " of " + MonthName$(Mo%) + ", " + Yr$
    RETURN
  
ProgramID:
    Temp$ = "List Compiled Using Program " + Version + " by R.J.(Bob) Ross - 1:134/75"
    PRINT #OutP%, ""; STRING$(78, 196); ""
    PRINT #OutP%, "";
    PRINT #OutP%, TAB(40 - LEN(Temp$) / 2); Temp$;
    PRINT #OutP%, TAB(80); ""
    PRINT #OutP%, ""; STRING$(78, 196); ""
    RETURN
  
GetAreaDatInfo:
  
    OutPutCfg$ = "RJCDFAL.$$$"
  
    OPEN AreaDatFile$ FOR BINARY ACCESS READ AS #Adat%
    OPEN OutPutCfg$ FOR OUTPUT AS #AdatO%
    PRINT "   Opening: "; AreaDatFile$
    PRINT "   Opening: "; OutPutCfg$;
    H% = CSRLIN
  
    NxtRecord& = 0
  'Get the Record Length
  '---------------------
    SEEK Adat%, 5
    GET Adat%, , Length%
  'First Record
  '------------
    SEEK Adat%, 9
    AreaNumber$ = INPUT$(8, Adat%)
    AreaNumber$ = QPTrim$(AreaNumber$)
  
    SEEK Adat%, 399
    FileAreaPath$ = INPUT$(80, Adat%)
    IF LEFT$(FileAreaPath$, 1) = CHR$(0) THEN
      'Forget it
    ELSE
        FileAreaPath$ = QPTrim$(FileAreaPath$)

        SEEK Adat%, 639
        FilesBBS$ = INPUT$(80, Adat%)

        SEEK Adat%, 719
        AreaTitle$ = INPUT$(80, Adat%)
        AreaTitle$ = QPTrim$(AreaTitle$)

        IF LEFT$(FilesBBS$, 1) = CHR$(0) THEN
            FilesBBS$ = "Files.bbs"
            ELSE
            FilesBBS$ = QPTrim$(FilesBBS$)
        END IF
        GOSUB WriteToFile
    END IF
  'All Remaining Records
  '---------------------
    DO UNTIL EOF(Adat%)
        Ct% = Ct% + 1
        LOCATE H%, 30
        PRINT Ct%;
        NxtRecord& = NxtRecord& + Length%

        SEEK Adat%, NxtRecord& + 9
        AreaNumber$ = INPUT$(8, Adat%)

        IF AreaNumber$ = "" THEN EXIT DO

        AreaNumber$ = QPTrim$(AreaNumber$)
      
        SEEK Adat%, NxtRecord& + 399
        FileAreaPath$ = INPUT$(80, Adat%)

        IF LEFT$(FileAreaPath$, 1) = CHR$(0) THEN
          'Forget it
        ELSE
            FileAreaPath$ = QPTrim$(FileAreaPath$)

            SEEK Adat%, NxtRecord& + 639
            FilesBBS$ = INPUT$(80, Adat%)

            SEEK Adat%, NxtRecord& + 719
            AreaTitle$ = INPUT$(80, Adat%)
            AreaTitle$ = QPTrim$(AreaTitle$)

            IF LEFT$(FilesBBS$, 1) = CHR$(0) THEN
                FilesBBS$ = "Files.bbs"
            END IF
            FilesBBS$ = QPTrim$(FilesBBS$)
            IF FilesBBS$ > "" THEN
                GOSUB WriteToFile
            END IF
        END IF
    LOOP
    CLOSE Adat%
    CLOSE AdatO%
    PRINT
 '  CLOSE : END
    RETURN
  
ParseAreaTitle:
  'Remove all commas from the AreaTitle
  ' L% = LEN(AreaTitle$)
  ' FOR X% = 1 TO L%
  '     IF MID$(AreaTitle$, X%, 1) = "," THEN
  '         MID$(AreaTitle$, X%, 1) = " "
  '     END IF
  ' NEXT
  ' RETURN

WriteToFile:
   PRINT #AdatO%, Quote$; AreaNumber$; Quote$; ",";
   PRINT #AdatO%, Quote$; FileAreaPath$; Quote$; ",";
   PRINT #AdatO%, Quote$; FilesBBS$; Quote$; ",";
   PRINT #AdatO%, Quote$; AreaTitle$; Quote$
   RETURN

    FUNCTION Date2Day% (Dat$) STATIC
        Date2Day% = Num2Day%(Date2Num%(Dat$))
    END FUNCTION

DEFSNG A-Z
    SUB Help
        CLS
        Temp$ = "RJ's CD - Files Available Listing - " + Version
        Temp2$ = "by R.J.(Bob) Ross"
        Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
      
        PRINT
        PRINT TAB(40 - LEN(Temp$) / 2); Temp$
        PRINT TAB(40 - LEN(Temp2$) / 2); Temp2$
        PRINT TAB(40 - LEN(Temp3$) / 2); Temp3$
        PRINT STRING$(78, 196)
        PRINT "Purpose:  To produce a CD Files Available Listing, listing files"
        PRINT "          available with descriptions from the files.bbs files,"
        PRINT "          that are available on a BBS.  "
        PRINT
        PRINT "   Note:  The optional - T switch will only produce a File Available"
        PRINT "          listing for the first directory/files.bbs.  Use for testing"
        PRINT "          output to confirm the left margin is set correctly, etc."
        PRINT
        PRINT "          See Sample.Cfg for detals on the verbs to use."
        PRINT
        PRINT STRING$(78, 196)
        PRINT "Switches:"
        PRINT
        PRINT
        PRINT "          -Cdrive:\directory\Sample.cfg"
        PRINT "          -T [optional]"
        PRINT
        PRINT
    END SUB

DEFINT A-Z
    FUNCTION Pad$ (X&, Places%) STATIC
      
        X$ = STR$(X&)           'make a string version of the number
      
        IF LEN(LTRIM$(X$)) > Places% THEN       'if after trimming a possible leading
            Pad$ = "%" + X$     '  blank it's too long, add a "%"
            EXIT FUNCTION       '  to show an error and go away
        END IF
      
        X$ = MID$(X$, 2)        'discard the leading blank or "-" sign
        Pad$ = MID$("-", SGN(X&) + 2) + STRING$(Places% - LEN(X$) + (SGN(X&) = -1), "0") + X$
      '            ^add minus if needed       ^create the zeros    ^less one if negative
      
    END FUNCTION

    SUB Process (FilePath$, FilesBBS$, FileCount&, AreaTotBytes&)
1       SHARED Handel%, OutP%, LM%, AreaNumber$, ShowAreaNum%, ShowAreaTitle%, AreaDescription$, Array$()
2       FileCount& = 0
3       Bytes& = 0
4       Wdth% = 79 - LM%        'Width of File description
5       LftRec% = LM% - 1       'portion of line before the file description
      
6       IF ShowAreaNum% THEN
7           Temp$ = "File Area: " + AreaNumber$
8           PRINT #OutP%, TAB(38 - LEN(Temp$) \ 2); ""; STRING$(LEN(Temp$) + 2, 205); ""
9           PRINT #OutP%, TAB(38 - LEN(Temp$) \ 2); "";
10          PRINT #OutP%, TAB(40 - LEN(Temp$) \ 2); Temp$; " "
11          PRINT #OutP%, TAB(38 - LEN(Temp$) \ 2); ""; STRING$(LEN(Temp$) + 2, 205); ""
12      END IF
      
13      IF ShowAreaTitle% THEN
14          PRINT #OutP%, TAB(38 - LEN(AreaDescription$) \ 2); ""; STRING$(LEN(AreaDescription$) + 2, 205); ""
15          PRINT #OutP%, TAB(38 - LEN(AreaDescription$) \ 2); "";
16          PRINT #OutP%, TAB(40 - LEN(AreaDescription$) \ 2); AreaDescription$; " "
17          PRINT #OutP%, TAB(38 - LEN(AreaDescription$) \ 2); ""; STRING$(LEN(AreaDescription$) + 2, 205); ""
18      END IF
      
19      DO UNTIL EOF(Handel%)
20          DO UNTIL EOF(Handel%)
21              LINE INPUT #Handel%, Record$
22              IF MID$(Record$, 2, 1) = "" THEN
23                  EXIT DO
24              END IF
25              IF INSTR(Record$, CHR$(22)) THEN
                  '**** This code by Henning Johansen - 1:134/40
26                  WHILE INSTR(Record$, CHR$(22)) <> 0
27                      Offset = INSTR(Record$, CHR$(22))
28                      LineLength = LEN(Record$)
29                      Temp$ = (LEFT$(Record$, (Offset - 1))) + (RIGHT$(Record$, ((LineLength - Offset) - 2)))
30                      Record$ = Temp$
31                  WEND
                  '****
32                  PRINT #OutP%, Record$
33                  EXIT DO
34              END IF
35              IF LEFT$(Record$, 1) = "" THEN
36                  PRINT #OutP%, Record$
37                  EXIT DO
38              END IF
39              IF LEFT$(Record$, 1) = " " THEN
40                  PRINT #OutP%, Record$
41                  EXIT DO
42              END IF
43              IF LEFT$(Record$, 1) = "-" THEN
44                  PRINT #OutP%, Record$
45                  EXIT DO
46              END IF
47              P% = INSTR(Record$, ".")
48              IF P% THEN
49                  IF LEFT$(Record$, 1) <> " " THEN
50                      Posn% = INSTR(Record$, " ")
51                      IF Posn% THEN
52                          FilesBBSFileName$ = LEFT$(Record$, Posn% - 1)
53                          IF Exist%(FilePath$ + FilesBBSFileName$) THEN
54                              FileCount& = FileCount& + 1
55                              Array$(0) = FilePath$ + FilesBBSFileName$
56                              Array$(1) = SPACE$(37)
57                              CALL ReadFileI(BYVAL VARPTR(Array$(0)))
58                              Bytes& = QPValL&(MID$(Array$(1), 13, 10))
59                              AreaTotBytes& = AreaTotBytes& + Bytes&
60                              Temp$ = LTRIM$(MID$(Record$, Posn%))
61                              IF LEFT$(Temp$, 3) = "/tb" THEN
62                                    Temp$ = LTRIM$(MID$(Temp$, 4))
63                                END IF
64                                IF LEFT$(Temp$, 2) = "/b" THEN
65                                    Temp$ = LTRIM$(MID$(Temp$, 3))
66                                END IF
67                                Record$ = LEFT$(Array$(1), 30) + " " + Temp$
                              
68                                PRINT #OutP%, LEFT$(Record$, LftRec%);
69                                CALL WordWrap(MID$(Record$, LM%), Wdth%, LM%, OutP%)
70                                IF MID$(Record$, 31, 1) = "*" THEN
71                                END IF
72                            END IF
73                            EXIT DO
74                        END IF
75                    END IF
76                END IF
77           LOOP
78      LOOP
79      CLOSE Handel%
80  END SUB

    SUB WordWrap (X$, Wide, LeftMargin, OutFileHandel%) STATIC
      
        DO WHILE LEN(X$)        ' Loop while we have text
          ' find a place to break the line
            Pointer% = Wide + 1
            DO UNTIL MID$(X$, Pointer%, 1) = " " OR Pointer% = 1 OR Pointer% > LEN(X$)
                Pointer% = Pointer% - 1
            LOOP
          ' handle unbreakable text
            IF Pointer% = 1 THEN Pointer% = Wide + 1
            PRINT #OutFileHandel%, TAB(LeftMargin%); LEFT$(X$, Pointer% - 1)    ' dump the line
            X$ = MID$(X$, Pointer% + 1)
        LOOP
      
    END SUB

