  '***********************************************************************
  ' **        Program:  RJDLC - Download Counter                        **
  ' **   Date Started:  October 13th, 1994                              **
  ' **        Version: .01 Beta completed October 15th, 1994            **
  ' **                 .02 Beta completed October 15th, 1994            **
  ' **                 .03 Beta completed October 24th, 1994            **
  ' **                 .04 Beta completed October 24th, 1994            **
  ' **                 .05 Beta completed November 7th, 1994            **
  ' **                 .06 Beta completed November 22nd, 1994           **
  ' **                 .07 Beta completed December 4th, 1994            **
  ' **                 .08 Beta completed December 10th, 1994           **
  ' **                 1.00 completed February 9th, 1995                **
  ' **                 Last compiled April 15th, 1995                   **
  ' **                                                                  **
  ' **        Purpose:  To read a Binkley and or Max log and update the **
  ' **                  download counter and last year/month a program  **
  ' **                  was downloaded.                                 **
  ' **                                                                  **
  ' **       Language:  Microsoft QuickBASIC 4.5                        **
  ' **        Library:  Crescent Software Inc - QuickPak Professional   **
  ' **********************************************************************
  
    DEFINT A-Z
    DECLARE FUNCTION CurrentDate$ ()
    DECLARE FUNCTION DOSError%
    DECLARE FUNCTION ErrorMsg$ (Num%)
    DECLARE FUNCTION Exist% (Filename$)
    DECLARE SUB FilesBBS (Path$, ArcFile$, WhoGot$, DLDate$)
    DECLARE FUNCTION FUsing$ (Num$, Image$)
    DECLARE SUB Help ()
    DECLARE SUB InputLine (IOCHAN%, BUFSIZE%, STATUS%, TEXT$)
    DECLARE FUNCTION ItsAFile% (Work$)
    DECLARE FUNCTION Month$ (MnthName$)
    DECLARE FUNCTION MonthName$ (Mnth%)
    DECLARE SUB ParsePthFilN (Work$, Pth$, FileN$)
    DECLARE FUNCTION QInstrB% (StartPosn%, Source$, Search$)
    DECLARE FUNCTION QPValI% (Num$)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION WhichError%
    DECLARE SUB Wordwrap (X$, Wide, LeftMargin)
    DECLARE FUNCTION CurrentDate$ ()

  
  
    COMMON SHARED CR$, LF$, CRLF$               'required for binary read Sub InputLine
    CLS
    CONST False = 0
    CONST True = NOT False
    ActivityLog% = False
    AreaDat% = False
    CONST Version = "RJDLC V1.00"
    Dt$ = CurrentDate$

    PRINT
    PRINT Dt$; TIME$; " RJUT Begin "; Version
  
    CR$ = CHR$(13)
    LF$ = CHR$(10)
    CRLF$ = CR$ + LF$
  
  'Command line argument - or lack of
    CmdLine$ = UCASE$(COMMAND$)
    IF CmdLine$ = "" THEN
        CALL Help
        END
    END IF
  
    P% = INSTR(CmdLine$, "-I")  '   -I    Input Log File
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            Logfile$ = LEFT$(Temp$, P% - 1)
        ELSE
            Logfile$ = Temp$
        END IF
    END IF
  
    IF Exist%(Logfile$) THEN
      'do nothing
    ELSE
        BEEP
        PRINT "Logfile: "; Logfile$; " NOT found!"
        PRINT Dt$; TIME$; " RJUT Logfile: "; Logfile$; " NOT found."
        PRINT Dt$; TIME$; " RJUT End RJDLC"
        END
    END IF
  
  
    P% = INSTR(CmdLine$, "-O")  '   -O    Output activity log
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            ActivityLog$ = LEFT$(Temp$, P% - 1)
        ELSE
            ActivityLog$ = Temp$
        END IF
        ActivityLog% = True
    END IF
  
    P% = INSTR(CmdLine$, "-A")  '   -A    Area.dat
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            AreaDat$ = LEFT$(Temp$, P% - 1)
        ELSE
            AreaDat$ = Temp$
        END IF
        AreaDat% = True
    END IF
  
    IF AreaDat% THEN
        IF Exist%(AreaDat$) THEN
          
            OutPutTbl$ = "RJDLC.TBL"
          
            OPEN AreaDat$ FOR BINARY ACCESS READ AS #1
            PRINT Dt$; TIME$; " RJUT Reading: "; AreaDat$
            OPEN OutPutTbl$ FOR OUTPUT AS #2
            R% = CSRLIN
            C% = POS(0)
          
            NxtRecord& = 0
          'Get the Record Length
          '---------------------
            SEEK 1, 5
            GET 1, , Length%
          'First Record
          '------------
            SEEK 1, 399
            FileAreaPath$ = INPUT$(80, 1)
            IF LEFT$(FileAreaPath$, 1) = CHR$(0) THEN
              'Forget it
            ELSE
                FileAreaPath$ = QPTrim$(FileAreaPath$)
             '  PRINT FileAreaPath$;
                PRINT #2, FileAreaPath$;
                SEEK 1, 639
                AreaDatFilesBBS$ = INPUT$(80, 1)
                IF LEFT$(AreaDatFilesBBS$, 1) = CHR$(0) THEN
                    PRINT #2, ","; FileAreaPath$; "Files.bbs"
                ELSE
                    AreaDatFilesBBS$ = QPTrim$(AreaDatFilesBBS$)
                    PRINT #2, " "; AreaDatFilesBBS$
                END IF
            END IF
          'All Remaining Records
          '---------------------
            DO UNTIL EOF(1)
              ' ctr% = ctr% + 1
              ' LOCATE R%, C%
              ' PRINT "Reading: "; AreaDat$; ctr%
              ' PRINT Dt$; TIME$; " RJUT Reading: "; AreaDat$
                NxtRecord& = NxtRecord& + Length%
                SEEK 1, NxtRecord& + 399
                FileAreaPath$ = INPUT$(80, 1)
                IF LEFT$(FileAreaPath$, 1) = CHR$(0) THEN
                  'Forget it
                ELSE
                    FileAreaPath$ = QPTrim$(FileAreaPath$)
                    PRINT #2, FileAreaPath$;
                    SEEK 1, NxtRecord& + 639
                    AreaDatFilesBBS$ = INPUT$(80, 1)
                    IF LEFT$(AreaDatFilesBBS$, 1) = CHR$(0) THEN
                        PRINT #2, ","; FileAreaPath$; "Files.bbs"
                    ELSE
                        AreaDatFilesBBS$ = QPTrim$(AreaDatFilesBBS$)
                        IF AreaDatFilesBBS$ > "" THEN
                          '  PRINT ","; AreaDatFilesBBS$
                            PRINT #2, ","; AreaDatFilesBBS$
                        END IF
                    END IF
                END IF
            LOOP
            CLOSE 1, 2
         '  PRINT "Files.bbs Lookup Table: "; OutPutTbl$
            PRINT Dt$; TIME$; " RJUT Files.bbs Lookup Table: "; OutPutTbl$
        ELSE
            BEEP
         '  PRINT "File: "; AreaDat$; " NOT found!"
            PRINT Dt$; TIME$; " RJUT File: "; AreaDat$; " NOT found!"
            AreaDat% = False
        END IF
    END IF
  
    IF ActivityLog% THEN
      'Log program actions in activity log
        OPEN ActivityLog$ FOR APPEND AS #4
      
      'Program/Copyright Identification
        Temp$ = Version
        PRINT #4,
        PRINT #4, Logfile$;
        PRINT #4, TAB(78 - LEN(Temp$)); Temp$
        PRINT #4,
      
      'Log start info
        PRINT #4, STRING$(1, 213); STRING$(76, 205); STRING$(1, 184)
        PRINT #4, "                     "; MID$(DATE$, 4, 2); " ";
        PRINT #4, MonthName$(QPValI%(LEFT$(DATE$, 2))); " ";
        PRINT #4, LEFT$(TIME$, 5); " RJDLC Start activity Log.                 "
        PRINT #4, STRING$(1, 212); STRING$(76, 205); STRING$(1, 190)
    END IF
  
  'Required for InputLine Sub
    Maxsize% = 4096
    Filestat% = 1
    Chan% = 1
  
  'Process the log file
    OPEN Logfile$ FOR BINARY SHARED AS #Chan%
  
  'Program loop to get appropriate log entries
    DO UNTIL Filestat% = -1
      
      'Read a log line
        CALL InputLine(Chan%, Maxsize%, Filestat%, Record$)
      
      'Binkley File Request or Send
        IF INSTR(19, UCASE$(Record$), "BINK SYSOP:") THEN
            WhoGot$ = MID$(Record$, 3, 12) + " " + MID$(Record$, 23)
            SysYear$ = RIGHT$(DATE$, 2)
            IF LEFT$(DATE$, 5) = "01-01" THEN
                SysYear% = QPValI%(SysYear$)
                SysYear% = SysYear% - 1
                SysYear$ = LTRIM$(STR$(SysYear%))
            END IF
            DLDate$ = SysYear$ + Month$(MID$(Record$, 6, 3))
        END IF
      
      'MAX User download
        IF INSTR(Record$, "MAX") THEN
            IF INSTR(Record$, "calling (U#") THEN
                WhoGot$ = MID$(Record$, 3, 12) + " " + MID$(Record$, 23)
                SysYear$ = RIGHT$(DATE$, 2)
                IF LEFT$(DATE$, 5) = "01-01" THEN
                    SysYear% = QPValI%(SysYear$)
                    SysYear% = SysYear% - 1
                    SysYear$ = LTRIM$(STR$(SysYear%))
                END IF
                DLDate$ = SysYear$ + Month$(MID$(Record$, 6, 3))
            END IF
        END IF
      
      'Blue Wave Mail Door file request
        IF INSTR(Record$, "BWMX") THEN
            IF INSTR(Record$, "entering The Blue Wave Mail Door") THEN
                BWWhoGot$ = MID$(Record$, 3, 12) + " " + MID$(Record$, 23)
                SysYear$ = RIGHT$(DATE$, 2)
                IF LEFT$(DATE$, 5) = "01-01" THEN
                    SysYear% = QPValI%(SysYear$)
                    SysYear% = SysYear% - 1
                    SysYear$ = LTRIM$(STR$(SysYear%))
                END IF
                BWDLDate$ = SysYear$ + Month$(MID$(Record$, 6, 3))
            END IF
        END IF
      
      'Re-set WhoGot & Download Date
        IF INSTR(19, Record$, "MAX  End,") THEN
            WhoGot$ = ""
            DLDate$ = ""
        END IF
      
        IF INSTR(19, Record$, "BINK End of WaZOO/EMSI Session") THEN
            WhoGot$ = ""
            DLDate$ = ""
        END IF
      
        IF INSTR(19, Record$, "BWMX") AND INSTR(19, Record$, "leaving The Blue Wave Mail Door.") THEN
            BWWhoGot$ = ""
            BWDLDate$ = ""
        END IF
      
      'File sent via Binkley
        IF INSTR(19, Record$, "BINK Sent") THEN 'Binkley Record
            IF ItsAFile(Record$) THEN
                CALL ParsePthFilN(Record$, Pth$, FileN$)
                CALL FilesBBS(Pth$, FileN$, WhoGot$, DLDate$)
            END IF
          
          'File sent via Max
        ELSEIF INSTR(19, Record$, "MAX  DL-") THEN
            IF ItsAFile(Record$) THEN           'Max Record
                CALL ParsePthFilN(Record$, Pth$, FileN$)
                CALL FilesBBS(Pth$, FileN$, WhoGot$, DLDate$)
            END IF
          
          'File send via Blue Wave
        ELSEIF INSTR(19, Record$, "BWMX Added") AND INSTR(Record$, "to DL FREQ Queue") THEN
            Temp$ = MID$(Record$, 30)
            P% = INSTR(Temp$, " ")
            IF P% THEN
                Temp1$ = LEFT$(Temp$, P% - 1)
                Posn% = QInstrB%(-1, Temp1$, "\")
                Pth$ = LEFT$(Temp1$, Posn%)
                FileN$ = MID$(Temp1$, Posn% + 1)
                CALL FilesBBS(Pth$, FileN$, BWWhoGot$, BWDLDate$)
            END IF
        END IF
ReturnFmError:
    LOOP
  
  'Finished
    IF ActivityLog% THEN
        PRINT #4,
        PRINT #4, MID$(DATE$, 4, 2); " ";
        PRINT #4, MonthName$(QPValI%(LEFT$(DATE$, 2))); " ";
        PRINT #4, LEFT$(TIME$, 5); " RJDLC End activity Log."
        CLOSE #4
    END IF
    PRINT Dt$; TIME$; " RJUT End RJDLC"
    END
FileError:
    IF ActivityLog% THEN
        PRINT #4, "***** File Error *******"; ERR;
        PRINT #4, " "; ErrorMsg$(ERR)
        PRINT #4, "Could not open "; Path$; "Files.bbs"
        PRINT #4, Record$
        PRINT #4, STRING$(78, 196)
      ' PRINT "* File Error *"; ERR;
        PRINT Dt$; TIME$; " RJUT * File Error *"; ERR
      ' PRINT " "; ErrorMsg$(ERR)
        PRINT Dt$; TIME$; " RJUT "; ErrorMsg$(ERR)
      ' PRINT "Could not open "; Path$; "Files.bbs"
        PRINT Dt$; TIME$; " RJUT Could not open "; Path$; "Files.bbs"
      '  PRINT Record$
        PRINT Dt$; TIME$; " RJUT "; Record$
        RESUME ReturnFmError
    ELSE
      ' PRINT "***** File Error *******"; ERR;
        PRINT Dt$; TIME$; " RJUT * File Error *"; ERR
      ' PRINT " "; ErrorMsg$(ERR)
        PRINT Dt$; TIME$; " RJUT "; ErrorMsg$(ERR)
      ' PRINT "Could not open "; Path$; "Files.bbs"
      ' PRINT Record$
        PRINT Dt$; TIME$; " RJUT Could not open "; Path$; "Files.bbs"
        PRINT Dt$; TIME$; " RJUT "; Record$
        RESUME ReturnFmError
    END IF

    FUNCTION CurrentDate$
        Dt$ = DATE$
        Mnth$ = LEFT$(Dt$, 2)
        SELECT CASE Mnth$
        CASE IS = "01"
            Mnth$ = "Jan"
        CASE IS = "02"
            Mnth$ = "Feb"
        CASE IS = "03"
            Mnth$ = "Mar"
        CASE IS = "04"
            Mnth$ = "Apr"
        CASE IS = "05"
            Mnth$ = "May"
        CASE IS = "06"
            Mnth$ = "Jun"
        CASE IS = "07"
            Mnth$ = "Jul"
        CASE IS = "08"
            Mnth$ = "Aug"
        CASE IS = "09"
            Mnth$ = "Sep"
        CASE IS = "10"
            Mnth$ = "Oct"
        CASE IS = "11"
            Mnth$ = "Nov"
        CASE IS = "12"
            Mnth$ = "Dec"
        END SELECT
        CurrentDate$ = "  " + MID$(Dt$, 4, 2) + " " + Mnth$ + " "
      
    END FUNCTION

    SUB FilesBBS (Path$, ArcFile$, WhoGot$, DLDate$)
        SHARED ActivityLog%, AreaDat%, Dt$
      'Updates the Files.bbs.
      'Files.bak is made prior to messing with the Files.bbs
      'When done Temp.$$$ is copied to Files.bbs - to create a new Files.bbs
      '
        TableMatch% = False
        IF AreaDat% THEN
            OPEN "RJDLC.TBL" FOR INPUT AS #7
          
            DO UNTIL EOF(7)
                INPUT #7, FilesPath$, FilesBBSName$
                IF UCASE$(Path$) = UCASE$(FilesPath$) THEN
                    TableMatch% = True
                    EXIT DO
                END IF
            LOOP
            CLOSE 7
        END IF
      
        IF NOT TableMatch% THEN
            FilesBBSName$ = Path$ + "Files.bbs"
        END IF
      
        DE% = 0
        NoMatch% = -1
      
        IF NOT Exist%(FilesBBSName$) THEN
            PRINT Dt$; TIME$; " RJUT "; FilesBBSName$; " not found. "; "("; ArcFile$; ")"
            IF ActivityLog% THEN
                PRINT #4, FilesBBSName$; " not found. "; "("; ArcFile$; ")"
                PRINT #4, WhoGot$
                PRINT #4, STRING$(78, 196)
            END IF
            EXIT SUB
        END IF
      
        IF Exist%(FilesBBSName$) THEN
            P% = INSTR(FilesBBSName$, ".")
            IF P% THEN FilesBak$ = LEFT$(FilesBBSName$, P%) + "BAK"
            CALL FCopy(FilesBBSName$, FilesBak$, SPACE$(4096), ErrCode%)
          
            IF DOSError% THEN
              ' If an error occurs here it's very likley that it's coming
              ' from the CD-ROM drive since you can't write to the drive.
              ' I set up this trap primarily for this.
                PRINT "DOS Error: "; WhichError%; " - "; ErrorMsg(WhichError%)
                IF ActivityLog% THEN
                    PRINT #4, "DOS Error: "; WhichError%; " - "; ErrorMsg(WhichError%)
                END IF
                DE% = -1
            END IF
          
            Infile% = 2
            ON ERROR GOTO FileError
            OPEN FilesBBSName$ FOR INPUT AS #Infile%
            ON ERROR GOTO 0
          
            OutFile% = 3
            IF DE% THEN
              'Do nothing
            ELSE
                OPEN "Temp.$$$" FOR OUTPUT AS #OutFile%
            END IF
          
            DO UNTIL EOF(Infile%)
                LINE INPUT #Infile, Record$
                IF LEFT$(Record$, LEN(ArcFile$)) = UCASE$(ArcFile$) THEN
                    NoMatch% = 0
                    IF ActivityLog% THEN
                        PRINT #4, "File Path: "; Path$
                        PRINT #4, "Files.bbs: "; FilesBBSName$
                        PRINT #4, WhoGot$
                        PRINT #4,
                    END IF
                    IF DE% THEN
                        IF ActivityLog% THEN
                            PRINT #4, LEFT$(Record$, 28);
                            CALL Wordwrap(MID$(Record$, 29), 50, 29)
                            PRINT #4, STRING$(78, 196)
                        END IF
                        EXIT DO
                    END IF
                  
                    P% = INSTR(Record$, "[")
                    IF P% = 0 THEN
                      'Format Record$ to include the brackets [   ]
                        Temp1$ = LEFT$(Record$, LEN(ArcFile$)) + SPACE$(13 - LEN(ArcFile$)) + "[   0 | 9999] "
                        Temp2$ = LTRIM$(MID$(Record$, 1 + LEN(ArcFile$)))
                        Record$ = Temp1$ + Temp2$
                    END IF
                  
                    P% = INSTR(Record$, "[")
                    IF P% THEN
                        DownCount% = QPValI%(MID$(Record$, P% + 1))
                        DownCount% = DownCount% + 1
                        DownCount$ = FUsing$(STR$(DownCount%), "####")
                      
                        PRINT #OutFile%, LEFT$(Record$, P%);
                        PRINT #OutFile%, TAB(P% + 1);
                        PRINT #OutFile%, DownCount$;
                        PRINT #OutFile%, " ";
                        PRINT #OutFile%, "| "; DLDate$;
                      
                    '   PRINT "Updating: "; LEFT$(Record$, P% - 1);
                     '  PRINT TAB(40); "["; DownCount$; " | "; DLDate$; "]"
                        PRINT Dt$; TIME$; " RJUT Updating: "; LEFT$(Record$, P% - 1); "["; DownCount$; " | "; DLDate$; "]"
                      
                        IF ActivityLog% THEN
                          'piece the record back together for the activity log
                            Temp$ = LEFT$(Record$, P%) + DownCount$ + " | " + DLDate$
                        END IF
                      
                        P% = INSTR(Record$, "]")
                        IF P% THEN
                            PRINT #OutFile%, MID$(Record$, P%)
                            IF ActivityLog% THEN
                              'complete piecing the record together for the activity log
                                Temp2$ = Temp$ + MID$(Record$, P%)
                                Record$ = Temp2$
                                Length% = LEN(Record$)
                                Temp$ = Record$
                                IF Length% > 78 THEN
                                    FOR X% = 1 TO Length%
                                        Posn% = QInstrB%(-1, Temp$, " ")
                                        IF Posn% <= 78 THEN
                                            Temp1$ = LEFT$(Record$, Posn% - 1)
                                            Temp2$ = QPTrim$(MID$(Record$, Posn%))
                                            EXIT FOR
                                        ELSEIF Posn% THEN
                                            Temp$ = LEFT$(Record$, Posn% - 1)
                                        END IF
                                    NEXT
                                    PRINT #4, Temp1$
                                    CALL Wordwrap(Temp2$, 50, 28)
                                ELSE PRINT #4, Record$
                                END IF
                                PRINT #4, STRING$(78, 196)
                            END IF
                        END IF
                    END IF
                ELSE
                    IF DE% THEN
                      'DO NOTHING
                    ELSE
                        PRINT #OutFile%, Record$
                    END IF
                END IF
            LOOP
        END IF
        IF NoMatch% THEN
          
         '  PRINT Path$; "No match found on Files.bbs. "; "("; ArcFile$; ")"
            PRINT Dt$; TIME$; " RJUT "; Path$; "No match on Files.bbs. "; "("; ArcFile$; ")"
            IF ActivityLog% THEN
                PRINT #4, Path$; "No match found on Files.bbs. "; "("; ArcFile$; ")"
                PRINT #4, WhoGot$
                PRINT #4, STRING$(78, 196)
            END IF
        END IF
        CLOSE #Infile%: CLOSE #OutFile%
        CALL FCopy("Temp.$$$", FilesBBSName$, SPACE$(4096), ErrCode%)
        IF Exist%("Temp.$$$") THEN
            KILL "Temp.$$$"
        END IF
    END SUB

    SUB Help
        CLS
        Temp$ = "RJ's Files.bbs Download Counter Program - " + Version
        Temp2$ = "by R.J.(Bob) Ross"
        Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT TAB(40 - LEN(Temp$) / 2); Temp$
        PRINT TAB(40 - LEN(Temp2$) / 2); Temp2$
        PRINT TAB(40 - LEN(Temp3$) / 2); Temp3$
        PRINT STRING$(78, 196)
        PRINT "  Purpose:  To read a Binkley and/or Max log file and update the"
        PRINT "            download counter field and the year/month last downloaded"
        PRINT "            field. Optionally, will generate a download/file request"
        PRINT "            activity log using the -O switch."
        PRINT "            Note:  If the -A switch is used, RJDLC will create a lookup"
        PRINT "                   table (RJDLC.TBL) from the Maximus Areas.dat file."
        PRINT "                   This allows updating of counters for CD-ROMS and files.bbs"
        PRINT "                   files which are not stored in the same directory or use"
        PRINT "                   the file name Files.bbs."
        PRINT STRING$(78, 196)
        PRINT " Switches:"
        PRINT
        PRINT "    -I      -IDrive:\Path\Binkley.log"
        PRINT
        PRINT "    -O      -ODrive:\Path\RJDLC.log [optional]"
        PRINT
        PRINT "    -A      -ADrive:\Path\Area.dat [optional]"
      
    END SUB

    SUB InputLine (IOCHAN, BUFSIZE, STATUS, TEXT$) STATIC
      
      '[]=============================================================[]
      '[]        Inputs a line of text from the specified file        []
      '[]=============================================================[]
      
        STATIC TOTBYTES&        ' Total #bytes in file
        STATIC BYTES&           ' #Bytes read so far
        STATIC SEEKPOS&         ' Seek position in file
        STATIC SPOS             ' Start of line in buffer
      
      ' Initialize if this is the first call
      
        IF STATUS = 1 THEN
            STATUS = 0
            TOTBYTES& = LOF(IOCHAN)
            BYTES& = 0
            SEEKPOS& = 1
            BUFFER$ = STRING$(BUFSIZE, 0)
            SPOS = 1
        END IF
      
        EPOS = INSTR(SPOS, BUFFER$, CRLF$)
        IF EPOS <> 0 THEN
          '
          ' Easy - have a full line
          '
            TEXT$ = MID$(BUFFER$, SPOS, EPOS - SPOS)
        ELSE
          ' Partial line - read the next block
          '  and assemble the full line
          '
            IF LEFT$(BUFFER$, 1) = CHR$(0) THEN
                TEXT$ = ""
            ELSE
                TEXT$ = MID$(BUFFER$, SPOS, BUFSIZE - SPOS + 1)
            END IF
            IF (SEEKPOS& + BUFSIZE) > TOTBYTES& THEN
                BUFSIZE = TOTBYTES& - SEEKPOS& + 1
                BUFFER$ = STRING$(BUFSIZE, 0)
            END IF
            GET #IOCHAN, SEEKPOS&, BUFFER$
            BYTES& = BYTES& + BUFSIZE
            SEEKPOS& = SEEKPOS& + BUFSIZE
            IF BYTES& = TOTBYTES& THEN
              '
              ' Last block needs ending CRLF
              '
                IF RIGHT$(BUFFER$, 2) <> CRLF$ THEN
                    BUFFER$ = BUFFER$ + CRLF$
                    BUFSIZE = BUFSIZE + 2
                END IF
            END IF
            IF RIGHT$(TEXT$, 1) = CR$ THEN
              '
              ' Special case - CR at end of previous block
              '
                TEXT$ = LEFT$(TEXT$, LEN(TEXT$) - 1)
                EPOS = 0
            ELSE
                EPOS = INSTR(1, BUFFER$, CRLF$)
                TEXT$ = TEXT$ + MID$(BUFFER$, 1, EPOS - 1)
            END IF
        END IF
      
      ' Point to start of next line
      
        SPOS = EPOS + 2
      
      ' All done? If so set status and deallocate buffer
      
        IF (BYTES& = TOTBYTES& AND EPOS = (BUFSIZE - 1)) THEN
            BUFFER$ = ""        ' This doesn't ERASE
            STATUS = -1
        END IF
      
    END SUB

    FUNCTION ItsAFile (Work$)
      
      'Determine by the extension on the filename if it's
      'Mail or a file.
      
        P% = INSTR(28, Work$, ".")
        IF P% THEN
            Extension$ = MID$(Work$, P% + 1, 2)
            SELECT CASE UCASE$(Extension$)
            CASE IS = "MO", "TU", "WE", "TH", "FR", "SA", "SU", "OU", "PK", "CU", "HU", "DU", "RS", "RE", "TI"
              'Not interested - it's mail
                ItsAFile% = False
            CASE IS = "QW"
              'Not interested - it's mail
                ItsAFile% = False
            CASE ELSE
                ItsAFile% = True
            END SELECT
        END IF
      
    END FUNCTION

    FUNCTION Month$ (MnthName$) STATIC
      'SelECT CASE MID$(Record$, 6, 3)
        SELECT CASE MnthName$
        CASE IS = "Jan"
            Month$ = "01"
        CASE IS = "Feb"
            Month$ = "02"
        CASE IS = "Mar"
            Month$ = "03"
        CASE IS = "Apr"
            Month$ = "04"
        CASE IS = "May"
            Month$ = "05"
        CASE IS = "Jun"
            Month$ = "06"
        CASE IS = "Jul"
            Month$ = "07"
        CASE IS = "Aug"
            Month$ = "08"
        CASE IS = "Sep"
            Month$ = "09"
        CASE IS = "Oct"
            Month$ = "10"
        CASE IS = "Nov"
            Month$ = "11"
        CASE IS = "Dec"
            Month$ = "12"
        CASE ELSE
            Month$ = "**"
        END SELECT
      
    END FUNCTION

    SUB ParsePthFilN (Work$, Pth$, FileN$)
      '
      'Separate the Path and Filename
      '
        P% = QInstrB%(-1, Work$, " ")
        IF P% THEN
            PthF$ = MID$(Work$, P% + 1)
            P% = QInstrB%(-1, PthF$, "\")
            IF P% THEN
                Pth$ = LEFT$(PthF$, P%)
                FileN$ = MID$(PthF$, P% + 1)
            END IF
        END IF
    END SUB

    SUB Wordwrap (X$, Wide, LeftMargin) STATIC
      
        DO WHILE LEN(X$)        ' Loop while we have text
          ' find a place to break the line
            Pointer% = Wide + 1
            DO UNTIL MID$(X$, Pointer%, 1) = " " OR Pointer% = 1 OR Pointer% > LEN(X$)
                Pointer% = Pointer% - 1
            LOOP
          ' handle unbreakable text
            IF Pointer% = 1 THEN Pointer% = Wide + 1
            PRINT #4, TAB(LeftMargin%); LEFT$(X$, Pointer% - 1) ' dump the line
            X$ = MID$(X$, Pointer% + 1)
        LOOP
      
    END SUB

