    '********************************************************************
    '** Program Name: RJDUP                                            **
    '** Date Started: February 24, 1995                                **
    '**      Version: 1.00 - completed February 25, 1995               **
    '**      Last compiled - March 9th, 1995                           **
    '**                                                                **
    '**      Purpose: To remove duplicate filenames/descriptions from  **
    '**               files.bbs files.                                 **
    '**               Last compiled March 29th, 1995                   **
    '**                                                                **
    '**     Language: Microsoft QuickBASIC 4.5                         **
    '**    Libraries: Crescent Software Inc QuickPak Professional      **
    '**               Crescent Software Inc P.D.Q.                     **
    '**         Note: Had to remove the On Error Trap in order for     **
    '**               the program to run when compiled with P.D.Q.     **
    '********************************************************************
    DEFINT A-Z

    DECLARE FUNCTION ErrorMsg$ (ErrorNumber%)
    DECLARE FUNCTION Exist% (FileName$)
    DECLARE SUB Help ()
    DECLARE FUNCTION QPTrim$ (Var$)
    DECLARE FUNCTION CurrentDate$ ()
  
    CLS
    CONST False = 0
    CONST True = NOT False
    CONST Version = "RJDUP Version 1.00"
    Dt$ = CurrentDate$
    Ctr% = 0
    Pass% = 1
    Duplicates% = 0
    FilesBBS% = 0
    Cfg% = 10
    PRINT
    PRINT Dt$; TIME$; " RJUT Begin "; Version

   ' use if not using P.D.Q. Library
   ' ON ERROR GOTO Bomb

    CmdLine$ = UCASE$(COMMAND$)

  'Look for a Config file
    P% = INSTR(CmdLine$, "-C")
    IF P% THEN
        ConfigFile$ = RTRIM$(MID$(CmdLine$, 3))
        ConfigFile% = True
        IF Exist%(ConfigFile$) THEN
            OPEN ConfigFile$ FOR INPUT AS #Cfg%
            IF LOF(Cfg%) = 0 THEN
                CLOSE Cfg%
                PRINT Dt$; TIME$; " RJUT "; ConfigFile$; " is empty."
                PRINT Dt$; TIME$; " RJUT End RJDUP"
                END
            END IF
        ELSE
            BEEP
            PRINT Dt$; TIME$; " RJUT Config file "; ConfigFile$; "  NOT found."
            PRINT Dt$; TIME$; " RJUT End RJDUP"
            END
        END IF
      'No command line option given - display help screen.
    ELSEIF CmdLine$ = "" THEN
        CALL Help
        END
    ELSE
      'Files.bbs file name was given on the command lane.
        FilesBBS$ = LTRIM$(CmdLine$)
        ConfigFile% = False
        FilesBBS% = True
    END IF
    CLOSE Cfg%
    IF FilesBBS% THEN
        IF Exist%(FilesBBS$) THEN
            P% = INSTR(FilesBBS$, ".")
            IF P% THEN
                FilesBak$ = LEFT$(FilesBBS$, P%) + "bak"
            END IF
        ELSE
            BEEP
            PRINT Dt$; TIME$; " RJUT File not found: "; FilesBBS$
            END
        END IF
      
    ELSEIF ConfigFile% THEN
        OPEN ConfigFile$ FOR INPUT AS #Cfg%
        DO UNTIL EOF(Cfg%)
            DO UNTIL EOF(Cfg%)
                LINE INPUT #Cfg%, ConfigRec$
                ConfigRec$ = UCASE$(LTRIM$(ConfigRec$))
                IF LEFT$(ConfigRec$, 12) = "AREAFILESBBS" THEN
                    FilesBBS$ = QPTrim$(MID$(ConfigRec$, 13))
                ELSE
                    EXIT DO
                END IF
                IF Exist%(FilesBBS$) THEN
                    P% = INSTR(FilesBBS$, ".")
                    IF P% THEN
                        FilesBak$ = LEFT$(FilesBBS$, P%) + "bak"
                    END IF
                ELSE
                    BEEP
                    PRINT Dt$; TIME$; " RJUT File not found: "; FilesBBS$
                    EXIT DO
                END IF
                CLOSE 1
                CLOSE 2
                GOSUB CheckForDupes
            LOOP
        LOOP
    END IF
  
    IF FilesBBS% THEN
        GOSUB CheckForDupes
    END IF
  
    IF Exist%("rjdup.$$$") THEN KILL "rjdup.$$$"
    PRINT Dt$; TIME$; " RJUT End RJDUP"
    END
  
CheckForDupes:
    Ctr% = 0
    CLOSE 1
    OPEN FilesBBS$ FOR INPUT AS #1
    OPEN "rjdup.$$$" FOR OUTPUT AS #2
    DO UNTIL EOF(1)
        LINE INPUT #1, Record$
        P% = INSTR(Record$, ".")
        IF P% THEN
            IF P% < 10 AND LEFT$(Record$, 1) <> " " THEN
                P% = INSTR(Record$, " ")
                IF P% THEN
                    Ctr% = Ctr% + 1
                    FileName$ = LEFT$(Record$, P% - 1)
                    PRINT #2, FileName$
                END IF
            END IF
        END IF
    LOOP
    CLOSE 1
    CLOSE 2

    IF Ctr% > 1 THEN
        REDIM FlName$(1 TO Ctr%)
        CLOSE 1
        OPEN "rjdup.$$$" FOR INPUT AS #1
        FOR X% = 1 TO Ctr%
            LINE INPUT #1, FlName$(X%)
        NEXT
        CLOSE 1
        KILL "rjdup.$$$"
        CALL SortStr(BYVAL VARPTR(FlName$(1)), Ctr%, 0)
    ELSE
        PRINT Dt$; TIME$; " RJUT No duplicates in: "; FilesBBS$
        RETURN
    END IF
    Duplicates% = False
    OPEN "rjdup.$$$" FOR OUTPUT AS #1
    FOR X% = 1 TO Ctr%
        IF X% < Ctr% THEN
            IF FlName$(X%) = FlName$(X% + 1) THEN
                PRINT #1, FlName$(X%)
                PRINT Dt$; TIME$; " RJUT Duplicate found: "; FlName$(X%)
                Duplicates% = -1
            END IF
        END IF
    NEXT
    CLOSE 1
    IF Duplicates% THEN
        OPEN "rjdup.$$$" FOR INPUT AS #1
        CALL FCopy(FilesBBS$, FilesBak$, SPACE$(4096), ErrorCode%)
        DO UNTIL EOF(1)
            OPEN FilesBBS$ FOR INPUT AS #2
            PRINT Dt$; TIME$; " RJUT Removing Dupe from: "; FilesBBS$
            P% = INSTR(FilesBBS$, ".")
            FilesDup$ = LEFT$(FilesBBS$, P%) + "Dup"
            OPEN FilesDup$ FOR OUTPUT AS #3
            LINE INPUT #1, FileName$
            DO UNTIL EOF(2)
                LINE INPUT #2, Record$
                IF LEFT$(Record$, LEN(FileName$)) = FileName$ THEN
                  'do nothing
                    FileName$ = "~~~$$$.***"
                ELSE
                    PRINT #3, Record$
                END IF
            LOOP
            CLOSE 2
            CLOSE 3
            KILL FilesBBS$
            NAME FilesDup$ AS FilesBBS$
        LOOP
    ELSE
        PRINT Dt$; TIME$; " RJUT No Duplicates in: "; FilesBBS$
        Duplicates% = False
    END IF
    RETURN

' Error trap if compiled not using P.D.Q.
'Bomb:
'   CALL Chime(1)
'   PRINT "Program bombed as a result of: "; ErrorMsg$(ERR)
'   END

    FUNCTION CurrentDate$ STATIC
        Dt$ = DATE$
        Mnth$ = LEFT$(Dt$, 2)
        SELECT CASE Mnth$
        CASE IS = "01"
            Month$ = "Jan"
        CASE IS = "02"
            Month$ = "Feb"
        CASE IS = "03"
            Month$ = "Mar"
        CASE IS = "04"
            Month$ = "Apr"
        CASE IS = "05"
            Month$ = "May"
        CASE IS = "06"
            Month$ = "Jun"
        CASE IS = "07"
            Month$ = "Jul"
        CASE IS = "08"
            Month$ = "Aug"
        CASE IS = "09"
            Month$ = "Sep"
        CASE IS = "10"
            Month$ = "Oct"
        CASE IS = "11"
            Month$ = "Nov"
        CASE IS = "12"
            Month$ = "Dec"
        END SELECT
        CurrentDate$ = "  " + MID$(Dt$, 4, 2) + " " + Month$ + " "
      
    END FUNCTION

DEFSNG A-Z
    SUB Help
        CLS
        Temp$ = "RJ's Files.bbs Duplicate Filename Remover - " + Version
        Temp2$ = "by R.J.(Bob) Ross"
        Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT TAB(40 - LEN(Temp$) \ 2); Temp$
        PRINT TAB(40 - LEN(Temp2$) \ 2); Temp2$
        PRINT TAB(40 - LEN(Temp3$) \ 2); Temp3$
        PRINT STRING$(78, 196)
        PRINT "  Purpose:  To scan Files.bbs files and remove all duplicated filenames"
        PRINT "            along with the file descriptions and update the files.bbs file."
        PRINT STRING$(78, 196)
        PRINT " Switches:"
        PRINT
        PRINT "            -CDrive:\Path\Cfg.cfg"
        PRINT "    or"
        PRINT "            Drive:\Path\files.bbs"
        PRINT
        PRINT
        PRINT

      
    END SUB

