  '************************************************************************
  '**       Program:  RJFA -  File Announcement                          **
  '**                         Name changed from RJTFA                    **
  '**        Author:  R.J.(Bob) Ross                                     **
  '**                 SysOp - RJ's Byteline BBS - FidoNet 1:134/75       **
  '**  Date Started:  October 22nd, 1994                                 **
  '**       Version:  .01 Beta - completed October 23, 1994              **
  '**                 .02 Beta - completed October 31, 1994              **
  '**                 .03 Beta - completed November 7, 1994              **
  '**                 .04 Beta - completed November 22, 1994             **
  '**                 .05 Beta - completed December 15, 1994             **
  '**                 1.00     - completed February 21, 1995             **
  '**                 Last compiled - March 9th, 1995                    **
  '**                                                                    **
  '**       Purpose:  To produce a text file announcing file arrivals    **
  '**                 either via Tick or uploaded and optionally         **
  '**                 produce a Config file for use by program RJFFM     **
  '**                 to format the files.bbs counter and year/month     **
  '**                 display. Also will produce batch file RJFB.BAT     **
  '**                 to run Maximus FB to update the file index files   **
  '**                                                                    **
  '**      Language:  Microsoft QuickBASIC 4.5                           **
  '**                 Cresent Software Inc - QuickPak Professional       **
  '**                                                                    **
  '************************************************************************
  '
    DEFINT A-Z
    DECLARE FUNCTION Date2Day% (D$)
    DECLARE FUNCTION Date2Num% (Dat$)
    DECLARE FUNCTION ErrorMsg$ (ErrorNumber%)
    DECLARE FUNCTION Num2Day% (Days%)
    DECLARE FUNCTION DayName$ (Day%)
    DECLARE FUNCTION MonthName$ (Month%)
    DECLARE FUNCTION Exist% (Filename$)
    DECLARE SUB FileView (Filename$, Ky, Action, FVI AS ANY, SEG Array)
    DECLARE FUNCTION FindLast% (BYVAL Address, Size)
    DECLARE SUB Help ()
    DECLARE FUNCTION ParseString$ (CurPos%, Work$, Delimit$)
    DECLARE FUNCTION QInstrB% (StartPos%, Source$, Search$)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION QPValI% (Work$)
    DECLARE FUNCTION QPValL& (Work$)
    DECLARE SUB WordWrap (X$, Wide, LeftMargin)
    CONST False = 0
    CONST True = NOT False
    CONST Version = "RJFA Version 1.00"
    DIM Array$(0 TO 1)
    DIM LogFile$(0 TO 15)
    DIM SuppressArea$(1 TO 15)
  
    AreaDat% = False
    CfgFile% = False
    AnnounceFile% = False
    OutPutCfg% = False
    ShowPath% = False
    ShowLogNames% = False
    SuppressArea% = False
    Skip% = False
    NoLogFile% = False
  
    BBSName$ = "No BBS Name Stated in Configuration File"
    SysOp$ = "Unknown"
  
    ON ERROR GOTO Bomb
  
    CmdLine$ = UCASE$(COMMAND$)
  
  'No command line options given
    IF CmdLine$ = "" THEN
        CALL Help
        END
    END IF
  
  'Look for a Config file
    P% = INSTR(CmdLine$, "-C")
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            ConfigFile$ = LEFT$(Temp$, P% - 1)
        ELSE
            ConfigFile$ = Temp$
        END IF
        CfgFile% = True
    END IF
  
  'Output File Arrival announcement text file
    P% = INSTR(CmdLine$, "-O")
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            AnnounceFile$ = LEFT$(Temp$, P% - 1)
        ELSE
            AnnounceFile$ = Temp$
        END IF
        AnnounceFile% = True
    END IF
  
    IF CfgFile% AND AnnounceFile% THEN
      'do nothing
    ELSE
        PRINT "Use of both -C and -O switches are mandatory!"
        END
    END IF
  
    IF Exist%(ConfigFile$) THEN
        OPEN ConfigFile$ FOR INPUT AS #1
        DO UNTIL EOF(1)
            DO UNTIL EOF(1)
                LINE INPUT #1, Record$
                IF LEFT$(Record$, 1) = ";" THEN
                    EXIT DO
                END IF
                Record$ = LTRIM$(Record$)
                IF UCASE$(LEFT$(Record$, 7)) = "BBSNAME" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        BBSName$ = QPTrim$(MID$(Record$, P%))
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 5)) = "SYSOP" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        SysOp$ = "SysOp: " + QPTrim$(MID$(Record$, P%))
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 9)) = "OUTPUTCFG" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        OutPutCfg$ = QPTrim$(MID$(Record$, P%))
                        OutPutCfg% = True
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 12)) = "SUPPRESSAREA" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        SuppressArea% = SuppressArea% + 1
                        SuppressArea$(SuppressArea%) = QPTrim$(MID$(Record$, P%))
                        IF RIGHT$(SuppressArea$(SuppressArea%), 1) <> "\" THEN
                            SuppressArea$(SuppressArea%) = SuppressArea$(SuppressArea%) + "\"
                        END IF
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 7)) = "AREADAT" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        AreaDat$ = QPTrim$(MID$(Record$, P%))
                        AreaDat% = True
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 11)) = "ARRIVALLOGS" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        Logfiles$ = QPTrim$(MID$(Record$, P%))
                    END IF
                    LF% = 0
                    Posn% = 1
                    DO
                        LogFile$(LF%) = ParseString$(Posn%, Logfiles$, ",")
                        LF% = LF% + 1
                    LOOP UNTIL Posn% = LEN(Logfiles$) OR LF% = 15
                    Lastlog% = FindLast%(BYVAL VARPTR(LogFile$(15)), 15)
                    FOR X% = 0 TO Lastlog%
                        LogFile$(X%) = QPTrim$(LogFile$(X%))
                    NEXT
                ELSEIF UCASE$(LEFT$(Record$, 8)) = "SHOWPATH" THEN
                    ShowPath% = True
                ELSEIF UCASE$(LEFT$(Record$, 5)) = "NOTE1" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        Note1$ = QPTrim$(MID$(Record$, P%))
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 5)) = "NOTE2" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        Note2$ = QPTrim$(MID$(Record$, P%))
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 5)) = "NOTE3" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        Note3$ = QPTrim$(MID$(Record$, P%))
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 5)) = "NOTE4" THEN
                    P% = INSTR(Record$, " ")
                    IF P% THEN
                        Note4$ = QPTrim$(MID$(Record$, P%))
                    END IF
                ELSEIF UCASE$(LEFT$(Record$, 16)) = "SHOWLOGNAMESUSED" THEN
                    ShowLogNames% = True
                ELSE EXIT DO
                END IF
            LOOP
        LOOP
        CLOSE 1
    ELSE
        CALL Chime(4)
        PRINT "Configuration file "; ConfigFile$; " not found."
        CLOSE
        END
    END IF
  
    IF NOT Exist%(LogFile$(0)) THEN
        NoLogFile% = True
    END IF
  
    IF OutPutCfg% THEN
        OPEN "RJTFA.$$$" FOR OUTPUT AS #4
    END IF
  
    OPEN AnnounceFile$ FOR OUTPUT AS #3
  
    Day% = Date2Day%(DATE$)
    Dy% = QPValI%(MID$(DATE$, 4, 2))
    Dy$ = STR$(Dy%)
    Mo% = QPValI%(LEFT$(DATE$, 2))
    Yr$ = RIGHT$(DATE$, 4)
    SELECT CASE Dy%
    CASE 1, 21, 31
        Suffix$ = "st"
    CASE 2, 22
        Suffix$ = "nd"
    CASE 3, 23
        Suffix$ = "rd"
    CASE ELSE
        Suffix$ = "th"
    END SELECT
    Temp$ = "Files Received at"
    AsOf$ = "As of: " + TIME$ + " Hrs -- " + DayName$(Day%) + "," + Dy$ + Suffix$ + " of " + MonthName$(Mo%) + ", " + Yr$
  
    PRINT #3, TAB(40 - LEN(Version) / 2); Version
    PRINT #3, TAB(40 - LEN(Temp$) / 2); Temp$
    PRINT #3, TAB(40 - LEN(BBSName$) / 2); BBSName$
    PRINT #3, TAB(40 - LEN(SysOp$) / 2); SysOp$
    PRINT #3, TAB(40 - LEN(AsOf$) / 2); AsOf$
    PRINT #3, STRING$(75, 196)
    FileArrived% = 0
    CLS
    Ln% = CSRLIN
    IF Ln% = 24 THEN Ln% = 23
    Ctr% = 1
    IF NOT NoLogFile% THEN
        DO UNTIL CountLogs% = Lastlog% + 1
            DO UNTIL CountLogs% = Lastlog% + 1
                IF NOT Exist%(LogFile$(CountLogs%)) THEN
                    IF CountLogs% <= Lastlog% THEN
                        LogFile$(CountLogs%) = LogFile$(CountLogs%) + "(Not Found!)"
                        BEEP
                        LOCATE Ln% + 1, 1: PRINT SPACE$(40)
                        LOCATE Ln% + 1, 1
                        PRINT TAB(1); LogFile$(CountLogs%)
                        SLEEP 1
                        PRINT
                        CountLogs% = CountLogs% + 1
                        EXIT DO
                    END IF
                END IF
                OPEN LogFile$(CountLogs%) FOR INPUT ACCESS READ SHARED AS #2
                PRINT
                LOCATE Ln% + 1, 1: PRINT SPACE$(40)
                LOCATE Ln% + 1, 1
                PRINT "Opening: "; LogFile$(CountLogs%)
                CountLogs% = CountLogs% + 1
                DO UNTIL EOF(2)
                    LINE INPUT #2, Record$
                    Ctr% = Ctr% + 1
                    GOSUB Searching
                    P% = INSTR(19, Record$, "TICK")
                    IF P% THEN
                        P% = INSTR(23, Record$, "Moving")
                        IF P% THEN
                          ' Posn% = QInstrB%(56, Record$, "to")
                            Posn% = QInstrB%(-1, Record$, "to")
                            Filename$ = MID$(Record$, Posn% + 3)
                            Posn% = QInstrB(-1, Filename$, "\")
                            IF Posn% THEN
                                SupPath$ = UCASE$(LEFT$(Filename$, Posn%))
                            END IF
                            IF SuppressArea% THEN
                                FOR X% = 1 TO SuppressArea%
                                    IF SuppressArea$(X%) = SupPath$ THEN
                                        Skip% = True
                                    END IF
                                NEXT
                            END IF
                            IF Skip% THEN
                              ' do nothing
                            ELSE
                                FileArrived% = -1
                                Array$(1) = SPACE$(37)
                                Array$(0) = Filename$
                                CALL ReadFileI(BYVAL VARPTR(Array$(0)))
                                LINE INPUT #2, Record$
                                Area$ = MID$(Record$, 24)
                                LINE INPUT #2, Record$
                                Title$ = MID$(Record$, 24)
                                IF ShowPath% THEN
                                    PRINT #3, " FILE: "; UCASE$(Filename$);
                                ELSE
                                    Posn% = QInstrB(-1, Filename$, "\")
                                    IF Posn% THEN
                                        PRINT #3, " FILE: "; UCASE$(MID$(Filename$, Posn% + 1));
                                    END IF
                                END IF
                                PRINT #3, TAB(59); MID$(Array$(1), 14, 18)
                                PRINT #3, "TITLE: ";
                                CALL WordWrap(Title$, 50, 8)
                                PRINT #3, " "; Area$
                                PRINT #3, STRING$(75, 196)
                                Filecount% = Filecount% + 1
                                TotFileSize& = TotFileSize& + QPValL(MID$(Array$(1), 14, 8))
                                IF OutPutCfg% THEN
                                    Posn% = QInstrB(-1, Filename$, "\")
                                    IF Posn% THEN
                                        PRINT #4, "AreaFilesBBS    ";
                                        PRINT #4, LEFT$(Filename$, Posn%); "files.bbs"
                                    END IF
                                END IF
                            END IF
                            Skip% = False
                        END IF
                    END IF
                    P% = INSTR(19, Record$, "MAX  UL-")
                    IF P% THEN
                        Skip% = False
                        Posn% = QInstrB%(-1, Record$, " ")
                        IF Posn% THEN
                            Filename$ = MID$(Record$, Posn% + 1)
                            Posn% = QInstrB%(-1, Filename$, "\")
                            IF Posn% THEN
                                Path$ = LEFT$(Filename$, Posn%)
                                Path$ = QPTrim$(Path$)
                                Filname$ = UCASE$(MID$(Filename$, Posn% + 1))
                            END IF
                            IF SuppressArea% THEN
                                FOR X% = 1 TO SuppressArea%
                                    IF SuppressArea$(X%) = UCASE$(Path$) THEN
                                        Skip% = True
                                    END IF
                                NEXT
                            END IF
                          
                            IF Skip% THEN
                              'do nothing
                            ELSE
                              
                                IF Exist%(Path$ + "files.bbs") THEN
                                    Ross$ = Path$ + "files.bbs"
                                    OPEN Path$ + "Files.bbs" FOR INPUT AS #6
                                    DO UNTIL EOF(6)
                                        LINE INPUT #6, Record$
                                        IF UCASE$(LEFT$(Record$, LEN(Filname$))) = UCASE$(Filname$) THEN
                                            FileArrived% = -1
                                            Title$ = MID$(Record$, LEN(Filename$) + 1)
                                            Array$(1) = SPACE$(37)
                                            Array$(0) = Filename$
                                            CALL ReadFileI(BYVAL VARPTR(Array$(0)))
                                            IF ShowPath% THEN
                                                PRINT #3, " FILE: "; UCASE$(Filename$);
                                            ELSE
                                                PRINT #3, " FILE: "; UCASE$(Filname$);
                                            END IF
                                            PRINT #3, TAB(59); MID$(Array$(1), 14, 18)
                                            PRINT #3, "TITLE: ";
                                            CALL WordWrap(Title$, 50, 8)
                                            PRINT #3,
                                            PRINT #3, STRING$(75, 196)
                                            IF OutPutCfg% THEN
                                                PRINT #4, "AreaFilesBBS    ";
                                                PRINT #4, Path$ + "Files.bbs"
                                            END IF
                                            Filecount% = Filecount% + 1
                                            TotFileSize& = TotFileSize& + QPValL(MID$(Array$(1), 14, 8))
                                        END IF
                                    LOOP
                                END IF
                            END IF
                            Skip% = False
                            CLOSE 6
                        END IF
                    END IF
                LOOP
                CLOSE 2
            LOOP
        LOOP
    END IF
    IF OutPutCfg% THEN
        IF Filecount% > 0 THEN
            PRINT #4, STRING$(30, 254)
            CLOSE 4
            REDIM SArray$(1 TO Filecount% + 1)
            OPEN "RJTFA.$$$" FOR INPUT AS #4
            FOR X% = 1 TO Filecount% + 1
                LINE INPUT #4, SArray$(X%)
            NEXT
            CLOSE 4
            CALL SortStr(BYVAL VARPTR(SArray$(1)), Filecount% + 1, 0)
            OPEN "RJTFA.$$$" FOR OUTPUT AS #4
            FOR X% = 1 TO Filecount% + 1
                PRINT #4, SArray$(X%)
            NEXT
            CLOSE 4
          
            OPEN "rjtfa.$$$" FOR INPUT AS #4
            OPEN OutPutCfg$ FOR OUTPUT AS #5
          
            LINE INPUT #4, Record1$
            DO
                DO
                    IF EOF(4) THEN
                        EXIT DO
                    END IF
                    IF Record2$ = "" THEN
                        LINE INPUT #4, Record2$
                    END IF
                    IF Record1$ = Record2$ THEN
                      'get next record
                        LINE INPUT #4, Record2$
                    END IF
                LOOP UNTIL Record1$ <> Record2$
                IF Record1$ = Record2$ THEN
                    PRINT #5, Record1$
                ELSE
                    IF Record1$ > "" THEN
                        PRINT #5, Record1$
                    END IF
                END IF
                Record1$ = Record2$
                IF EOF(4) THEN EXIT DO
                LINE INPUT #4, Record2$
            LOOP UNTIL Record1$ = STRING$(30, 254)
            CLOSE 4
            CLOSE 5
            IF OutPutCfg% AND AreaDat% THEN
                IF Exist%(AreaDat$) THEN
                    P% = QInstrB%(-1, AreaDat$, "\")
                    IF P% THEN
                        FBPath$ = LEFT$(AreaDat$, P%)
                        OPEN FBPath$ + "RJFB.BAT" FOR OUTPUT AS #7
                        PRINT #7, "FB "; AreaDat$;
                        OPEN AreaDat$ FOR BINARY ACCESS READ AS #1
                        OPEN OutPutCfg$ FOR INPUT AS #2
                        NxtRecord& = 0
                      'Get the Record Length
                      '---------------------
                        SEEK 1, 5
                        GET 1, , Length%
                        DO UNTIL EOF(2)
                            NxtRecord& = 0
                            LINE INPUT #2, Record$
                            Record$ = QPTrim$(Record$)
                            Temp$ = QPTrim$(MID$(Record$, 13))
                            P% = QInstrB%(-1, Temp$, "\")
                            IF P% THEN
                                Path$ = LEFT$(Temp$, P%)
                            END IF
                          'First Record
                          '------------
                            SEEK 1, 9
                            AreaNumber$ = INPUT$(8, 1)
                            AreaNumber$ = QPTrim$(AreaNumber$)
                            SEEK 1, 399
                            FileAreaPath$ = INPUT$(80, 1)
                            IF LEFT$(FileAreaPath$, 1) = CHR$(0) THEN EXIT DO
                            FileAreaPath$ = QPTrim$(FileAreaPath$)
                            IF UCASE$(FileAreaPath$) = UCASE$(Path$) THEN
                                PRINT #7, " "; AreaNumber$;
                                PRINT " "; AreaNumber$;
                            END IF
                          'All Remaining Records
                          '---------------------
                            DO UNTIL EOF(1)
                                DO UNTIL EOF(1)
                                    NxtRecord& = NxtRecord& + Length%
                                    SEEK 1, NxtRecord& + 9
                                    AreaNumber$ = INPUT$(8, 1)
                                    AreaNumber$ = QPTrim$(AreaNumber$)
                                    SEEK 1, NxtRecord& + 399
                                    FileAreaPath$ = INPUT$(80, 1)
                                    IF LEFT$(FileAreaPath$, 1) = CHR$(0) THEN EXIT DO
                                    FileAreaPath$ = QPTrim$(FileAreaPath$)
                                    IF UCASE$(FileAreaPath$) = UCASE$(Path$) THEN
                                        PRINT #7, " "; AreaNumber$;
                                        PRINT " "; AreaNumber$;
                                        EXIT DO
                                    END IF
                                LOOP
                            LOOP
                        LOOP
                        CLOSE #1, #2, #7
                    END IF
                END IF
            END IF
        ELSE
            IF Filecount% = 0 THEN
                OPEN OutPutCfg$ FOR OUTPUT AS #5
                CLOSE 5
            END IF
        END IF
    END IF
  
    IF Exist%("rjtfa.$$$") THEN
        IF FileArrived% = 0 THEN
            IF OutPutCfg% THEN
                CLOSE 4
                KILL "rjtfa.$$$"
            END IF
        ELSE
            KILL "rjtfa.$$$"
        END IF
    END IF
  
    IF FileArrived% THEN
        PRINT #3, ""; STRING$(73, 205); ""
        PRINT #3, " TOTAL FILES RECEIVED: "; Filecount%;
        PRINT #3, TAB(43); "TOTAL BYTES: ";
        PRINT #3, USING "###,###,###"; TotFileSize&;
        PRINT #3, TAB(75); ""
        PRINT #3, ""; STRING$(73, 205); ""
        GOSUB ShowNotes
        IF ShowLogNames% THEN
            GOSUB LogNames
        END IF
        CLOSE 3
    ELSE
        IF NoLogFile% THEN
            PRINT #3,
            PRINT #3, "Log File "; LogFile$(0); " not found!"
            PRINT #3,
            GOSUB ShowNotes
        ELSE
            PRINT #3, "No files received during the Log period."
            GOSUB ShowNotes
        END IF
        IF ShowLogNames% THEN
            GOSUB LogNames
        END IF
        CLOSE 3
    END IF
  
    IF INSTR(COMMAND$, "-L") THEN
      'do nothing
    ELSE
        CALL Chime(10)
        Title$ = "RJ's File Announcemnt Program " + Version
        See$ = "See File " + AnnounceFile$ + " for a detailed listing."
        IF OutPutCfg% THEN
            Cfg$ = "Output Configuration file produced: " + OutPutCfg$
        END IF
        PRINT
        PRINT TAB(40 - LEN(Title$) / 2); Title$
        PRINT SPACE$(30); "by R.J.(Bob) Ross"
        PRINT SPACE$(18); "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT STRING$(78, 196)
        PRINT
        PRINT
        PRINT ""; STRING$(73, 205); ""
        PRINT " TOTAL FILES ARRIVED: "; Filecount%;
        PRINT TAB(43); "TOTAL BYTES: ";
        PRINT USING "###,###,###"; TotFileSize&;
        PRINT TAB(75); ""
        PRINT ""; STRING$(73, 205); ""
        PRINT
        PRINT
        PRINT TAB(40 - LEN(See$) / 2); See$
        IF OutPutCfg% THEN
            PRINT
            PRINT TAB(40 - LEN(Cfg$) / 2); Cfg$
        END IF
        IF AreaDat% THEN
            Ad$ = "Maximus FB batch file produced as: " + FBPath$ + "RJFB.BAT"
            PRINT
            PRINT TAB(40 - LEN(Ad$) / 2); Ad$
        END IF
        Ln% = CSRLIN
        IF Ln% < 24 THEN
            FOR X% = Ln% TO 24
                PRINT
            NEXT
        END IF
        END
    END IF
    ListFile:
    TYPE FVInfo
        Colr        AS INTEGER  'Text color (white on black default)
        ULRow       AS INTEGER  'these four describe the window's corners
        ULCol       AS INTEGER
        LRRow       AS INTEGER
        LRCol       AS INTEGER
        HorizOffset AS INTEGER  'left margin within the window (see below)
        LoPtr       AS INTEGER  'used internally -- do not change!
        FileHandle  AS INTEGER  'internal (the DOS file handle if you care)
        EndOfFile   AS INTEGER  'used internally -- do not change!
        LineNumber  AS LONG     'line number of top line displayed, READ ONLY
        TabStop     AS INTEGER  'Tab stop setting (see below)
        FileSeek    AS LONG     'force read anywhere in the file (see below)
        FileOffset  AS LONG     'used internally -- do not change!
    END TYPE
  
    DIM FVI0 AS FVInfo          'create the TYPE variable
    REDIM Array(1 TO 16384)     'set up the MANDATORY 32K buffer
  
    FVI0.Colr = 10              'select a display color
    FVI0.ULRow = 2              'define the window corners
    FVI0.ULCol = 1
    FVI0.LRRow = 24
    FVI0.LRCol = 80
    FVI0.TabStop = 8
  
    Filename$ = AnnounceFile$
    Ln% = 76 - (LEN(ID1) + LEN(Version))
  
    CLS
    Ky = 0      'no keystrokes pending
    Action = 1  'tell FileView to assume full control
    DO
        LOCATE 1, 1
        Title$ = BBSName$
        P% = LEN(Title$)
        IF P% < 72 THEN
            Marg% = (74 - P%) / 2
            PRINT SPACE$(Marg%); Title$; SPACE$(Marg%)
        ELSE
            PRINT LEFT$(Title$, 74)
        END IF
      
        LOCATE 25, 1
        COLOR 0, 7
        PRINT "Line:"; LEFT$(STR$(FVI0.LineNumber) + SPACE$(3), 4);
        PRINT "File:"; LEFT$(Filename$ + SPACE$(15), 15);
        PRINT "QUIT: ESC or X  MOVE: "; CHR$(24); CHR$(25); CHR$(27);
        PRINT CHR$(26); " PgUp PgDn Home End";
      
        FileView Filename$, Ky, Action, FVI0, Array(1)
        IF Ky = 27 OR Ky = 88 OR Ky = 120 THEN
            EXIT DO
        END IF
    LOOP
    COLOR 7, 0
    PRINT
    LOCATE 25, 1
    CALL ClearEOL(0)
    CLOSE
    END
    Searching:
    SELECT CASE Ctr%
    CASE IS = 1
        LOCATE Ln%, 1
        PRINT "Searching ..  |";
    CASE IS = 2
        LOCATE Ln%, 1
        PRINT "Searching ..  /";
    CASE IS = 3
        LOCATE Ln%, 1
        PRINT "Searching ..  -";
    CASE IS = 4
        LOCATE Ln%, 1
        PRINT "Searching ..  \";
    CASE ELSE
        IF Ctr% >= 4 THEN Ctr% = 1
    END SELECT
    RETURN
  
    ShowNotes:
    IF Note1$ > "" THEN
        PRINT #3, Note1$
    END IF
    IF Note2$ > "" THEN
        PRINT #3, Note2$
    END IF
    IF Note1$ > "" THEN
        PRINT #3, Note3$
    END IF
    IF Note2$ > "" THEN
        PRINT #3, Note4$
    END IF
    RETURN
  
    LogNames:
    PRINT #3,
    PRINT #3, "LogFile(s) Used:"
    PRINT #3, "~~~~~~~~~~~~~~~~"
    IF Lastlog% > 0 THEN
        FOR X% = 0 TO Lastlog%
            PRINT #3, LogFile$(X%)
        NEXT
    ELSE
        PRINT #3, LogFile$(0)
    END IF
    RETURN
  
    Bomb:
    PRINT "Program bombed as a result of: "; ErrorMsg$(ERR)
    END
  
    FUNCTION Date2Day% (Dat$) STATIC
        Date2Day% = Num2Day%(Date2Num%(Dat$))
    END FUNCTION
  
    SUB Help
        CLS
        Temp$ = "RJ's File Arrival Announcement Program " + Version
        PRINT
        PRINT TAB(40 - LEN(Temp$) \ 2); Temp$
        PRINT SPACE$(30); "by R.J.(Bob) Ross"
        PRINT SPACE$(18); "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT STRING$(78, 196)
        PRINT "Purpose: "; "To produce a text readable file, listing files and titles of those"
        PRINT "         files that have arrived during the period covered by a Tick log and/or."
        PRINT "         a Miximus BBS Log (uploads)."
        PRINT
        PRINT "         Optionally, produces a config file in a suitable format that can be "
        PRINT "         read by program RJFFM (Files.bbs file format program) to format the "
        PRINT "         Download Counter field and the year/month received field on files.bbs "
        PRINT "         files. See BBSUTILS.DOC or Sample.cfg for details."
        PRINT STRING$(78, 196)
        PRINT "Switches:"
        PRINT
        PRINT "            -Cdirve:\path\Cfg.cfg      [configuration file]"
        PRINT "            -Odrive:\path\Arrival.txt  [files listing     ]"
        PRINT "            -L  [optional - displays filename stated using the -O switch"
        PRINT "                 to the screen]"
        PRINT
        PRINT
      
      
      
      
    END SUB
  
    SUB WordWrap (X$, Wide, LeftMargin) STATIC
      
        DO WHILE LEN(X$)        ' Loop while we have text
          ' find a place to break the line
            Pointer% = Wide + 1
            DO UNTIL MID$(X$, Pointer%, 1) = " " OR Pointer% = 1 OR Pointer% > LEN(X$)
                Pointer% = Pointer% - 1
            LOOP
          ' handle unbreakable text
            IF Pointer% = 1 THEN Pointer% = Wide + 1
            PRINT #3, TAB(LeftMargin%); LEFT$(X$, Pointer% - 1) ' dump the line
            X$ = MID$(X$, Pointer% + 1)
        LOOP
      
    END SUB
  
