  '**********************************************************************
  '**      Program:  RJFAL - Files Available Listing                   **
  '**       Author:  R.J.(Bob) Ross                                    **
  '**                SysOp - RJ's Byteline BBS - FidoNet 1:134/75      **
  '** Date Started:  October 25th, 1994                                **
  '**                Version .01 Beta - completed October 27, 1994     **
  '**                Version .02 Beta - completed November 1, 1994     **
  '**                Version .03 Beta - completed November 22, 1994    **
  '**                Version 1.00     - completed February 22 1995     **
  '**                Last compiled - March 9th, 1995                   **
  '**                                                                  **
  '**      Purpose:  To produce a Files Available Listing, listing     **
  '**                files available with descriptions from the        **
  '**                files.bbs files, that are available on a BBS      **
  '**                system.  Also will optionally produce a New       **
  '**                Files listing.  See Sample.Cfg for detals on the  **
  '**                the verbs to use.                                 **
  '**                                                                  **
  '**     Language:  Microsoft QuickBASIC 4.5                          **
  '**      Library:  Crescent Software Inc - QuickPak Professional     **
  '**                                                                  **
  '**********************************************************************
  '
    DEFINT A-Z
    DECLARE SUB Help ()
    DECLARE FUNCTION Exist% (FileName$)
    DECLARE SUB Process (InFileHandel%, OutFileHandel%, Path$, Count&, Bytes&)
    DECLARE FUNCTION QInstrB% (Start%, Source$, Search$)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION QPValI% (Num$)
    DECLARE FUNCTION QPValL& (Number$)
    DECLARE SUB WordWrap (X$, Wide, LeftMargin, OutFileHandel%)
    DECLARE FUNCTION Date2Day% (D$)
    DECLARE FUNCTION Date2Num% (Dat$)
    DECLARE FUNCTION Num2Day% (Days%)
    DECLARE FUNCTION Num2Date$ (Days%)
    DECLARE FUNCTION DayName$ (Day%)
    DECLARE FUNCTION MonthName$ (Month%)
    DECLARE FUNCTION Pad$ (X&, Places%)
    DECLARE SUB PrintRecord (FileHandel%, Rec$)
  
  
    CONST False = 0
    CONST True = NOT False
    CONST Version = "RJFAL V1.00"
  
    Header% = False
    NewFiles% = False
    NewFilesList$ = "NewFiles.txt"
    NewFilesList% = False
    ShowPath% = False
  
    DIM Array$(0 TO 1)
    Array$(1) = SPACE$(37)
  
  
    BBSName$ = "You forgot to put your BBS Name in the Config File"
    SysOp$ = "SysOp Who!"
  
    OutputFile$ = "RJFAL.LST"
  
  'FileHandles
    CfgF% = 1
    OutP% = 2
    NewF% = 3
    Handel% = 4
    HdrF% = 5
  
   ON ERROR GOTO Bomb
  
    CmdLine$ = UCASE$(COMMAND$)
  
  'No command line options given
    IF CmdLine$ = "" THEN
        CALL Help
        END
    END IF
  
  'Look for a Config file
    P% = INSTR(CmdLine$, "-C")
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            ConfigFile$ = LEFT$(Temp$, P% - 1)
        ELSE
            ConfigFile$ = Temp$
        END IF
    END IF
  
    IF Exist%(ConfigFile$) THEN
        OPEN ConfigFile$ FOR INPUT AS #CfgF%
        PRINT "   Opening: "; ConfigFile$
        DO UNTIL EOF(CfgF%)
            DO UNTIL EOF(1)
                LINE INPUT #CfgF%, Record$
                Record$ = LTRIM$(Record$)
                IF LEFT$(Record$, 1) = ";" THEN
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 7)) = "BBSNAME" THEN
                    BBSName$ = QPTrim$(MID$(Record$, 8))
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 5)) = "SYSOP" THEN
                    SysOp$ = QPTrim$(MID$(Record$, 6))
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 10)) = "HEADERFILE" THEN
                    HeaderFile$ = QPTrim$(MID$(Record$, 11))
                    Header% = True
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 15)) = "RJFALOUTPUTFILE" THEN
                    OutputFile$ = QPTrim$(MID$(Record$, 16))
                    OPEN OutputFile$ FOR OUTPUT AS #OutP%
                    PRINT "   Opening: "; OutputFile$
                    IF Header% THEN
                        FileHandel% = OutP%
                        GOSUB HeaderFile
                    END IF
                    FileHandel% = OutP%
                    GOSUB BannerHeader
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 12)) = "SHOWAREAPATH" THEN
                    ShowPath% = True
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 10)) = "LEFTMARGIN" THEN
                    LM$ = QPTrim$(MID$(Record$, 11))
                    LM% = QPValI%(LM$)
                    IF LM% = 0 THEN
                        BEEP
                        PRINT "Invalid or missing LeftMargin in "; ConfigFile$
                        CLOSE
                        END
                    END IF
                END IF
              
                IF UCASE$(LEFT$(Record$, 12)) = "FLAGNEWFILES" THEN
                    NewFiles% = QPValI%(MID$(Record$, 13))
                    CurrentDay% = Date2Num%(DATE$)
                    FileHandel% = OutP%
                    GOSUB NewFilesBanner
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 15)) = "NEWFILESLISTING" THEN
                    NewFilesList$ = QPTrim$(MID$(Record$, 16))
                    IF NewFiles% THEN
                        OPEN NewFilesList$ FOR OUTPUT AS #NewF%
                        PRINT "   Opening: "; NewFilesList$
                    ELSE
                        NewFilesList% = False
                        EXIT DO
                    END IF
                    NewFilesList% = True
                    IF Header% THEN
                        FileHandel% = NewF%
                        GOSUB HeaderFile
                    END IF
                    FileHandel% = NewF%
                    GOSUB BannerHeader
                    GOSUB NewFilesBanner
                    EXIT DO
                END IF
                IF UCASE$(LEFT$(Record$, 12)) = "AREAFILESBBS" THEN
                    FilesBBS$ = QPTrim$(MID$(Record$, 13))
                    IF Exist%(FilesBBS$) THEN
                        OPEN FilesBBS$ FOR INPUT AS #Handel%
                        Ln% = LEN(FilesBBS$)
                        Ln% = Ln% - 12
                        PRINT "Processing: "; FilesBBS$;
                        PRINT STRING$((45 - Ln%), ".");
                        Posn% = QInstrB%(-1, FilesBBS$, "\")
                        Path$ = LEFT$(FilesBBS$, Posn%)
                        Count& = 0
                        Bytes& = 0
                        CALL Process(Handel, OutP, Path$, Count&, Bytes&)
                        MegaBytes! = Bytes& / 1048576
                        Padded$ = Pad$(Bytes&, 11)
                        PRINT Padded$
                        TotalFiles& = TotalFiles& + Count&
                        TotalMBytes! = TotalMBytes! + MegaBytes!
                        IF ShowPath% THEN
                            PRINT #OutP%, TAB(38 - LEN(Path$) / 2); "("; Path$; ")"
                        END IF
                        PRINT #OutP%, STRING$(80, 196)
                        PRINT #OutP%, SPACE$(23); ""; STRING$(28, 196); ""
                        PRINT #OutP%, SPACE$(23); "  TOTAL FILES: ";
                        PRINT #OutP%, USING "###,###,###"; Count&;
                        PRINT #OutP%, "  "
                        PRINT #OutP%, SPACE$(23); "  TOTAL BYTES: ";
                        PRINT #OutP%, USING "###,###,###"; Bytes&;
                        PRINT #OutP%, "  "
                        PRINT #OutP%, SPACE$(23); ""; STRING$(28, 196); ""
                        PRINT #OutP%, STRING$(80, 196)
                    END IF
                ELSE EXIT DO
                END IF
            LOOP
        LOOP
        CLOSE CfgF%
        IF NewFilesList% THEN
            FileHandel% = NewF%
            PRINT #NewF%,
            GOSUB ProgramID
            CLOSE NewF%
        END IF
        PRINT #OutP%, STRING$(80, 196)
        PRINT #OutP%, SPACE$(18); ""; STRING$(37, 205); ""
        PRINT #OutP%, SPACE$(18); " GRAND TOTAL FILES    : ";
        PRINT #OutP%, USING "###,###,###"; TotalFiles&;
        PRINT #OutP%, "  "
        PRINT #OutP%, SPACE$(18); " GRAND TOTAL MEGABYTES: ";
        PRINT #OutP%, USING "    ###,###"; TotalMBytes!;
        PRINT #OutP%, "  "
        PRINT #OutP%, SPACE$(18); ""; STRING$(37, 205); ""
        PRINT #OutP%, STRING$(80, 196)
        FileHandel% = OutP%
        GOSUB ProgramID
        CLOSE #OutP%
    ELSE
        CALL chime(4)
        PRINT "Configuration file "; ConfigFile$; " not found!"
        END
    END IF
    CLOSE OutP
    CLOSE NewF
    CALL chime(10)
    PRINT
    PRINT
    PRINT Version
    PRINT "                            Started at:    "; Tm$
    PRINT "                           Finished at:    "; TIME$
    PRINT
    PRINT "                           Total Files: ";
    PRINT USING "###,###,###"; TotalFiles&;
    PRINT "                       Total MegaBytes: ";
    PRINT USING "###,###,###"; TotalMBytes!
    PRINT
    PRINT
    PRINT "    Created Files Available Listing as: "; OutputFile$
    IF NewFilesList% THEN
        PRINT "Created New Files Available Listing as: "; NewFilesList$
    ELSE
        PRINT
    END IF
    END
    PRINT
  
Bomb:
    PRINT "program bombed!", ERR
    END
  
HeaderFile:
    IF Exist%(HeaderFile$) THEN
        OPEN HeaderFile$ FOR INPUT AS #HdrF%
        PRINT "   Opening: "; HeaderFile$
        DO UNTIL EOF(HdrF%)
            LINE INPUT #HdrF%, Record$
            PRINT #FileHandel%, Record$
        LOOP
        CLOSE HdrF%
    END IF
    RETURN
  
BannerHeader:
  
    GOSUB BannerInfo
    GOSUB DaySuffix
    GOSUB AsOfLine
    PRINT #FileHandel%,
    PRINT #FileHandel%, ""; STRING$(78, 205); ""
    PRINT #FileHandel%, "";
    PRINT #FileHandel%, TAB(40 - LEN(BBSName$) / 2); BBSName$;
    PRINT #FileHandel%, TAB(80); ""
    PRINT #FileHandel%, "";
    PRINT #FileHandel%, TAB(40 - LEN(SysOp$) / 2); SysOp$;
    PRINT #FileHandel%, TAB(80); ""
    PRINT #FileHandel%, "";
    PRINT #FileHandel%, TAB(40 - LEN(Fal$) / 2); Fal$;
    PRINT #FileHandel%, TAB(80); ""
    PRINT #FileHandel%, "";
    PRINT #FileHandel%, TAB(40 - LEN(AsOf$) / 2); AsOf$;
    PRINT #FileHandel%, TAB(80); ""
    PRINT #FileHandel%, ""; STRING$(78, 205); ""
    RETURN
  
BannerInfo:
    SysOp$ = "SysOp: " + SysOp$
    Fal$ = "Files Available Listing As Of"
    Day% = Date2Day%(DATE$)
    Dy% = QPValI%(MID$(DATE$, 4, 2))
    Dy$ = STR$(Dy%)
    Mo% = QPValI%(LEFT$(DATE$, 2))
    Yr$ = RIGHT$(DATE$, 4)
    Tm$ = TIME$
    RETURN
  
DaySuffix:
    SELECT CASE Dy%
    CASE 1, 21, 31
        Suffix$ = "st"
    CASE 2, 22
        Suffix$ = "nd"
    CASE 3, 23
        Suffix$ = "rd"
    CASE ELSE
        Suffix$ = "th"
    END SELECT
    RETURN
AsOfLine:
    AsOf$ = Tm$ + " Hrs -- " + DayName$(Day%) + "," + Dy$ + Suffix$ + " of " + MonthName$(Mo%) + ", " + Yr$
    RETURN
  
NewFilesBanner:
    NumberDays% = Date2Num%(DATE$)
    Since% = NumberDays% - NewFiles%
    Dt$ = Num2Date$(Since%)
    Dy% = QPValI%(MID$(Dt$, 4, 2))
    Dy$ = STR$(Dy%)
    Mo% = QPValI%(LEFT$(Dt$, 2))
    Yr$ = RIGHT$(Dt$, 4)
    GOSUB DaySuffix
    PRINT #FileHandel%,
    PRINT #FileHandel%, SPACE$(16); ""; STRING$(46, 205); ""
    PRINT #FileHandel%, SPACE$(16); "  *New File Arrivals Since"; Dy$; Suffix$; " of "; MonthName$(Mo%); ", " + Yr$;
    PRINT #FileHandel%, TAB(64); ""
    PRINT #FileHandel%, SPACE$(16); ""; STRING$(46, 205); ""
    RETURN
  
ProgramID:
    Temp$ = "List Compiled Using Program " + Version + " by R.J.(Bob) Ross - 1:134/75"
    PRINT #FileHandel%, ""; STRING$(78, 196); ""
    PRINT #FileHandel%, "";
    PRINT #FileHandel%, TAB(40 - LEN(Temp$) / 2); Temp$;
    PRINT #FileHandel%, TAB(80); ""
    PRINT #FileHandel%, ""; STRING$(78, 196); ""
    RETURN
  

    FUNCTION Date2Day% (Dat$) STATIC
        Date2Day% = Num2Day%(Date2Num%(Dat$))
    END FUNCTION

DEFSNG A-Z
    SUB Help
        CLS
        Temp$ = "RJ's File Available Listing Program - " + Version
        Temp2$ = "by R.J.(Bob) Ross"
        Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
      
        PRINT
        PRINT TAB(40 - LEN(Temp$) / 2); Temp$
        PRINT TAB(40 - LEN(Temp2$) / 2); Temp2$
        PRINT TAB(40 - LEN(Temp3$) / 2); Temp3$
        PRINT STRING$(78, 196)
        PRINT "Purpose:  To produce a Files Available Listing, listing files"
        PRINT "          available with descriptions from the files.bbs files,"
        PRINT "          that are available on a BBS.  "
        PRINT
        PRINT "          Optionally, will produce a New Files listing."
        PRINT
        PRINT "          See Sample.Cfg for detals on the verbs to use."
        PRINT
        PRINT STRING$(78, 196)
        PRINT "Switches:"
        PRINT
        PRINT
        PRINT "          -Cdrive:\directory\Sample.cfg"
        PRINT
        PRINT
    END SUB

DEFINT A-Z
    FUNCTION Pad$ (X&, Places%) STATIC
      
        X$ = STR$(X&)           'make a string version of the number
      
        IF LEN(LTRIM$(X$)) > Places% THEN       'if after trimming a possible leading
            Pad$ = "%" + X$     '  blank it's too long, add a "%"
            EXIT FUNCTION       '  to show an error and go away
        END IF
      
        X$ = MID$(X$, 2)        'discard the leading blank or "-" sign
        Pad$ = MID$("-", SGN(X&) + 2) + STRING$(Places% - LEN(X$) + (SGN(X&) = -1), "0") + X$
      '            ^add minus if needed       ^create the zeros    ^less one if negative
      
    END FUNCTION

    SUB Process (Handel%, OutP%, Path$, FileCount&, AreaTotBytes&)
        SHARED LM%, NewFiles%, CurrentDay%, NewF%, NewFilesList%, Array$()
        FileCount& = 0
        Bytes& = 0
        Wdth% = 79 - LM%        'Width of File description
        LftRec% = LM% - 1       'portion of line before the file description
      
        DO UNTIL EOF(Handel%)
            DO UNTIL EOF(Handel%)
                LINE INPUT #Handel%, Record$
                IF MID$(Record$, 2, 1) = "" THEN
                    EXIT DO
                END IF
                IF INSTR(Record$, CHR$(22)) THEN
                  '**** This code by Henning Johansen - 1:134/40
                    WHILE INSTR(Record$, CHR$(22)) <> 0
                        Offset = INSTR(Record$, CHR$(22))
                        LineLength = LEN(Record$)
                        Temp$ = (LEFT$(Record$, (Offset - 1))) + (RIGHT$(Record$, ((LineLength - Offset) - 2)))
                        Record$ = Temp$
                    WEND
                  '****
                    PRINT #OutP%, Record$
                    IF NewFilesList% THEN
                        PRINT #NewF%, Record$
                    END IF
                    EXIT DO
                END IF
                IF LEFT$(Record$, 1) = "" THEN
                    PRINT #OutP%, Record$
                    IF NewFilesList% THEN
                        PRINT #NewF%, Record$
                    END IF
                    EXIT DO
                END IF
                IF LEFT$(Record$, 1) = " " THEN
                    PRINT #OutP%, Record$
                    IF NewFilesList% THEN
                        PRINT #NewF%, Record$
                    END IF
                    EXIT DO
                END IF
                IF LEFT$(Record$, 1) = "-" THEN
                    PRINT #OutP%, Record$
                    IF NewFilesList% THEN
                        PRINT #NewF%, Record$
                    END IF
                    EXIT DO
                END IF
                P% = INSTR(Record$, ".")
                IF P% THEN
                    IF LEFT$(Record$, 1) <> " " THEN
                        Posn% = INSTR(Record$, " ")
                        IF Posn% THEN
                            FilesBBSFileName$ = LEFT$(Record$, Posn% - 1)
                            IF Exist%(Path$ + FilesBBSFileName$) THEN
                                FileCount& = FileCount& + 1
                                Array$(0) = Path$ + FilesBBSFileName$
                                Array$(1) = SPACE$(37)
                                CALL ReadFileI(BYVAL VARPTR(Array$(0)))
                                Bytes& = QPValL&(MID$(Array$(1), 13, 10))
                                AreaTotBytes& = AreaTotBytes& + Bytes&
                                Temp$ = LTRIM$(MID$(Record$, Posn%))
                                IF LEFT$(Temp$, 3) = "/tb" THEN
                                    Temp$ = LTRIM$(MID$(Temp$, 4))
                                END IF
                                IF LEFT$(Temp$, 2) = "/b" THEN
                                    Temp$ = LTRIM$(MID$(Temp$, 3))
                                END IF
                                Record$ = LEFT$(Array$(1), 30) + "  " + Temp$
                                IF NewFiles% THEN
                                    FileDay% = Date2Num%(MID$(Array$(1), 23, 8))
                                    DaysOld& = CurrentDay% - FileDay%
                                    IF DaysOld& <= NewFiles% THEN
                                        Record$ = LEFT$(Array$(1), 30) + "* " + Temp$
                                    END IF
                                END IF
                                PRINT #OutP%, LEFT$(Record$, LftRec%);
                                CALL WordWrap(MID$(Record$, LM%), Wdth%, LM%, OutP%)
                                IF MID$(Record$, 31, 1) = "*" THEN
                                    IF NewFilesList% THEN
                                        PRINT #NewF%, LEFT$(Record$, LftRec%);
                                        CALL WordWrap(MID$(Record$, LM%), Wdth%, LM%, NewF%)
                                    END IF
                                END IF
                            END IF
                            EXIT DO
                        END IF
                    END IF
                END IF
            LOOP
        LOOP
        CLOSE Handel%
      
    END SUB

    SUB WordWrap (X$, Wide, LeftMargin, OutFileHandel%) STATIC
      
        DO WHILE LEN(X$)        ' Loop while we have text
          ' find a place to break the line
            Pointer% = Wide + 1
            DO UNTIL MID$(X$, Pointer%, 1) = " " OR Pointer% = 1 OR Pointer% > LEN(X$)
                Pointer% = Pointer% - 1
            LOOP
          ' handle unbreakable text
            IF Pointer% = 1 THEN Pointer% = Wide + 1
            PRINT #OutFileHandel%, TAB(LeftMargin%); LEFT$(X$, Pointer% - 1)    ' dump the line
            X$ = MID$(X$, Pointer% + 1)
        LOOP
      
    END SUB

