  ' **********************************************************************
  ' ** Program Name: RJFFM - Files.bbs Format                           **
  ' ** Date Started: October 8th, 1994                                  **
  ' **      Version: .01 Beta - completed 14 Oct 94.                    **
  ' **               .02 Beta - completed 14 Oct 94.                    **
  ' **               .03 Beta - completed 14 Oct 94.                    **
  ' **               .04 Beta - completed 19 Oct 94.                    **
  ' **               .05 Beta - completed 23 Oct 94.                    **
  ' **               .06 Beta - completed 06 Dec 94.                    **
  ' **               1.00     - completed 09 Feb 95.                    **
  ' **               Last compiled - 30 Mar 95.                         **
  ' **                                                                  **
  ' **      Purpose: To format Files.BBS files to add or change the     **
  ' **               Download counter format and add a year and month   **
  ' **               of last time downloaded field.                     **
  ' **               Format: [9999 | yymm] - where 9999 represents the  **
  ' **                       number of downloads and yymm represents    **
  ' **                       the year and month last downloaded.        **
  ' **                       eg.  [   1 | 9410]                         **
  ' **                 Note: The yymm date field is initialized using   **
  ' **                       the system date at run time.  Thereafter,  **
  ' **                       the date field is updated by program RJDLC **
  ' **                       after a file is download or file requested **
  ' **                       via Binkley.                               **
  ' **                                                                  **
  ' **     Language:  Microsoft QuickBASIC 4.5                          **
  ' **    Libraries:  Crescent Software Inc - QuickPak Professional     **
  ' **                Crescent Software Inc - P.D.Q.                    **
  ' **********************************************************************

    DEFINT A-Z
    DECLARE FUNCTION CurrentDate$ ()
    DECLARE FUNCTION Exist% (FileName$)
    DECLARE FUNCTION FUsing$ (Num$, Image$)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION QPValI (Number$)
    DECLARE SUB Help ()
    DECLARE FUNCTION CurrentDate$ ()


    CONST False = 0
    CONST True = NOT False
    CONST Version = "RJFFM V1.00"

    Yr$ = RIGHT$(DATE$, 2)
    Mnth$ = LEFT$(DATE$, 2)
    Dt$ = CurrentDate$
    CLS
    PRINT
    PRINT Dt$; TIME$; " RJUT Begin "; Version

    CmdLine$ = UCASE$(COMMAND$)

    ON ERROR GOTO Bomb

  'Look for a Config file
    P% = INSTR(CmdLine$, "-C")
    IF P% THEN
        ConfigFile$ = RTRIM$(MID$(CmdLine$, 3))
        ConfigFile% = True
        IF Exist%(ConfigFile$) THEN
            OPEN ConfigFile$ FOR INPUT AS #2
            IF LOF(2) = 0 THEN
               CLOSE 2
         '     PRINT ConfigFile$; " is empty!"
               PRINT Dt$; TIME$; " RJUT "; ConfigFile$; " is empty!"
               END
            END IF
        ELSE
            BEEP
            PRINT "Config file "; ConfigFile$; " NOT found! "
            PRINT Dt$; TIME$; " RJUT Config file "; ConfigFile$; " NOT found."
            END
        END IF
      'No command line option given - display help screen.
    ELSEIF CmdLine$ = "" THEN
        CALL Help
        END
    ELSE
      'Files.bbs file name was given on the command lane.
        FilesBBS$ = LTRIM$(CmdLine$)
        ConfigFile% = False
        FilesBBS% = True
    END IF
    CLS

    IF FilesBBS% THEN
        IF Exist%(FilesBBS$) THEN
            P% = INSTR(FilesBBS$, ".")
            IF P% THEN
                FilesBak$ = LEFT$(FilesBBS$, P%) + "bak"
                CALL FCopy(FilesBBS$, FilesBak$, SPACE$(4096), ErrCode%)
                OPEN FilesBBS$ FOR OUTPUT AS #3
            END IF
            OPEN FilesBak$ FOR INPUT AS #1
         '  PRINT "ReFormatting :"; FilesBBS$
            PRINT Dt$; TIME$; " RJUT ReFormatting :"; FilesBBS$
        ELSE
            BEEP
            PRINT "File "; FilesBBS$; " not found!"
            PRINT Dt$; TIME$; " RJUT File "; FilesBBS$; " not found."
            PRINT Dt$; TIME$; " RJUT End RJFFM"
            END
        END IF

    ELSEIF ConfigFile% THEN

        DO UNTIL EOF(2)
            DO UNTIL EOF(2)
                LINE INPUT #2, ConfigRec$
                ConfigRec$ = UCASE$(LTRIM$(ConfigRec$))
                IF LEFT$(ConfigRec$, 12) = "AREAFILESBBS" THEN
                    FilesBBS$ = QPTrim$(MID$(ConfigRec$, 13))
                ELSE
                    EXIT DO
                END IF
                IF Exist%(FilesBBS$) THEN
                    P% = INSTR(FilesBBS$, ".")
                    IF P% THEN
                        FilesBak$ = LEFT$(FilesBBS$, P%) + "bak"
                        CALL FCopy(FilesBBS$, FilesBak$, SPACE$(4096), ErrCode%)
                        OPEN FilesBBS$ FOR OUTPUT AS #3
                    END IF
                    OPEN FilesBak$ FOR INPUT AS #1
                 '  PRINT "ReFormatting :"; FilesBBS$
                    PRINT Dt$; TIME$; " RJUT ReFormatting :"; FilesBBS$
                ELSE
                    BEEP
                 '  PRINT "File "; FilesBBS$; " not found!"
                    PRINT Dt$; TIME$; " RJUT File "; FilesBBS$; " not found."
                    EXIT DO
                END IF
                GOSUB WriteBak
                CLOSE 1
                CLOSE 3
            LOOP
        LOOP
    END IF

    IF FilesBBS% THEN
        GOSUB WriteBak
    END IF

    CLOSE
    PRINT Dt$; TIME$; " RJUT End RJFFM"
    END

Bomb:
    BEEP
    PRINT Program; Bombed!
    END

WriteBak:
    DO UNTIL EOF(1)
        DO UNTIL EOF(1)
            LINE INPUT #1, Record$
            P% = INSTR(Record$, ".")
            IF P% THEN
                IF LEFT$(Record$, 1) <> " " THEN
                    IF P% < 10 THEN
                        FileName$ = LEFT$(Record$, P% + 3)
                        P% = INSTR(12, Record$, "[")
                        IF P% = 0 OR P% > 20 THEN
                          'Format the line
                            PRINT #3, FileName$ + SPACE$(13 - LEN(FileName$)); "[   0 | "; Yr$; Mnth$; "] "; LTRIM$(MID$(Record$, 13))
                            EXIT DO
                        END IF
                        IF P% > 0 AND P% < 20 THEN
                            PRINT #3, LEFT$(Record$, P%);
                            DownCount% = QPValI%(MID$(Record$, P% + 1))
                            DownCount$ = FUsing$(STR$(DownCount%), "####")      'for PDQ compile
                            PRINT #3, DownCount$;
                            P% = INSTR(Record$, "|")

                            IF P% > 25 THEN P% = 0

                            IF P% THEN
                                IF QPValI%(MID$(Record$, P% + 1)) > 0 THEN
                                    PRINT #3, " "; MID$(Record$, P%, 7);
                                END IF
                            ELSE
                                PRINT #3, " | "; Yr$; Mnth$; "]";
                            END IF
                            P% = INSTR(Record$, "]")
                            IF P% THEN
                                PRINT #3, MID$(Record$, P% + 1)
                                EXIT DO
                            END IF
                        END IF
                    END IF
                END IF
            END IF
            IF LEFT$(Record$, 1) = "" THEN
                PRINT #3, Record$
            ELSEIF LEFT$(Record$, 1) = "-" THEN
                PRINT #3, Record$
            ELSEIF LEFT$(Record$, 1) = " " THEN
                PRINT #3, Record$
            ELSE
                PRINT #3, Record$
            END IF
        LOOP
    LOOP
    RETURN

    FUNCTION CurrentDate$ STATIC
        Dt$ = DATE$
        Mnth$ = LEFT$(Dt$, 2)
        SELECT CASE Mnth$
        CASE IS = "01"
            Month$ = "Jan"
        CASE IS = "02"
            Month$ = "Feb"
        CASE IS = "03"
            Month$ = "Mar"
        CASE IS = "04"
            Month$ = "Apr"
        CASE IS = "05"
            Month$ = "May"
        CASE IS = "06"
            Month$ = "Jun"
        CASE IS = "07"
            Month$ = "Jul"
        CASE IS = "08"
            Month$ = "Aug"
        CASE IS = "09"
            Month$ = "Sep"
        CASE IS = "10"
            Month$ = "Oct"
        CASE IS = "11"
            Month$ = "Nov"
        CASE IS = "12"
            Month$ = "Dec"
        END SELECT
        CurrentDate$ = "  " + MID$(Dt$, 4, 2) + " " + Month$ + " "

    END FUNCTION

    SUB Help
        CLS
        Temp$ = "RJ's Files.bbs Format Program - " + Version
        Temp2$ = "by R.J.(Bob) Ross"
        Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT TAB(40 - LEN(Temp$) \ 2); Temp$
        PRINT TAB(40 - LEN(Temp2$) \ 2); Temp2$
        PRINT TAB(40 - LEN(Temp3$) \ 2); Temp3$
        PRINT STRING$(78, 196)
        PRINT "  Purpose:  To Format/Re-format the download counter field on Files.bbs"
        PRINT "            files and incorporate a last download year and month date."
        PRINT "            The date field will initially be loaded with the current year"
        PRINT "            and month by this program.  Thereafter the date will be"
        PRINT "            determined by the last date a file was downloaded."
        PRINT STRING$(78, 196)
        PRINT " Switches:"
        PRINT
        PRINT "            -CDrive:\Path\Cfg.cfg"
        PRINT "    or"
        PRINT "            Drive:\Path\files.bbs"
    END SUB

