  '************************************************************************
  '**  Program Name:  RJFSort - RJ's Files.bbs Sort Program              **
  '**        Author:  R.J. (Bob) Ross                                    **
  '**                 SysOp RJ's Byteline BBS - FidoNet 1:134/75         **
  '**  Date Started:  November 26th, 1994                                **
  '**       Version:  .01 Beta completed  December 4th, 1994             **
  '**       Version:  .02 Beta completed  December 27th, 1994            **
  '**       Version:  1.00 completed February 9th, 1995                  **
  '**                 Last compiled - March 29th, 1995                   **
  '**                                                                    **
  '**       Purpose:  To sort Files.bbs files in alphabetical order.     **
  '**                                                                    **
  '**      Language:  Microsoft QuickBASIC 4.5                           **
  '**       Library:  Crescent Software Inc - QuickPak Professional      **
  '**                 Does not compile well with P.D.Q.                  **
  '**                                                                    **
  '**          Note:  Complie using the /ah switch. Should be able to    **
  '**                 sort about 3,000 lines withoug running out of      **
  '**                 memory.                                            **
  '************************************************************************
  
    DEFINT A-Z
    DECLARE FUNCTION CurrentDate$ ()
    DECLARE FUNCTION Exist% (FileName$)
    DECLARE SUB Help ()
    DECLARE FUNCTION LineCount (FileName$, Buffer$)
    DECLARE SUB ParseCmdLine (Switch$, Work$, ReturnCode%)
    DECLARE SUB ISort (Tmp1$(), Tmp2&(), CNT%)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION QPValI% (Value$)

    CONST False = 0
    CONST True = NOT False
    CONST Version = "RJFSORT V1.00"
    Dt$ = CurrentDate$
    Skip% = 0
    CLS
    PRINT
    PRINT Dt$; TIME$; " RJUT Begin "; Version
  
    CmdLine$ = UCASE$(COMMAND$)

    IF CmdLine$ = "" THEN
        CALL Help
        END
    END IF
  
   ON ERROR GOTO Bomb
  
 'Look for a Config file (-C)
  CALL ParseCmdLine("-C", ConfigFile$, ConfigFile%)

     IF ConfigFile% THEN
        IF Exist%(ConfigFile$) THEN
            OPEN ConfigFile$ FOR INPUT AS #2
            IF LOF(2) = 0 THEN
                CLOSE 2
                PRINT Dt$; TIME$; " RJUT "; ConfigFile$; " is empty."
                PRINT Dt$; TIME$; " RJUT End RJFSORT"
                END
            END IF
        ELSE
            BEEP
            PRINT Dt$; TIME$; " RJUT "; ConfigFile$; " NOT found."
            PRINT Dt$; TIME$; " RJUT End RJFSORT"
            END
        END IF
      'No command line option given - display help screen.
  END IF

  'do one Files.bbs file (-F)
    CALL ParseCmdLine("-F", FilesBBS$, FilesBBS%)

    IF FilesBBS% THEN
        ConfigFile% = False
    END IF

 'Skip n number of lines (-S)
    CALL ParseCmdLine("-S", Skip$, SkipLines%)
    IF SkipLines% THEN
        Skip% = QPValI%(Skip$)
    END IF
    IF NOT FilesBBS% THEN
        IF NOT ConfigFile% THEN
            CALL Help
            END
        END IF
    END IF

    IF FilesBBS% THEN
        IF Exist%(FilesBBS$) THEN
            P% = INSTR(FilesBBS$, ".")
            IF P% THEN
                FilesBak$ = LEFT$(FilesBBS$, P%) + "BAK"
            END IF
            GOSUB SortFile
            PRINT Dt$; TIME$; " RJUT End RJFSORT"
ErrorEntry1:
            CLOSE : END
        ELSE
            BEEP
            PRINT Dt$; TIME$; " RJUT "; FilesBBS$; " not found."
            PRINT Dt$; TIME$; " RJUT End RJFSORT"
            END
        END IF
      
    ELSEIF ConfigFile% THEN
      
        DO UNTIL EOF(2)
            DO UNTIL EOF(2)
                LINE INPUT #2, ConfigRec$
                ConfigRec$ = UCASE$(LTRIM$(ConfigRec$))
                IF LEFT$(ConfigRec$, 12) = "AREAFILESBBS" THEN
                    FilesBBS$ = QPTrim$(MID$(ConfigRec$, 13))
                ELSE
                    EXIT DO
                END IF
                IF Exist%(FilesBBS$) THEN
                    P% = INSTR(FilesBBS$, ".")
                    IF P% THEN
                        FilesBak$ = LEFT$(FilesBBS$, P%) + "BAK"
                    END IF
                    GOSUB SortFile
                ELSE
                    BEEP
                    PRINT Dt$; TIME$; " RJUT "; FilesBBS$; " not found."
                    EXIT DO
                END IF
ErrorEntry2:
            LOOP
        LOOP
    END IF
    CLOSE
    PRINT Dt$; TIME$; " RJUT End RJFSORT"
    END
  
SortFile:
  
    OPEN FilesBBS$ FOR INPUT AS #3
    OPEN FilesBak$ FOR OUTPUT AS #1
    Count = 0
    PRINT Dt$; TIME$; " RJUT Making "; FilesBak$;
    Vert% = CSRLIN: Horiz% = POS(0)
    DO UNTIL EOF(3)
        LOCATE Vert%, Horiz%
        Count = Count + 1
        LINE INPUT #3, Record$
        PRINT #1, Record$
    LOOP
    PRINT Count;
    PRINT
    CLOSE 3, 1
    Count = Count - Skip%
    IF Count < 2 THEN
        CLOSE 1, 3
        RETURN
    END IF
  
    IF Count < 2 THEN
        CLOSE 1, 3
        RETURN
    END IF
  
    IF Skip% THEN
        REDIM Heading$(1 TO Skip% + 1)
    END IF
  
    CurSeek& = 1
  
    REDIM Seeks&(1 TO Count)    ' Max number of lines
    REDIM FileName$(1 TO Count)
  
    OPEN FilesBBS$ FOR OUTPUT AS #3
    OPEN FilesBak$ FOR INPUT AS #1
  
    IF Skip% THEN
        FOR X% = 1 TO Skip%
            LINE INPUT #1, Heading$(X%)
            CurSeek& = CurSeek& + LEN(Heading$(X%)) + 2
        NEXT
    END IF
  
    FOR X% = 1 TO Count
        IF EOF(1) THEN EXIT FOR
        LINE INPUT #1, Text$
        Seeks&(X%) = CurSeek&
        FileName$(X%) = LEFT$(Text$, 12)
        CurSeek& = CurSeek& + LEN(Text$) + 2    ' Next position - 2 is
    NEXT
  
    PRINT Dt$; TIME$; " RJUT Sorting "; FilesBBS$
    CALL ISort(FileName$(), Seeks&(), Count)
  
    IF Skip% THEN
        FOR X% = 1 TO Skip%
            PRINT #3, Heading$(X%)
        NEXT
    END IF
  
    FOR X% = 1 TO Count
        IF Seeks&(X%) = 0 THEN EXIT FOR
        SEEK 1, Seeks&(X%)
        LINE INPUT #1, Record$
        PRINT #3, Record$
    NEXT
    CLOSE 1, 3
    RETURN
  
Bomb:
    SELECT CASE ERR
    CASE IS = 14
        ERASE Seeks&
        ERASE FileName$
        PRINT Dt$; TIME$; " RJUT Not enough string space to sort "; FilesBBS$
        PRINT Dt$; TIME$; " RJUT Recovering "; FilesBBS$; " from "; FilesBak$
        SEEK 1, 1
        DO UNTIL EOF(1)
            LINE INPUT #1, Record$
            PRINT #3, Record$
        LOOP
        CLOSE 1, 3
        IF FilesBBS% THEN
            RESUME ErrorEntry1
        END IF
        IF ConfigFile% THEN
            RESUME ErrorEntry2
        END IF
    CASE ELSE
        PRINT Dt$; TIME$; " RJUT Program failed"; ERR
        END
    END SELECT

    FUNCTION CurrentDate$ STATIC
        Dt$ = DATE$
        Mnth$ = LEFT$(Dt$, 2)
        SELECT CASE Mnth$
        CASE IS = "01"
            Month$ = "Jan"
        CASE IS = "02"
            Month$ = "Feb"
        CASE IS = "03"
            Month$ = "Mar"
        CASE IS = "04"
            Month$ = "Apr"
        CASE IS = "05"
            Month$ = "May"
        CASE IS = "06"
            Month$ = "Jun"
        CASE IS = "07"
            Month$ = "Jul"
        CASE IS = "08"
            Month$ = "Aug"
        CASE IS = "09"
            Month$ = "Sep"
        CASE IS = "10"
            Month$ = "Oct"
        CASE IS = "11"
            Month$ = "Nov"
        CASE IS = "12"
            Month$ = "Dec"
        END SELECT
        CurrentDate$ = "  " + MID$(Dt$, 4, 2) + " " + Month$ + " "
      
    END FUNCTION

    SUB Help
        CLS
        Temp$ = "RJ's Files.bbs Sort Program - " + Version
        Temp2$ = "by R.J.(Bob) Ross"
        Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT TAB(40 - LEN(Temp$) / 2); Temp$
        PRINT TAB(40 - LEN(Temp2$) / 2); Temp2$
        PRINT TAB(40 - LEN(Temp3$) / 2); Temp3$
        PRINT STRING$(78, 196)
        PRINT "  Purpose:  To sort Files.bbs into alphabetical order, optionally skipping"
        PRINT "            the first n of lines using the -S switch."
        PRINT STRING$(78, 196)
        PRINT " Switches:"
        PRINT "            -Sn [optional]"
        PRINT "            -CDrive:\Path\Cfg.cfg"
        PRINT "    or"
        PRINT "            -Sn [optional]"
        PRINT "            -FDrive:\Path\files.bbs"
    END SUB

    SUB ISort (Tmp1$(), Tmp2&(), CNT%) STATIC
      '
      ' --- The Shell-Metzner Sort Subroutine --- <Fast!>
      '
        M% = CNT%
        WHILE M% > 1
            M% = INT(M% / 2)
            FOR J% = 1 TO CNT% - M%
                FOR I% = J% TO 1 STEP -M%
                    k% = I% + M%
                  'IF Tmp1$(i%) >= Tmp1$(k%) THEN
                    IF Tmp1$(I%) <= Tmp1$(k%) THEN
                        I% = 0
                    ELSE
                        SWAP Tmp1$(I%), Tmp1$(k%)
                        SWAP Tmp2&(I%), Tmp2&(k%)
                    END IF
                NEXT I%
            NEXT J%
        WEND
    END SUB

SUB ParseCmdLine (Switch$, Work$, ReturnCode%)

    CmdLine$ = UCASE$(COMMAND$)
    ReturnCode% = False

    P% = INSTR(CmdLine$, Switch$)
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            Work$ = LEFT$(Temp$, P% - 1)
        ELSE
            Work$ = Temp$
        END IF
        ReturnCode% = True
    END IF

END SUB

