    '**********************************************************************
    '**  Program Name: RJKILL - Kill (delete) files                      **
    '**        Author: R.J.(Bob) Ross                                    **
    '**                SysOp - RJ's Byteline BBS - FidoNet 1:134/75      **
    '**  Date Started: October 19th, 1994                                **
    '**       Version: .01 Beta - completed October 19, 1994             **
    '**                1.00     - completed February 10th, 1995          **
    '**                Last compiled - March 9th, 1995                   **
    '**                                                                  **
    '**       Purpose: To Kill (delete) files and update files.bbs files **
    '**                from a listing produced by program RJKLST.        **
    '**                                                                  **
    '**      Language: Microsoft QuickBASIC 4.5                          **
    '**     Libraries: Crescent Software Inc - QuickPak Professional     **
    '**                Crescent Software Inc - P.D.Q                     **
    '**********************************************************************
    '
    DEFINT A-Z
    DECLARE FUNCTION Exist% (FileName$)
    DECLARE FUNCTION FUsing$ (Number$, Image$)
    DECLARE SUB Help ()
    DECLARE FUNCTION QInstrB% (StartPos%, Source$, Search$)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION QPValL& (Number$)
    DECLARE SUB YesNo (YN$, Prompt$, ScanCode, NormalColr, EditColr, Row, Column)
  
    Ln% = CSRLIN
    DIM Array$(0 TO 1)
    CONST Title1$ = "RJ's Kill (Delete) Files Program - Version 1.00"
    CONST Title2$ = "by R.J.(Bob) Ross"
    CONST Title3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"

    CONST Version = "RJKILL Version 1.00"

    CmdLine$ = UCASE$(COMMAND$)
    P% = INSTR(CmdLine$, "-K")
    IF P% THEN
        KillList$ = QPTrim$(MID$(CmdLine$, P% + 2))
    ELSE
        CALL Help
        END
    END IF
  
    IF Exist%(KillList$) THEN
        CALL Chime(4)
        Msg$ = "OK to delete all files listed in " + KillList$ + " ? (Yes/No) "
        YN$ = "N"
        YesNo YN$, Msg$, ScanCode, 7, 112, Ln%, 1
        IF YN$ = "Y" THEN
            PRINT
            ELSEIF YN$ = "N" THEN
            PRINT
            PRINT "Program terminated."
            END
        END IF
        OPEN KillList$ FOR INPUT AS #1
    ELSE
        CALL Chime(2)
        PRINT "File: "; KillList$; " not found!"
        END
    END IF
  
    DO UNTIL EOF(1)
        DO UNTIL EOF(1)
            LINE INPUT #1, Record$
            P% = INSTR(Record$, " ")
            IF P% THEN
                Temp$ = LEFT$(Record$, P% - 1)
                Posn% = QInstrB%(-1, Temp$, "\")
                IF Posn% THEN
                    DrvPath$ = LEFT$(Temp$, Posn%)
                    FileName$ = MID$(Temp$, Posn% + 1)
                    PRINT DrvPath$; FileName$
                ELSE
                    EXIT DO
                END IF
                ELSE
                    EXIT DO
            END IF
                IF Exist%(DrvPath$ + "files.bbs") THEN
                    OPEN DrvPath$ + "files.bbs" FOR INPUT AS #2
                    OPEN DrvPath$ + "Files.bak" FOR OUTPUT AS #3
                ELSE
                    EXIT DO
                END IF
                DO UNTIL EOF(2)
                    LINE INPUT #2, Record$
                    P% = INSTR(Record$, ".")
                    IF P% THEN
                        BBSFileName$ = LEFT$(Record$, P% + 3)
                        IF BBSFileName$ = FileName$ THEN
                            IF Exist%(DrvPath$ + FileName$) THEN
                                Array$(0) = DrvPath$ + FileName$
                                Array$(1) = SPACE$(37)
                                CALL ReadFileI(BYVAL VARPTR(Array$(0)))
                                FileSz& = QPValL(MID$(Array$(1), 13, 9))
                                TotFileSz& = TotFileSz& + FileSz&
                                FileCount% = FileCount% + 1
                                KILL DrvPath$ + FileName$
                            END IF
                        ELSE PRINT #3, Record$
                        END IF
                    ELSE PRINT #3, Record$
                    END IF
                LOOP
                CLOSE 2
                CLOSE 3
                KILL DrvPath$ + "Files.bbs"
                NAME DrvPath$ + "Files.bak" AS DrvPath$ + "files.bbs"
            LOOP
        LOOP
        CLOSE 1

        CALL Chime(6)
        FileCount$ = FUsing$(STR$(FileCount%), "##,###")
        TotFileSz$ = FUsing$(STR$(TotFileSz&), "###,###,###")
        PRINT
        PRINT
        PRINT TAB(40 - LEN(Title1$) \ 2); Title1$
        PRINT TAB(40 - LEN(Title2$) \ 2); Title2$
        PRINT TAB(40 - LEN(Title3$) \ 2); Title3$
        PRINT STRING$(78, 196)
        PRINT
        PRINT "      Input Kill file listing: "; KillList$
        PRINT
        PRINT "      Number of files deleted:      ";
        PRINT FileCount$
        PRINT
        PRINT "            Total Bytes saved: ";
        PRINT TotFileSz$
        FOR X% = 1 TO 13
          PRINT
        NEXT

DEFSNG A-Z
        SUB Help
            CLS
            PRINT TAB(40 - LEN(Title1$) \ 2); Title1$
            PRINT TAB(40 - LEN(Title2$) \ 2); Title2$
            PRINT TAB(40 - LEN(Title3$) \ 2); Title3$
            PRINT STRING$(78, 196)
            PRINT
            PRINT " Purpose:  To kill (delete) files listed in the listing generated"
            PRINT "           by program RJKLST."
            PRINT
            PRINT STRING$(78, 196)
            PRINT "Switches:"
            PRINT
            PRINT "           -KDrive:\Path\Killlist.txt"
            PRINT

        END SUB

