    '*********************************************************************
    '**  Program Name: RJKLST - Kill List                               **
    '**  Date Started: October 17th, 1994                               **
    '**       Version: .01 Beta - completed October 19, 1994            **
    '**                .02 Beta - completed October 20, 1994            **
    '**                1.00     - completed February 10th, 1995         **
    '**                Last compiled Marth 9th, 1995                    **
    '**                                                                 **
    '**       Purpose: To create a listing of filess that may be        **
    '**                deleted using program RJKILL.                    **
    '**                                                                 **
    '**      Language: Microsoft QuickBASIC 4.5                         **
    '**     Libraries: Crescent Software Inc - QuickPak Professional    **
    '**                Crescent Software Inc - P.D.Q.                   **
    '**                use /ah switch  & /e                             **
    '*********************************************************************

    DEFINT A-Z
    DECLARE FUNCTION ErrorMsg$ (ErrorNumber%)
    DECLARE FUNCTION Exist% (FileName$)
    DECLARE FUNCTION FCount% (Spec$)
    DECLARE FUNCTION FUsing$ (Number$, Image$)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION QInstrB% (StartPos%, Source$, Search$)
    DECLARE FUNCTION QPValI% (Number$)
    DECLARE FUNCTION QPValL& (Number$)
    DECLARE SUB Help ()
  
    CONST False = 0
    CONST True = NOT False
    Title1$ = "RJ's Kill Listing Program - RJKLST Version 1.00"
    Title2$ = "by R.J. (Bob) Ross"
    Title3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
 
   'Defaults
    DLDate% = 9999
    DLCount% = 9999
    FileDate% = 9999
  
    CfgFile% = False
    KillList% = False
    Ln% = CSRLIN
  
    ON ERROR GOTO Bomb
  
    CmdLine$ = UCASE$(COMMAND$)
  
  'No command line options given
    IF CmdLine$ = "" THEN
        CALL Help
        END
    END IF
  
  'Look for a Config file
    P% = INSTR(CmdLine$, "-C")  ' -C  Config file
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            ConfigFile$ = LEFT$(Temp$, P% - 1)
        ELSE
            ConfigFile$ = Temp$
        END IF
        IF Exist%(ConfigFile$) THEN
            CfgFile% = True
            OPEN ConfigFile$ FOR INPUT AS #1
            DO UNTIL EOF(1)
                LINE INPUT #1, Record$
                IF UCASE$(LEFT$(Record$, 12)) = "AREAFILESBBS" THEN
                    FilesBBS$ = QPTrim$(MID$(Record$, 13))
                    P% = QInstrB%(-1, FilesBBS$, "\")
                    IF P% THEN
                        IF P% >= LongestPath% THEN
                            LongestPath% = P%
                        END IF
                    END IF
                END IF
            LOOP
            SEEK 1, 1
          
        ELSE
            CALL Chime(6)
            PRINT "Config file "; ConfigFile$; " not found! "
            END
        END IF
    END IF
  
    P% = INSTR(CmdLine$, "-O")  '   -O    Kill File listing
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            KillList$ = LEFT$(Temp$, P% - 1)
        ELSE
            KillList$ = Temp$
        END IF
        KillList% = True
    END IF
  
    IF KillList% AND CfgFile% THEN
      'do nothing
    ELSE
        CALL Help
        END
    END IF
  
    OPEN KillList$ FOR OUTPUT AS #2
  
    DO UNTIL EOF(1)
        DO UNTIL EOF(1)
            LINE INPUT #1, Record$
            Record$ = UCASE$(LTRIM$(Record$))
            IF LEFT$(Record$, 14) = "DLDATELESSTHAN" THEN
                DLDate% = QPValI%(MID$(Record$, 15))
                EXIT DO
            ELSEIF LEFT$(Record$, 15) = "DLCOUNTLESSTHAN" THEN
                DLCount% = QPValI%(MID$(Record$, 16))
                EXIT DO
            ELSEIF LEFT$(Record$, 16) = "FILEDATELESSTHAN" THEN
                FileDate% = QPValI%(MID$(Record$, 17))
                EXIT DO
            ELSEIF LEFT$(Record$, 12) = "AREAFILESBBS" THEN
                FilesBBS$ = QPTrim$(MID$(Record$, 13))
                P% = QInstrB%(-1, FilesBBS$, "\")
                IF P% THEN
                    Path$ = LEFT$(FilesBBS$, P%) + "*.*"
                END IF
            ELSE
                EXIT DO
            END IF
            Count = FCount%(Path$)
          
            REDIM Array$(Count)
          
            FOR C% = 1 TO Count
                Array$(C%) = SPACE$(37)
            NEXT
            Array$(0) = Path$
            CALL ReadFileI(BYVAL VARPTR(Array$(0)))
          
            OPEN FilesBBS$ FOR INPUT AS #3
            DO UNTIL EOF(3)
                DO UNTIL EOF(3)
                    LINE INPUT #3, Record$
                    P% = INSTR(Record$, ".")
                    IF P% THEN
                        BBSFileName$ = UCASE$(LEFT$(Record$, P% + 3))
                    ELSE EXIT DO
                    END IF
                  
                    FOR C% = 1 TO Count
                        P% = INSTR(Array$(C%), " ")
                        IF P% THEN
                            HDFileName$ = LEFT$(Array$(C%), P% - 1)
                            HDFileSize$ = MID$(Array$(C%), 13, 9)
                            HDFileDate$ = MID$(Array$(C%), 23, 8)
                        END IF
                        IF BBSFileName$ = HDFileName$ THEN
                            FileYear$ = RIGHT$(HDFileDate$, 2)
                            FileMonth$ = LEFT$(HDFileDate$, 2)
                            FileDtYYMM$ = FileYear$ + FileMonth$
                          
                            P% = INSTR(13, Record$, "[")
                            IF P% THEN
                                Downloads$ = MID$(Record$, P% + 1)
                            END IF
                            P% = INSTR(13, Record$, "|")
                            IF P% THEN
                                DownloadDate% = QPValI%(MID$(Record$, P% + 1))
                            END IF
                          
                          'Criteria for selecting files.
                            IF QPValI%(FileDtYYMM$) < FileDate% AND QPValI%(Downloads$) < DLCount% AND DownloadDate% < DLDate% THEN
                              
                                FileCtr% = FileCtr% + 1
                                FileSz& = QPValL(LEFT$(HDFileSize$, 9))
                                TotFileSz& = TotFileSz& + FileSz&
                                PRINT #2, LEFT$(Path$, LEN(Path$) - 3); HDFileName$;
                                PRINT #2, TAB(LongestPath% + 15); HDFileSize$; " "; HDFileDate$; MID$(Record$, 13)
                                EXIT FOR
                            END IF
                            Ctr% = Ctr% + 1
                            SELECT CASE Ctr%
                            CASE IS = 5
                                LOCATE Ln%, 1
                                PRINT "Searching ..  |";
                            CASE IS = 10
                                LOCATE Ln%, 1
                                PRINT "Searching ..  /";
                            CASE IS = 15
                                LOCATE Ln%, 1
                                PRINT "Searching ..  -";
                            CASE IS = 20
                                LOCATE Ln%, 1
                                PRINT "Searching ..  \";
                            CASE ELSE
                                IF Ctr% > 19 THEN Ctr% = 1
                            END SELECT
                        END IF
                      
                    NEXT
                LOOP
            LOOP
            CLOSE #3
        LOOP
    LOOP
    CLOSE

    DLCount$ = FUsing$(STR$(DLCount%), "#####")
    TotFileSz$ = FUsing$(STR$(TotFileSz&), "###,###,###")
    CALL Chime(8)
    PRINT
    PRINT
    PRINT TAB(40 - LEN(Title1$) \ 2); Title1$
    PRINT TAB(40 - LEN(Title2$) \ 2); Title2$
    PRINT TAB(40 - LEN(Title3$) \ 2); Title3$
    PRINT STRING$(78, 196)
    PRINT
    PRINT "    Input Configuration File: "; ConfigFile$
    PRINT
    PRINT "    Output Kill Listing File: "; KillList$
    PRINT
    PRINT "    Criteria for File Selection:"
    PRINT
    PRINT "                           File Dates < "; FileDate%
    PRINT "             Download Count Indicator < ";
    PRINT DLCount$
    PRINT "                 Last Downloaded Date < "; DLDate%
    PRINT
    PRINT
    PRINT "    Total Files Selected "; FileCtr%; " for a calculated total of ";
    PRINT TotFileSz&
    PRINT "    bytes saving if all files from "; KillList$; " are deleted."
    PRINT : PRINT : PRINT : PRINT
  
    END
  
Bomb:
  
    CLS
    CALL Chime(1)
    PRINT "Program bombed as a result of: "; ErrorMsg$(ERR)
    END

    SUB Help
        SHARED Title1$, Title2$, Title3$
        CLS
        PRINT TAB(40 - LEN(Title1$) \ 2); Title1$
        PRINT TAB(40 - LEN(Title2$) \ 2); Title2$
        PRINT TAB(40 - LEN(Title3$) \ 2); Title3$
        PRINT STRING$(78, 196)
      
        PRINT "Purpose:  To produce a listing of files based on the selection criteria"
        PRINT "          using the following verbs in the configuration file:"
        PRINT
        PRINT "            DLDateLessThan yymm"
        PRINT "           DLCountLessThan nnnn"
        PRINT "           FileDateLessThan yymm"
        PRINT STRING$(78, 196)
        PRINT "Switches:"
        PRINT
        PRINT "           -CDrive:\Path\CfgFile.Cfg"
        PRINT "           -ODrive:\Path\KillList.txt"
        PRINT
        PRINT
        PRINT " Note:  Use of both switches is mandatory."
      
      
    END SUB

