  '***********************************************************************
  '** Program Name: RJMISS - Files listed on the Files.bbs file(s) but   *
  '**                        missing in the directory.                   *
  '**       Author: R.J. (Bob) Ross                                      *
  '**               SysOp RJ's Byteline BBS - FidoNet 1:134/75           *
  '** Date Started: March 6th, 1995                                      *
  '**      Version: 1.00 completed March 7th, 1995                       *
  '**               Last compiled - Apr 5th, 1995                        *
  '**                                                                    *
  '**      Purpose: To identify files that are listed on Files.bbs files *
  '**               but not held in the directory where the Files.bbs    *
  '**               file(s) resides.  Updates the Files.bbs file(s) by   *
  '**               removing the filenames and description from the      *
  '**               Files.bbs file.                                      *
  '**                                                                    *
  '**     Language: Microsoft QuickBASIC 4.5                             *
  '**    Libraries: Crescent Software QuickPak Professional and P.D.Q.   *
  '***********************************************************************
  
    DEFINT A-Z
    DECLARE FUNCTION CurrentDate$ ()
    DECLARE FUNCTION GetDrive%
    DECLARE FUNCTION GetDir$ (Drive$)
    DECLARE FUNCTION Exist% (Filename$)
    DECLARE FUNCTION QInstrB% (StartPos%, Source$, Search$)
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE SUB ParseCmdLine (Switch$, Work$, ReturnCode%)
    DECLARE SUB Help ()
  
    CONST Version = "RJMISS V1.00"
    CONST False = 0
    CONST True = NOT False
    Dt$ = CurrentDate$
  
    MissingFile% = False
  
    CLS
    PRINT
    PRINT Dt$; TIME$; " RJUT Begin "; Version

    CmdLine$ = UCASE$(COMMAND$)
  
    IF CmdLine$ = "" THEN
        CALL Help
        END
    END IF
  
  'ON ERROR GOTO Bomb

  'Missing files info output file - optional
    CALL ParseCmdLine("-O", OutputFile$, OutputFile%)
    IF OutputFile% THEN
        OutP% = FREEFILE
        OPEN OutputFile$ FOR APPEND AS OutP%
        IF ERR GOTO Bomb
        PRINT #OutP%,
        PRINT #OutP%, Dt$; TIME$; " RJUT Begin "; Version
        PRINT Dt$; TIME$; " RJUT Begin "; Version
    END IF

  'Look for a Config file (-C)
    CALL ParseCmdLine("-C", ConfigFile$, ConfigFile%)
    IF ConfigFile% THEN
        IF Exist%(ConfigFile$) THEN
            OPEN ConfigFile$ FOR INPUT AS #2
            IF LOF(2) = 0 THEN
                CLOSE 2
                PRINT #OutP%, Dt$; TIME$; " RJUT "; ConfigFile$; " is empty."
                PRINT Dt$; TIME$; " RJUT "; ConfigFile$; " is empty."
                PRINT Dt$; TIME$; " RJUT End RJMISS"
                END
            END IF
            CLOSE 2
        ELSE
            BEEP
            IF OutputFile% THEN
                PRINT #OutP%, Dt$; TIME$; " RJUT Config file "; ConfigFile$; " NOT found."
                PRINT #OutP%, Dt$; TIME$; " RJUT End RJMISS"
            END IF
            PRINT Dt$; TIME$; " RJUT Config file "; ConfigFile$; " NOT found."
            PRINT Dt$; TIME$; " RJUT End RJMISS"
            END
        END IF
      'No command line option given - display help screen.
    END IF
  
  'Do only one Files.bbs file (-F)
    CALL ParseCmdLine("-F", FilesBBS$, FilesBBS%)
  
    IF FilesBBS% THEN
        ConfigFile% = False
        GOSUB CheckforMissing
        CLOSE
        PRINT Dt$; TIME$; " RJUT End RJMISS"
        END
    'Get Files.bbs names from the Cfg file
    ELSEIF ConfigFile% THEN
        Cfg% = FREEFILE
        OPEN ConfigFile$ FOR INPUT AS #Cfg%
        DO UNTIL EOF(Cfg%)
            DO UNTIL EOF(Cfg%)
                LINE INPUT #Cfg%, ConfigRec$
                ConfigRec$ = UCASE$(LTRIM$(ConfigRec$))
                IF LEFT$(ConfigRec$, 12) = "AREAFILESBBS" THEN
                    FilesBBS$ = QPTrim$(MID$(ConfigRec$, 13))
                ELSE
                    EXIT DO
                END IF
                IF Exist%(FilesBBS$) THEN
                    GOSUB CheckforMissing
                    CLOSE Fbbs%
                ELSE
                    BEEP
                    PRINT Dt$; TIME$; " RJUT File not found: "; FilesBBS$
                    IF OutputFile% THEN
                        PRINT #OutP%, Dt$; TIME$; " RJUT Files.bbs: "; FilesBBS$; " not found!"
                    END IF
                    EXIT DO
                END IF
            LOOP
        LOOP
    END IF
    IF OutputFile% THEN
        PRINT #OutP%, Dt$; TIME$; " RJUT End RJMISS"
    END IF
    CLOSE
    PRINT #OutP%, Dt$; TIME$; " RJUT End RJMISS"
    END
  
  'All the work is done here.
CheckforMissing:
    Fbbs% = FREEFILE
    IF Exist%(FilesBBS$) THEN
        OPEN FilesBBS$ FOR INPUT AS Fbbs%
        P% = QInstrB(-1, FilesBBS$, "\")
        IF P% THEN
            Path$ = LEFT$(FilesBBS$, P%)
        ELSE
            Drive% = GetDrive%
            Drive$ = CHR$(GetDrive%)
            Directory$ = GetDir$(Drive$)
            Path$ = Drive$ + ":" + Directory$
            FilesBBS$ = Path$ + FilesBBS$
        END IF
        IF OutputFile% THEN
            PRINT #OutP%, Dt$; TIME$; " RJUT Processing: "; FilesBBS$
        END IF
        PRINT Dt$; TIME$; " RJUT Processing: "; FilesBBS$
      
        'Do first check here just to see if we have at least one to remove."
        DO UNTIL EOF(Fbbs%)
            LINE INPUT #Fbbs%, Record$
            P% = INSTR(Record$, ".")
            IF P% THEN
                IF LEFT$(Record$, 1) <> " " AND P% < 10 THEN
                    BBSFileName$ = LEFT$(Record$, P% + 3)
                    IF NOT Exist%(Path$ + BBSFileName$) THEN
                        MissingFile% = True
                      'found a missing one so might as well get out
                        EXIT DO
                    END IF
                END IF
            END IF
        LOOP
      
        IF NOT MissingFile% THEN
            IF OutputFile% THEN
                PRINT Dt$; TIME$; " RJUT No listed files missing."
                PRINT #OutP%, Dt$; TIME$; " RJUT No listed files missing."
            END IF
            RETURN
        ELSE
            P% = INSTR(FilesBBS$, ".")
            IF P% THEN
               'crank the file back to the 1st byte
                SEEK Fbbs%, 1
                FilesBAK$ = LEFT$(FilesBBS$, P%) + "BAK"
                Bak% = FREEFILE
                OPEN FilesBAK$ FOR OUTPUT AS Bak%
                'make a backup copy of the files.bbs
                DO UNTIL EOF(Fbbs%)
                    LINE INPUT #Fbbs%, Record$
                    PRINT #Bak%, Record$
                LOOP
                CLOSE Fbbs%, Bak%
            END IF
        END IF
      
      'Remove some from the Files.bbs
        Bak% = FREEFILE
        OPEN FilesBAK$ FOR INPUT AS Bak%
        Fbbs% = FREEFILE
        OPEN FilesBBS$ FOR OUTPUT AS Fbbs%
        MissingFile% = False
        DO UNTIL EOF(Bak%)
            DO UNTIL EOF(Bak%)
                LINE INPUT #Bak%, Record$
                P% = INSTR(Record$, ".")
                IF P% THEN
                    IF LEFT$(Record$, 1) <> " " AND P% < 10 THEN
                        BBSFileName$ = LEFT$(Record$, P% + 3)
                        IF NOT Exist%(Path$ + BBSFileName$) THEN
                            PRINT Dt$; TIME$; " RJUT Removing: "; BBSFileName$
                            IF OutputFile% THEN
                                PRINT #OutP%, Dt$; TIME$; " RJUT Removing: "; Record$
                            END IF
                        ELSE
                            PRINT #Fbbs%, Record$
                        END IF
                    END IF
                ELSE
                    PRINT #Fbbs%, Record$
                    EXIT DO
                END IF
            LOOP
        LOOP
        CLOSE Fbbs%
        CLOSE Bak%
    ELSE
        PRINT Dt$; TIME$; " RJUT "; FilesBBS$; " not found."
        IF OutputFile% THEN
            PRINT #OutP%, Dt$; TIME$; " RJUT "; FilesBBS$; " not found."
        END IF

    END IF
    RETURN
  
Bomb:
    PRINT Dt$; TIME$; " RJUT Program failed!"
    END

    FUNCTION CurrentDate$ STATIC
        Dt$ = DATE$
        Mnth$ = LEFT$(Dt$, 2)
        SELECT CASE Mnth$
        CASE IS = "01"
            Month$ = "Jan"
        CASE IS = "02"
            Month$ = "Feb"
        CASE IS = "03"
            Month$ = "Mar"
        CASE IS = "04"
            Month$ = "Apr"
        CASE IS = "05"
            Month$ = "May"
        CASE IS = "06"
            Month$ = "Jun"
        CASE IS = "07"
            Month$ = "Jul"
        CASE IS = "08"
            Month$ = "Aug"
        CASE IS = "09"
            Month$ = "Sep"
        CASE IS = "10"
            Month$ = "Oct"
        CASE IS = "11"
            Month$ = "Nov"
        CASE IS = "12"
            Month$ = "Dec"
        END SELECT
        CurrentDate$ = "  " + MID$(Dt$, 4, 2) + " " + Month$ + " "
      
    END FUNCTION

    SUB Help
        CLS
        Temp$ = "RJ's Files.bbs Listed Files But Missing in Directory - " + Version
        PRINT TAB(40 - LEN(Temp$) / 2); Temp$
        PRINT "                                 by R.J.(Bob) Ross"
        PRINT "                    SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT STRING$(78, 196)
        PRINT "  Purpose:  To identify files listed in Files.bbs files that are not found"
        PRINT "            in the directory where the Files.bbs file resides and to remove"
        PRINT "            the filenames and descriptions from the appropriate Files.bbs"
        PRINT "            file(s)."
        PRINT STRING$(78, 196)
        PRINT " Switches:"
        PRINT "            -CDrive:\Path\Cfg.cfg"
        PRINT "                     or"
        PRINT "            -FDrive:\Path\files.bbs"
        PRINT
        PRINT "            -ODrive:\Path\Output.log"
        PRINT "              [Optional] - creates an output log of"
        PRINT "                           the program activity."
    END SUB

    SUB ParseCmdLine (Switch$, Work$, ReturnCode%)
      
        CmdLine$ = UCASE$(COMMAND$)
        ReturnCode% = False
      
        P% = INSTR(CmdLine$, Switch$)
        IF P% THEN
            Temp$ = MID$(CmdLine$, P% + 2)
            P% = INSTR(Temp$, " ")
            IF P% THEN
                Work$ = LEFT$(Temp$, P% - 1)
            ELSE
                Work$ = Temp$
            END IF
            ReturnCode% = True
        END IF
      
    END SUB

