    '*********************************************************************
    '**  Program Name:  RJMKCFG                                         **
    '**  Date Started:  March 26th, 1995                                **
    '**       Version:  1.00 completed March 26th, 1995                 **
    '** Last compiled:  March 27th, 1995                                **
    '**                                                                 **
    '**       Purpose:  To read the Maximus Area.dat file and produce   **
    '**                 AreaFilesBBS configuration file entries         **
    '**                 suitable for use with RJ utilities config file. **
    '**                                                                 **
    '**      Languare:  Microsoft QuickBASIC 4.5                        **
    '**     Libraries:  Crescent Software QuickPak Professional         **
    '**                 Creacent Software P.D.Q.                        **
    '*********************************************************************
   
    DEFINT A-Z
    DECLARE FUNCTION Exist% (Filename$)
    DECLARE SUB Help ()
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION CurrentDate$ ()
    DECLARE SUB ParseCmdLine (Switch$, Work$, ReturnCode%)

    CONST Version = "RJMKCFG Version 1.00"
    CONST False = 0
    CONST True = NOT False

    IF COMMAND$ = "" THEN
        CALL Help
        END
    END IF

    CLS
    Dt$ = CurrentDate$
    PRINT
    PRINT Dt$; TIME$; " RJUT Begin, "; Version

    CALL ParseCmdLine("-I", AreaDat$, AreaDat%)
    CALL ParseCmdLine("-O", OutPutTbl$, OutPutTbl%)

    IF NOT OutPutTbl% THEN
        PRINT Dt$; TIME$; " RJUT No output file specified on Cmd Line (-O)"
        PRINT Dt$; TIME$; " RJUT End RJMKCFG"
        END
    END IF

    IF Exist%(AreaDat$) THEN
        OPEN AreaDat$ FOR BINARY ACCESS READ AS #1
        OPEN OutPutTbl$ FOR OUTPUT AS #2
        PRINT Dt$; TIME$; " RJUT Opening: "; AreaDat$
        PRINT Dt$; TIME$; " RJUT Opening: "; OutPutTbl$
      
        NxtRecord& = 0
      'Get the Record Length
      '---------------------
        SEEK 1, 5
        GET 1, , Length%
      'First Record
      '------------
        PRINT Dt$; TIME$; " RJUT Reading: "; AreaDat$
        PRINT Dt$; TIME$; " RJUT Writing: "; OutPutTbl$
        SEEK 1, 399
        FileAreaPath$ = INPUT$(80, 1)
        IF LEFT$(FileAreaPath$, 1) = CHR$(0) THEN
          'Forget it
        ELSE
            FileAreaPath$ = QPTrim$(FileAreaPath$)
            SEEK 1, 639
            AreaDatFilesBBS$ = INPUT$(80, 1)
            IF LEFT$(AreaDatFilesBBS$, 1) = CHR$(0) THEN
                PRINT #2, "AreaFilesBBS          "; FileAreaPath$; "Files.bbs"
            ELSE
                AreaDatFilesBBS$ = QPTrim$(AreaDatFilesBBS$)
                PRINT #2, "AreaFilesBBS          "; AreaDatFilesBBS$
            END IF
        END IF
      'All Remaining Records
      '---------------------
        DO UNTIL EOF(1)
            ctr% = ctr% + 1
            NxtRecord& = NxtRecord& + Length%
            SEEK 1, NxtRecord& + 399
            FileAreaPath$ = INPUT$(80, 1)
            IF LEFT$(FileAreaPath$, 1) = CHR$(0) THEN
              'Forget it
            ELSE
                FileAreaPath$ = QPTrim$(FileAreaPath$)
                SEEK 1, NxtRecord& + 639
                AreaDatFilesBBS$ = INPUT$(80, 1)
                IF LEFT$(AreaDatFilesBBS$, 1) = CHR$(0) THEN
                    PRINT #2, "AreaFilesBBS          "; FileAreaPath$; "Files.bbs"
                ELSE
                    AreaDatFilesBBS$ = QPTrim$(AreaDatFilesBBS$)
                    IF AreaDatFilesBBS$ > "" THEN
                        PRINT #2, "AreaFilesBBS          "; AreaDatFilesBBS$
                    END IF
                END IF
            END IF
        LOOP
        CLOSE 1, 2
        PRINT Dt$; TIME$; " RJUT Finished: "; OutPutTbl$
        PRINT Dt$; TIME$; " RJUT End RJMKCFG"
    ELSE
        BEEP
        PRINT Dt$; TIME$; " RJUT File: "; AreaDat$; " NOT found!"
        PRINT Dt$; TIME$; " RJUT End RJMKCFG"
    END IF

    FUNCTION CurrentDate$ STATIC
        Dt$ = DATE$
        Mnth$ = LEFT$(Dt$, 2)
        SELECT CASE Mnth$
        CASE IS = "01"
            Month$ = "Jan"
        CASE IS = "02"
            Month$ = "Feb"
        CASE IS = "03"
            Month$ = "Mar"
        CASE IS = "04"
            Month$ = "Apr"
        CASE IS = "05"
            Month$ = "May"
        CASE IS = "06"
            Month$ = "Jun"
        CASE IS = "07"
            Month$ = "Jul"
        CASE IS = "08"
            Month$ = "Aug"
        CASE IS = "09"
            Month$ = "Sep"
        CASE IS = "10"
            Month$ = "Oct"
        CASE IS = "11"
            Month$ = "Nov"
        CASE IS = "12"
            Month$ = "Dec"
        END SELECT
        CurrentDate$ = " " + MID$(Dt$, 4, 2) + " " + Month$ + " "
      
    END FUNCTION

SUB Help
CLS
PRINT
Temp$ = "RJ's Make Configuration Entries - " + Version
Temp2$ = "by R.J. (Bob) Ross"
Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
PRINT TAB(40 - LEN(Temp$) \ 2); Temp$
PRINT TAB(40 - LEN(Temp2$) \ 2); Temp2$
PRINT TAB(40 - LEN(Temp3$) \ 2); Temp3$
PRINT STRING$(78, 196)
PRINT "  Purpose:  To read a Maximus Area.dat file and produce a text file containing"
PRINT "            AreaFilesBBS entries suitable to paste into a configuration file"
PRINT "            which can be edited and used by RJ utility programs."
PRINT STRING$(78, 196)
PRINT " Switches:"
PRINT
PRINT "            -Idrive:\path\Area.dat"
PRINT "            -Odrive:\path\Output.cfg"
PRINT
PRINT
END SUB

    SUB ParseCmdLine (Switch$, Work$, ReturnCode%)
      
        CmdLine$ = UCASE$(COMMAND$)
        ReturnCode% = False
      
        P% = INSTR(CmdLine$, Switch$)
        IF P% THEN
            Temp$ = MID$(CmdLine$, P% + 2)
            P% = INSTR(Temp$, " ")
            IF P% THEN
                Work$ = LEFT$(Temp$, P% - 1)
            ELSE
                Work$ = Temp$
            END IF
            ReturnCode% = True
        END IF
      
    END SUB

