  '**************************************************************************
  '**  Program Name:  RJMTL - Make Tick Log                                **
  '**  Date Started:  December 15th, 1994                                  **
  '**       Version:  .01 Beta - completed December 18th, 1994             **
  '**                 1.00     - completed February 10th, 1995             **
  '**                 Last compiled - March 9th, 1995                      **
  '**                                                                      **
  '**       Purpose:  To make a fake Tick logfile that can be processed    **
  '**                 by program RJFA (File Arrival) when the normal TIC   **
  '**                 program is not used to process *.TIC files.          **
  '**                 Note:  In order to successfully log the *.TIC files, **
  '**                 RJMTL must be run before tossing with Seal or"       **
  '**                 other compatable Tic processors.                     **
  '**                                                                      **
  '**      Language:  Microsoft QuickBASIC Version 4.5                     **
  '**     Libraries:  Crescent Software Inc - QuickPak Professional        **
  '**                 Crescent Software Inc - P.D.Q.                       **
  '**************************************************************************
  
    DEFINT A-Z
    DECLARE FUNCTION Exist% (Filename$)
    DECLARE FUNCTION Fcount% (Filespec$)
    DECLARE SUB Help ()
    DECLARE FUNCTION MonthName$ (Month%)
    DECLARE SUB ParseCmdLine (Switch$, Work$, ReturnCode%)
    DECLARE FUNCTION QPValI% (Value$)
  
    CONST False = 0
    CONST True = NOT False
    CONST Title = "Program RJMTL (Make Tick Log) by R.J.(Bob) Ross"
    CONST Version = "Version 1.00"
  
    IF COMMAND$ = "" THEN
        CALL Help
        END
    END IF

   CLS
   PRINT Title; " - "; Version
   PRINT

  '-L - Tic File Path
    CALL ParseCmdLine("-L", TICFilePath$, TICFPath%)
    IF TICFPath% THEN
       IF RIGHT$(TICFilePath$, 1) <> "\" THEN
           TICFilePath$ = TICFilePath$ + "\"
       END IF
    END IF
  '-O - Output TICK log file
    CALL ParseCmdLine("-O", TICLogFile$, TICLFile%)
  '-C - Tic.cfg file
    CALL ParseCmdLine("-C", TICCfgFile$, TICCFile%)

    IF NOT TICFPath% THEN
       PRINT "No Tic file path given on command line (switch -L)"
       END
       ELSEIF NOT TICLFile% THEN
       PRINT "No Output file given on command line (switch -O)"
       END
       ELSEIF NOT TICCFile% THEN
       PRINT "No Tic.Cfg file given on command line (switch -C)"
   END IF

    FileN$ = "*.tic"
    Spec$ = TICFilePath$ + FileN$
    Day$ = MID$(DATE$, 4, 2)
    Count = Fcount%(Spec$)

   'Start the fake tic logfile
    OPEN TICLogFile$ FOR APPEND AS #2
    GOSUB LogLine
    PRINT #2, "Program RJMTL by R.J. (Bob) Ross faking TICK log output."
    GOSUB LogLine
    PRINT #2, STRING$(56, 196)

  'Main Program loop
    IF Count THEN
        IF Exist%(TICCfgFile$) THEN
            OPEN TICCfgFile$ FOR INPUT AS #3
            ELSE
            PRINT "Tic configuration file "; TICCfgFile$; " NOT found!"
            GOSUB LogLine
            PRINT #2, "Tic configuration file "; TICCfgFile$; " NOT found!"
            CLOSE 2
            END
        END IF

        DIM Filename$(0 TO Count)
        FOR X% = 1 TO Count
            Filename$(X%) = SPACE$(12)
        NEXT
      
        Filename$(0) = Spec$
        CALL ReadFile(BYVAL VARPTR(Filename$(0)))
      
        FOR X% = 1 TO Count
            OPEN TICFilePath$ + Filename$(X%) FOR INPUT AS #1
            LINE INPUT #1, Area$
            LINE INPUT #1, file$
            LINE INPUT #1, Desc$
            Desc$ = RTRIM$(Desc$)
            DO UNTIL EOF(1)
                LINE INPUT #1, Record$
                    IF UCASE$(LEFT$(Record$, 4)) = "DESC" THEN
                        Desc$ = Desc$ + RTRIM$(MID$(Record$, 5))
                    END IF
            LOOP
            P% = INSTR(Area$, " ")
            IF P% THEN
                Area$ = UCASE$(LTRIM$(MID$(Area$, P%)))
                SEEK 3, 1
                DO UNTIL EOF(3)
                    LINE INPUT #3, Record$
                    Record$ = LTRIM$(UCASE$(Record$))
                    IF LEFT$(Record$, 4) = "AREA" THEN
                        P% = INSTR(Record$, " ")
                        IF P% THEN
                            Temp$ = LTRIM$(MID$(Record$, P%))
                            P% = INSTR(Temp$, " ")
                            IF P% THEN
                                TicCfgPath$ = LEFT$(Temp$, P% - 1)
                                IF RIGHT$(TicCfgPath$, 1) <> "\" THEN TicCfgPath$ = TicCfgPath$ + "\"
                                TicCfgArea$ = LTRIM$(MID$(Temp$, P%))
                                IF Area$ = TicCfgArea$ THEN
                                  
                                    GOSUB LogLine
                                    PRINT #2, Filename$(X%)
                                  
                                    PRINT "Logging: "; Filename$(X%)
                                  
                                    GOSUB LogLine
                                    PRINT #2, "Moving - not really but will be to "; TicCfgPath$; MID$(file$, 6)
                                  
                                    GOSUB LogLine
                                    PRINT #2, "AREA: "; Area$
                                  
                                    GOSUB LogLine
                                    PRINT #2, MID$(Desc$, 6)

                                    GOSUB LogLine
                                    PRINT #2, STRING$(56, 196)
                                END IF
                            END IF
                        END IF
                    END IF
                LOOP
            END IF
            CLOSE 1
        NEXT
        PRINT
        PRINT "Output Appended to: "; TICLogFile$
        ELSE
        PRINT "No Tic files found in "; TICFilePath$
        GOSUB LogLine
        PRINT #2, "No Tic files found in "; TICFilePath$
    END IF
    CLOSE 2
    END      'Finished
  
LogLine:
    PRINT #2, "  "; Day$; " "; MonthName$(QPValI%(LEFT$(DATE$, 2))); " "; TIME$; " TICK ";
    RETURN

    SUB Help
        CLS
        Temp1$ = "Program RJMTL (Make Tick Log) - " + Version
        Temp2$ = "By R.J.(Bob) Ross"
        Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT TAB(40 - LEN(Temp1$) / 2); Temp1$
        PRINT TAB(40 - LEN(Temp2$) / 2); Temp2$
        PRINT TAB(40 - LEN(Temp3$) / 2); Temp3$
        PRINT STRING$(78, 196)
        PRINT "Purpose:  To make a fake Tick logfile that can be processed by program"
        PRINT "          RJFA (File Arrival) when the normal TIC program is not used"
        PRINT "          to process *.TIC files.  Note:  In order to successfully log"
        PRINT "          the TIC files, RJMTL must be run before tossing with Seal or"
        PRINT "          other compatable Tic processors."
        PRINT STRING$(78, 196)
        PRINT
        PRINT "Switches: -O  Output Logfile"
        PRINT "          -C  your Tic.cfg file"
        PRINT "          -L  Tic File Path (Where the *.tic files are.)"
        PRINT
        PRINT " Example: -Odrive:\path\Output.Log"
        PRINT "          -Cdrive:\path\Tic.cfg"
        PRINT "          -Ldrive:\path\"
        PRINT : PRINT


    END SUB

SUB ParseCmdLine (Switch$, Work$, ReturnCode%)

    CmdLine$ = UCASE$(COMMAND$)
    ReturnCode% = False

    P% = INSTR(CmdLine$, Switch$)
    IF P% THEN
        Temp$ = MID$(CmdLine$, P% + 2)
        P% = INSTR(Temp$, " ")
        IF P% THEN
            Work$ = LEFT$(Temp$, P% - 1)
        ELSE
            Work$ = Temp$
        END IF
        ReturnCode% = True
    END IF

END SUB

