  '***********************************************************************
  '** Program Name:  RJORPH - Orphaned Files Program                    **
  '**       Author:  R.J. (Bob) Ross                                    **
  '**                SysOp RJ's Byteline BBS - FidoNet 1:134/75         **
  '** Date Started:  February 25th, 1995                                **
  '**      Version:  1.00 completed March 6th, 1995                     **
  '**                Last compiled - Marth 9th, 1995                    **
  '**                                                                   **
  '**      Purpose:  To identify those files in directories that are    **
  '**                not listed in the files.bbs file(s).               **
  '**                                                                   **
  '**     Language:  Microsoft QuickBASIC 4.5                           **
  '**    Libraries:  Crescent Software QuickPak Professional and P.D.Q. **
  '**                                                                   **
  '**         Note:  Compile using the /ah switch                       **
  '***********************************************************************
  
    DEFINT A-Z
  
    DECLARE FUNCTION Exist% (Filename$)
    DECLARE FUNCTION FCount% (FileSpec$)
    DECLARE FUNCTION GetDrive%
    DECLARE FUNCTION GetDir$ (Drive$)
    DECLARE SUB Help ()
    DECLARE FUNCTION QPTrim$ (Work$)
    DECLARE FUNCTION QInstrB% (StartPos%, Source$, Search$)
  
    CLS

    CONST False = 0
    CONST True = NOT False
    CONST Version = "RJORPH Version 1.00"
    ConfigFile% = False
    Orphan% = False

    CmdLine$ = UCASE$(COMMAND$)
  
  'Look for a Config file
    P% = INSTR(CmdLine$, "-C")
    IF P% THEN
        ConfigFile$ = RTRIM$(MID$(CmdLine$, 3))
        ConfigFile% = True
        IF Exist%(ConfigFile$) THEN
            Cfg% = FREEFILE
            OPEN ConfigFile$ FOR INPUT AS #Cfg%
            IF LOF(Cfg%) = 0 THEN
                CLOSE Cfg%
                Row% = Row% + 1
                LOCATE Row%
                PRINT #255, "REM - "; ConfigFile$; "is empty!"
                PRINT "REM - "; ConfigFile$; "is empty!"
                END
            END IF
        ELSE
            BEEP
            LOCATE 24
            PRINT #255, "REM - Configfile "; ConfigFile$; "; NOT found!; "
            PRINT "REM - Configfile "; ConfigFile$; "; NOT found!"
            END
        END IF
      'No command line option given - display help screen.
    ELSEIF CmdLine$ = "" THEN
        CALL Help
        END
    ELSE
      'Files.bbs file name was given on the command lane.
        FilesBBS$ = LTRIM$(CmdLine$)
        ConfigFile% = False
        FilesBBS% = True
    END IF
    CLOSE Cfg%

  'DOS Re-direct
    OPEN "CON" FOR OUTPUT AS #255
    LOCATE 24
    PRINT #255, "REM - "; Version
    PRINT "REM - "; Version

    IF FilesBBS% THEN
        IF Exist%(FilesBBS$) THEN
            P% = QInstrB%(-1, FilesBBS$, "\")
            IF P% THEN
                Spec$ = LEFT$(FilesBBS$, P%) + "*.*"
            ELSE
                Drive% = GetDrive%
                Drive$ = CHR$(GetDrive%)
                Directory$ = GetDir$(Drive$)
                Spec$ = Drive$ + ":" + Directory$
                IF RIGHT$(Spec$, 1) = "\" THEN
                    Spec$ = Spec$ + "*.*"
                ELSE
                    Spec$ = Spec$ + "\*.*"
                END IF
            END IF
            GOSUB CheckForOrphans
            CLOSE Fbbs%
            END
        ELSE
            BEEP
            LOCATE 24
            PRINT #255, "REM -   File not found: "; FilesBBS$
            PRINT "REM  -  File not found: "; FilesBBS$
            END
        END IF
    ELSEIF ConfigFile% THEN
        OPEN ConfigFile$ FOR INPUT AS #Cfg%
        DO UNTIL EOF(Cfg%)
            DO UNTIL EOF(Cfg%)
                LINE INPUT #Cfg%, ConfigRec$
                ConfigRec$ = UCASE$(LTRIM$(ConfigRec$))
                IF LEFT$(ConfigRec$, 12) = "AREAFILESBBS" THEN
                    FilesBBS$ = QPTrim$(MID$(ConfigRec$, 13))
                    P% = QInstrB%(-1, FilesBBS$, "\")
                    IF P% THEN
                        Spec$ = LEFT$(FilesBBS$, P%) + "*.*"
                    END IF
                ELSE
                    EXIT DO
                END IF
                IF Exist%(FilesBBS$) THEN
                    GOSUB CheckForOrphans
                    CLOSE Fbbs%
                ELSE
                    BEEP
                    LOCATE 24
                    PRINT #255, "REM     File not found: "; FilesBBS$
                    PRINT "REM     File not found: "; FilesBBS$
                    EXIT DO
                END IF
            LOOP
        LOOP
    END IF
    END
  
CheckForOrphans:
    Temp$ = ""
    Temp2$ = ""
    Count = FCount%(Spec$)
    REDIM Filename(1 TO Count) AS STRING * 12
    CALL ReadFileT(Spec$, BYVAL VARSEG(Filename(1)), BYVAL VARPTR(Filename(1)))

    LOCATE 24
    Fbbs% = FREEFILE
    OPEN FilesBBS$ FOR INPUT AS Fbbs%
    PRINT #255, "REM - Checking: "; FilesBBS$
    PRINT #255,
    PRINT
    PRINT "REM - Checking: "; FilesBBS$
    PRINT
    FOR X% = 1 TO Count
        DO UNTIL EOF(Fbbs%)
            DO UNTIL EOF(Fbbs%)
                LINE INPUT #Fbbs%, Record$
                P% = INSTR(Record$, ".")
                IF P% THEN
                    IF LEFT$(Record$, 1) <> " " AND P% < 10 THEN
                    END IF
                ELSE
                    EXIT DO
                END IF
                Temp$ = QPTrim$(Filename(X%))
                LN% = LEN(Temp$)
                Temp2$ = LEFT$(Record$, LN%)
                IF Temp$ = Temp2$ THEN
                    Filename(X%) = "BLANK......."
                ELSE
                  'Do nothing
                END IF
            LOOP
        LOOP
        SEEK Fbbs%, 1
    NEXT
    CLOSE Fbbs%
    FOR X% = 1 TO Count
        IF Filename(X%) = "BLANK......." OR LEFT$(Filename(X%), 6) = "FILES." THEN
          'do nothing
        ELSE
            LN% = LEN(Spec$)
            PRINT #255, "      Del "; LEFT$(Spec$, LN% - 3); Filename(X%)
            PRINT "      Del "; LEFT$(Spec$, LN% - 3); Filename(X%)
        END IF
      
    NEXT
    LOCATE 24
    PRINT #255,
    RETURN

    SUB Help
    CLS
        Temp$ = "RJ's Orphaned Files Program - " + Version
        Temp2$ = "by R.J. (Bob) Ross"
        Temp3$ = "SysOp - RJ's Byteline BBS - FidoNet 1:134/75"
        PRINT TAB(40 - LEN(Temp$) \ 2); Temp$
        PRINT TAB(40 - LEN(Temp2$) \ 2); Temp2$
        PRINT TAB(40 - LEN(Temp3$) \ 2); Temp3$
        PRINT STRING$(78, 196)
        PRINT "  Purpose:  To identify files not listed in a Files.bbs file or Files.bbs"
        PRINT "            files.  Excludes listing filenames named FILES. with any "
        PRINT "            extension.  Listing conforms to DOS batch file conventions so"
        PRINT "            that the listing output may be redirected to a file using DOS"
        PRINT "            redirection."
        PRINT STRING$(78, 196)
        PRINT " Switches:"
        PRINT "            -cDrive:\Path\Sample.cfg"
        PRINT "                      or"
        PRINT "            Drive:\Path\Files.bbs"
        PRINT
        PRINT "            Note:  Use DOS redirection if you want the output to a file."
        PRINT "                   Example:  RJORPH -cc:\RJUtils\Sample.cfg > e:\RJ.BAT"
        PRINT "                                                            ^"
        PRINT
        PRINT

    END SUB

